commit 52bae235b716a3c8d629ddf1306178568c69833f
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jun 22 16:14:12 2023 +0200

    NEWS and version update

commit 1499a335f6f44a0fd85365e404c2a11842d7f75c
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jun 22 16:07:28 2023 +0200

    Filter: Fixed segfault when a case option had an empty block
    
    Thanks to Kobayashi_Bairuo <noc@tohunet.com> for reporting.

commit ac7341a18146bf0f0b2c60477c4292a9cd428a87
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri May 19 01:02:57 2023 +0200

    BGP: Fix role check when no capability option is present
    
    When an OPEN message without capability options was parsed, the remote
    role field was not initialized with the proper (non-zero) default value,
    so it was interpreted as if 'provider' was announced.
    
    Thanks to Mikhail Grishin for the bugreport.

commit ca0f239c72486cebfe171e335e3b8a86f5999714
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Apr 21 20:24:43 2023 +0200

    NEWS and version update

commit 1a1e13cc2fc2df82e2319b7beeb18bb8eb92fbd2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Apr 21 19:29:17 2023 +0200

    Filter: Disable some trie formatting tests
    
    Trie formatting works slightly different with 4-way tries than with
    16-way ones, so these tests generated false error. Block them for now.

commit 52450bc96dcedbc30cbb2e282c6706ad9e5e5774
Merge: d61505b0 f3b599af
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Apr 21 04:47:55 2023 +0200

    Merge branch 'bmp'

commit f3b599afe5bde0c7f232421743041b305bb8afa7
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Apr 21 04:42:13 2023 +0200

    BMP: Add some basic documentation

commit d61505b039bf0aa6697e28b2a4e07907c89ba1fb
Author: Luiz Amaral <email@luiz.eng.br>
Date:   Fri Apr 21 01:37:30 2023 +0200

    BSD: IPv4 over IPv6 nexthop support on FreeBSD
    
    The support for IPv4 routes with IPv6 nexthops was implemented in FreeBSD
    13.1, this patch allows to import and export such routes from/to kernel.
    
    Minor change from committer.

commit 335409248ea932e93ce4361564b8e92d0b83b071
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Apr 20 19:33:00 2023 +0200

    Linpool: Fix lp_restore()
    
    When lp_save() is called on an empty linpool, then some allocation is
    done, then lp_restore() is called, the linpool is restored but the used
    chunks are inaccessible. Fix it.

commit 976dec048a25fc22efb07fa73be1316c95046420
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Apr 20 17:14:45 2023 +0200

    BMP: Silence some log messages
    
    Hooks called from BGP to BMP should not log warning when BMP is not
    connected, that is not an error (and we do not want to flood logs with
    a ton of messages).
    
    Blocked sk_send() should not log warning, that is expected situation.
    Error during sk_send() is handled in error hook anyway.

commit 2c7d2141ac86b0d482d3221447d1ad920c557108
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Apr 20 16:13:58 2023 +0200

    BMP: Fix connection management
    
    Replace broken TCP connection management with a simple state machine.
    Handle failed attempts properly with a timeout, detect and handle TCP
    connection close and try to reconnect after that. Remove useless
    'station_connected' flag.
    
    Keep open messages saved even after the BMP session establishment,
    so they can be used after BMP session flaps.
    
    Use proper log messages for session events.

commit 010df43519b12e83b0ff2cba9e344cba698586bb
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Apr 18 18:57:54 2023 +0200

    BMP: Fix reconfiguration
    
    It is not supported, but at least it must update internal config
    pointer to not keep old one.

commit 02164814b49a3385caae0ea10aa042487c6002d2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Apr 18 17:21:13 2023 +0200

    BMP: Allow build without BMP and disable BMP build by default
    
    It has still several important issues to be enabled by default.

commit fbeef4b74dfd73fb86b1ccc5dd1c6109e3c21624
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Apr 18 15:13:24 2023 +0200

    BMP: Move initialization to bmp_start()
    
    That fixes BMP socket allocation from an invalid pool.

commit 04e3a76c9417d35acdfba96a11327e99000fe47d
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Apr 18 15:09:21 2023 +0200

    BMP: Fix missing template
    
    It is mandatory for protocol.

commit 3925e65938e7c778f650d62a721dec7a66c19ab3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Apr 15 18:32:47 2021 +0200

    BMP: Add some missing bmp_buffer_free() calls
    
    They were inadvertently removed during recent code refactoring.
    
    Thanks to Dawid Macek for the bugreport and patch.

commit 4d56b70dc5facdf4b839b76bf80c93856bcbb121
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 29 04:43:04 2021 +0200

    BMP: Remove duplicate functions for update encoding
    
    Use existing BGP functions also for BMP update encoding.

commit 568fd666136fcf7a37eb445d18b478b6464536c4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 28 16:41:53 2021 +0200

    BMP: Integrate bmp_conn to bmp_proto
    
    There is only one socket per BMP instance, no need to have separate
    struct (like in BGP).

commit 4adebdf198d6e2ca1afcd7cb9bfac81725e7b24e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 28 15:36:59 2021 +0200

    BMP: Minor cleanups
    
    Remove redundant 'disable' option, simplify IP address serialization,
    and remove useless macros.

commit a995ed43860eb139a13456242aa12486179fac86
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 28 15:13:23 2021 +0200

    BMP: Do not use global instance ptr internally
    
    Use local variable to refence relevant instance instead of using global
    instance ptr. Also, use 'p' variable instead of 'bmp' so we can use
    common macros like TRACE().

commit ad16e351773f4b606dd8b4dbbe77c2cb35bf5133
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 28 04:30:11 2021 +0200

    BMP: Remove superfluous error handling
    
    Most error handling code was was for cases that cannot happen,
    or they would be code bugs (and should use ASSERT()). Keep error
    handling for just for I/O errors, like in rest of BIRD.

commit a848dad40aa618e5e24417e4ef46b62c860de679
Author: Pawel Maslanka <pmaslank@akamai.com>
Date:   Mon Mar 29 22:45:21 2021 +0200

    BMP protocol support
    
    Initial implementation of a basic subset of the BMP (BGP Monitoring
    Protocol, RFC 7854) from Akamai team. Submitted for further review
    and improvement.

commit 9e44ace3928a19560058dc713fcbff3a8bad3b3c
Author: Trisha Biswas <tbiswas@fastly.com>
Date:   Fri Apr 14 04:28:37 2023 +0200

    BGP: Add 'allow bgp_med' option for EBGP sessions
    
    This option allows to treat bgp_med as regular transitive attribute
    on EBGP sessions (without hacks in filters).
    
    Minor changes from committer.

commit dc139fb6438f0864e83a9dc71e7c212c5acaf3ef
Author: Jakub Ružička <jakub.ruzicka@nic.cz>
Date:   Thu Apr 13 20:06:55 2023 +0200

    Increase tests timeout
    
    Tests may take longer than 5 s to complete on slow/virtual machines.

commit f881b98d9b48e7a60c46dffc29009a86dac63233
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Apr 4 05:20:49 2023 +0200

    BGP: Fix bgp_med handling
    
    Missing translation from BGP attribute ID to eattr ID in bgp_unset_attr()
    broke automatic removal of bgp_med during export to EBGP peers.
    
    Thanks to Edward Sun for the bugreport.

commit 231c63851e3a56201dd02abfbf3fce47a80f8ae0
Author: Johannes Moos <johannes.moos@de-cix.net>
Date:   Sat Mar 18 15:33:48 2023 +0100

    Add missing references to "show route in" in the cli-help and doc.
    
    The feature of showing all prefixes inside the given one has been added
    in v2.0.9 but not well documented. Fixing it by this update.
    
    Text in doc and commit message added by commiter.

commit 2b712554d18dfb09274c003315a573f8578270ec
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Mar 16 19:23:19 2023 +0100

    BGP: Free bind applies also to outbound connections
    
    Even though the free bind option is primarily meant to alleviate problems
    with addresses assigned too late, it's also possible to use BIRD with AnyIP
    configuration, assigning whole ranges to the machine. Therefore free bind
    allows also to create an outbound connection from specific address even though
    such address is not assigned.

commit 6b38285f587be9d4b128ae816bc25cb338f7f07c
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Mar 6 11:57:40 2023 +0100

    Net: Replace runtime checks with STATIC_ASSERT()

commit 0f679438f36d8c2a31dfe490007e983b085caef6
Author: Petr Vaněk <arkamar@atlas.cz>
Date:   Mon Mar 6 11:19:30 2023 +0100

    Printf test suite fails on systems with musl libc because tests for "%m"
    and "%M" formats expect "Input/output error" message but musl returns
    "I/O error". Proposed change compares the printf output with string
    returned from strerror function for EIO constant.
    
    See-also: https://bugs.gentoo.org/836713
    
    Minor change from committer.

commit 2f080b543296aa2fa18bf7451b5174d942b0a952
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Feb 16 14:22:23 2023 +0100

    Config: Dropping filter instruction trees after linearization

commit 6c058ae40cf33d6d36c0159d0c40c9925c8e60d8
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 22 14:45:20 2023 +0100

    Linpool flush drops all the allocated pages but one
    
    When a linpool is used to allocate a one-off big load of memory, it
    makes no sense to keep that amount of memory for future use inside the
    linpool. Contrary to previous implementations where the memory was
    directly free()d, we now use the page allocator which has an internal
    cache which keeps the released pages for us and subsequent allocations
    simply get these released pages back.
    
    And even if the page cleanup routine kicks in inbetween, the pages get
    only madvise()d, not munmap()ed so performance aspects are negligible.
    
    This may fix some memory usage peaks in extreme cases.

commit 913ec57f27b06845e3698e8ea08821d39b9575cf
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Feb 19 15:35:07 2023 +0100

    BGP: Update RFC references

commit 501256cfc8c1fb5e225c81c4d3300b7c219baf63
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Feb 19 15:34:43 2023 +0100

    Babel: Update RFC references

commit eefb29679957fed3724e6d5db2ddf112e28f646f
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Feb 19 03:59:10 2023 +0100

    Conf: Fix too early free of old configuration
    
    The change 371eb49043d225d2bab8149187b813a14b4b86d2 introduced early free
    of old_config. Unfortunately, it did not properly check whether it is not
    still in use (blocked by obstacle during reconfiguration). Fix that.
    
    It also means that we still could have a short peak when three configs
    are in use (when a new reconfig is requeste while the previous one is
    still active).

commit ee919658948772105d0bd3b4535ba28883484f2c
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Tue Feb 14 18:18:32 2023 +0100

    Babel: Keep separate auth PC counters for unicast and multicast
    
    The babel protocol normally sends all its messages as multicast packets,
    but the protocol specification allows most messages to be sent as either
    unicast or multicast, and the two can be mixed freely. In particular, the
    babeld implementation can be configured to unicast updates to all peers
    instead of sending them as unicast.
    
    Daniel discovered that this can cause problems with the packet counter
    checks in the MAC extension due to packet reordering. This happens on WiFi
    networks where clients have power save enabled (which is quite common in
    infrastructure networks): in this case, the access point will buffer all
    multicast traffic and only send it out along with its beacons, leading to a
    maximum buffering in default Linux-based access point configuration of up
    to 200 ms.
    
    This means that a Babel sender that mixes unicast and multicast messages
    can have the unicast messages overtake the multicast messages because of
    this buffering; when authentication is enabled, this causes the receiver to
    discard the multicast message when it does arrive because it now has a
    packet counter value less than the unicast message that arrived before it.
    Daniel observed that this happens frequently enough that Babel ceases to
    work entirely when runner over a WiFi network.
    
    The issue has been described in draft-ietf-babel-mac-relaxed, which is
    currently pending RFC publication. That also describes two mitigation
    mechanisms: Keeping separate PC counters for unicast and multicast, and
    using a reorder window for PC values. This patch implements the former as
    that is the simplest, and resolves the particular issue seen on WiFi.
    
    Thanks to Daniel Gröber for the bugreport.
    
    Minor changes from committer.

commit eecc3f02e41bcb91d463c4c1189fd56bc44e6514
Author: Andreas Rammhold <andreas@rammhold.de>
Date:   Tue Feb 14 16:17:03 2023 +0100

    Babel: Implement IPv4 via IPv6 extension (RFC 9229)
    
    The patch implements an IPv4 via IPv6 extension (RFC 9229) to the Babel
    routing protocol (RFC 8966) that allows annoncing routes to an IPv4
    prefix with an IPv6 next hop, which makes it possible for IPv4 traffic
    to flow through interfaces that have not been assigned an IPv4 address.
    
    The implementation is compatible with the current Babeld version.
    
    Thanks to Toke Høiland-Jørgensen for early review on this work.
    
    Minor changes from committer.

commit 0851fcde651301a886fefc574a4f739bf68119b9
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 3 09:12:34 2023 +0100

    Documentation: Adding roadmap as decided in January 2023

commit 0ab62f267449d6496e753625e37924357fb0aa95
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Feb 1 19:30:21 2023 +0100

    Build: Partial revert of one of previous changes
    
    There are many compatibility issues with echo -e, scratch that.

commit ba348b2029f3c51559bed0bd752c4365793f0ea9
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Feb 1 17:46:48 2023 +0100

    Build: Minor improvement to build output

commit 23f3dd5cfbe8681b4e71c8d7345bdeaafc86e077
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Feb 1 16:15:13 2023 +0100

    Nest: Minor cleanup in buildsystem
    
    There ware missing dependencies for proto-build.c generation, which
    sometimes lead to failed builds, and ignores changes in the set of
    built protocols. Fix that, and also improve formatting of proto-build.c

commit dc4c5f51f83f97100b207136ecfde8ff94e597e6
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Tue Jan 31 15:52:14 2023 +0100

    Babel: Initialise source seqno from incoming message
    
    When creating a new babel_source object we initialise the seqno to 0. The
    caller will update the source object with the right metric and seqno value,
    for both newly created and old source objects. However if we initialise the
    source object seqno to 0 that may actually turn out to be a valid (higher)
    seqno than the one in the routing table, because of seqno wrapping. In this
    case the source metric will not be set properly, which breaks feasibility
    tracking for subsequent updates.
    
    To fix this, add a new initial_seqno argument to babel_get_source() which
    is used when allocating a new object, and set that to the seqno value of
    the update we're sending.
    
    Thanks to Juliusz Chroboczek for the bugreport.

commit 96d7c4679df49b34be004177b10a99210af5f141
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Jan 30 23:49:20 2023 +0100

    Babel: Improve clarity of unfeasible update handling.
    
    Add a comment and (unnecessary) check to make correctness obvious.

commit 3e7e4a71868bc519aacc0eb785471b46fc345a5c
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Mon Jan 30 23:36:39 2023 +0100

    Babel: Fix missing modulo comparison of seqnos
    
    Juliusz noticed there were a couple of places we were doing straight
    inequality comparisons of seqnos in Babel. This is wrong because seqnos can
    wrap: so we need to use the modulo-64k comparison function for these cases
    as well.
    
    Introduce a strict-inequality version of the modulo-comparison for this
    purpose.

commit 72230d3ca37d34cafa0442c23f83121ae1fc41be
Author: Alexander Zubkov <green@qrator.net>
Date:   Mon Jan 23 14:23:00 2023 +0100

    Small fix of indenting

commit 5437104afad90f2a74ce52946f06da607d021e2b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Jan 23 02:23:19 2023 +0100

    NEWS and version update

commit 99872676df45f1a490d3d63f43081afb41477040
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jan 22 23:42:08 2023 +0100

    BFD: Improve incoming packet matching
    
    For active sessions, ignore received packets with zero local id and
    mismatched remote id. That forces a session timeout instead of an
    immediate session restart. It makes BFD sessions more resilient to
    packet spoofing.
    
    Thanks to André Grüneberg for the suggestion.

commit a82683694da23799f247b3392a00efdd342afdfc
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jan 22 18:12:04 2023 +0100

    VRF: Fix issues with reconfiguration
    
    Protocols receive if_notify() announcements that are filtered according
    to their VRF setting, but during reconfiguration, they access iface_list
    directly and forgot to check VRF setting here, which leads to all
    interfaces be addedd.
    
    Fix this issue for Babel, OSPF, RAdv and RIP protocols.
    
    Thanks to Marcel Menzel for the bugreport.

commit 3186ffe79714a48542d5ad61a94c81216b522fd0
Author: Maria Matejka <mq@ucw.cz>
Date:   Sun Jan 22 12:55:31 2023 +0100

    Added test case for switch bug fixed in e20bef69ccc4a85ef62359ee539c9db2dbe09127

commit af611f93aa5040acc606ed289a873bf1136831c2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Jan 20 15:55:47 2023 +0100

    BGP: Add received role value to role mismatch log message

commit 804916daa91834a4740edba96a43c7f0a43744b3
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Jan 18 13:40:21 2023 +0100

    Alloc: Minor cleanups
    
     - Fix THP disable on old systems
     - Failed syscalls should use die() instead of bug()
     - Our printf uses %ld for s64 instead of long

commit 6bb992cb04926895be57dc97e7d569ea15a07db1
Merge: 973aa37e 7144c9ca
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jan 18 12:33:06 2023 +0100

    Merge branch 'master' of https://gitlab.nic.cz/labs/bird

commit 973aa37e1e28a9c508fe09c008196f64cd3966fd
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jan 18 09:39:45 2023 +0100

    Fix memory pre-allocation
    
    When BIRD has no free memory mapped, it allocates several pages in
    advance just to be sure that there is some memory available if needed.
    This hysteresis tactics works quite well to reduce memory ping-ping with
    kernel.
    
    Yet it had a subtle bug: this pre-allocation didn't take a memory
    coldlist into account, therefore requesting new pages from kernel even
    in cases when there were other pages available. This led to slow memory
    bloating.
    
    To demonstrate this behavior fast enough to be seen well, you may:
      * temporarily set the values in sysdep/unix/alloc.c as follows to
        exacerbate the issue:
          #define KEEP_PAGES_MAIN_MAX    4096
          #define KEEP_PAGES_MAIN_MIN    1000
          #define CLEANUP_PAGES_BULK     4096
      * create a config file with several millions of static routes
      * periodically disable all static protocols and then reload config
      * log memory consumption
    
    This should give you a steady growth rate of about 16kB per cycle. If
    you don't set the values this high, the issue happens much more slowly,
    yet after 14 days of running, you are going to see an OOM kill.
    
    After this fix, pre-allocation uses the memory coldlist to get some hot
    pages and the same test as described here gets you a perfectly stable
    constant memory consumption (after some initial wobbling).
    
    Thanks to NIX-CZ for reporting and helping to investigate this issue.
    Thanks to Santiago for finding the cause in the code.

commit 7144c9ca46f092da33a4e051bbce8f973a3bd8c4
Author: Radu Carpa <radu.carpa@cern.ch>
Date:   Tue Jan 17 18:13:37 2023 +0100

    Filter: Allow setting the 'onlink' route attribute in filters
    
    Add static route attribute to set onlink flag for route next hop. Can be
    used to build a dynamically routed IP-in-IP overlay network. Usage:
    
         ifname = "tunl0";
         onlink = true;
         gw = bgp_next_hop;

commit 928a1cb034e6f9e8edcdd1dc07264cd703e00827
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jan 17 17:13:50 2023 +0100

    Alloc: Disable transparent huge pages
    
    The usage pattern implemented in allocator seems to be incompatible with
    transparent huge pages, as memory released using madvise(MADV_DONTNEED)
    with regular page size and alignment does not seem to trigger demotion
    of huge pages back to regular pages, even when significant number of
    pages is released. Even if demotion is triggered when system memory
    is low, it still breaks memory accounting.

commit 54234c9eae978463a2518446da399470ff916252
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Jan 13 16:44:42 2023 +0100

    Build: Fix cleanup of nest/proto-build.c

commit f8276812e6bf3aaefe22cdf9135b06e344298273
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Jan 13 13:32:29 2023 +0100

    Minor cleanups

commit 7fb23041a52d01754c53ba963e2282e524813364
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Jan 13 13:17:46 2023 +0100

    BSD: Add support for kernel route metric
    
    Add support for kernel route metric/priority, exported as krt_metric
    attribute, like in Linux. This should also fix issues with overwriting
    or removing system routes.

commit 64a2b7aaa303be0b407508747bfc96c1c656f1e2
Author: Mike Crute <mike@crute.us>
Date:   Thu Jan 12 17:40:53 2023 +0100

    Log message before aborting
    
    Log message before aborting due to watchdog timeout. We have to use
    async-safe write to debug log, as it is done in signal handler.
    
    Minor changes from committer.

commit e20bef69ccc4a85ef62359ee539c9db2dbe09127
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Jan 7 20:18:44 2023 +0100

    Filter: Change linearization of branches in switch instruction
    
    Most branching instructions (FI_CONDITION, FI_AND, FI_OR) linearize its
    branches in a recursive way, while FI_SWITCH branches are linearized
    from parser even before the switch instruction is allocated.
    
    Change linearization of FI_SWITCH branches to make it similar to other
    branching instructions. This also fixes an issue with constant
    switch evaluation, where linearized branch is mistaken for
    non-linearized during switch construction.
    
    Thanks to Jiten Kumar Pathy for the bugreport.

commit d1cd5e5a63b2256eb71661f7438537e4ded7b01a
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jan 3 19:09:51 2023 +0100

    BGP: Allow role specific keywords to be used as symbols
    
    Some of these new BGP role keywords use generic names that collides with
    user-defined symbols. Allow them to be redefined. Also remove duplicit
    keyword definition for 'prefer'.

commit 309c874f9c8b217dbed1569c73b4a3035f5cb170
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jan 3 17:14:48 2023 +0100

    Configure: Expensive check option was broken, never worked

commit b28431e557c4f63923476094a919a0630001275e
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jan 3 17:01:54 2023 +0100

    Nest: Fix leaking internal attributes in RIP and Babel
    
    During backporting attribute changes from 3.0-branch, some internal
    attributes (RIP iface and Babel seqno) leaked to 'show route all' output.
    Allow protocols to hide specific attributes with GA_HIDDEN value.
    
    Thanks to Nigel Kukard for the bugreport.

commit d3f50ede127df338f575e188566035b2a46cf6c6
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Jan 2 15:55:55 2023 +0100

    Add compile-time option to enable 4-way tries instead of 16-way ones
    
    In some cases 16-way tries are too memory-heavy, while 4-way are
    almost as efficient as the original 2-way ones.

commit 6d1ae197d189d50e60279796441c6e74272ddc54
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jan 1 20:10:23 2023 +0100

    Nest: Fix several issues with pflags
    
    There were some confusion about validity and usage of pflags, which
    caused incorrect usage after some flags from (now removed) protocol-
    specific area were moved to pflags.
    
    We state that pflags:
    
     - Are secondary data used by protocol-specific hooks
     - Can be changed on an existing route (in contrast to copy-on-write
       for primary data)
     - Are irrelevant for propagation (not propagated when changed)
     - Are specific to a routing table (not propagated by pipe)
    
    The patch did these fixes:
    
     - Do not compare pflags in rte_same(), as they may keep cached values
       like BGP_REF_STALE, causing spurious propagation.
    
     - Initialize pflags to zero in rte_get_temp(), avoid initialization in
       protocol code, fixing at least two forgotten initializations (krt
       and one case in babel).
    
     - Improve documentation about pflags

commit 8b06a4d8af46511f0f8dbb8905afa88590a831b6
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Sat Dec 24 15:47:11 2022 +0100

    Babel: Rework seqno request handling
    
    The seqno request retransmission handling was tracking the destination
    that a forwarded request was being sent to and always retransmitting to
    that same destination. This is unnecessary because we only need to
    retransmit requests we originate ourselves, not those we forward on
    behalf of others; in fact retransmitting on behalf of others can lead to
    exponential multiplication of requests, which would be bad.
    
    So rework the seqno request tracking so that instead of storing the
    destination of a request, we just track whether it was a request that we
    forwarded on behalf of another node, or if it was a request we originated
    ourselves. Forwarded requests are not retransmitted, they are only used
    for duplicate suppression, and for triggering an update when satisfied.
    If we end up originating a request that we previously forwarded, we
    "upgrade" the old request and restart the retransmit counter.
    
    One complication with this is that requests sent in response to unfeasible
    updates (section 3.8.2.2 of the RFC) have to be sent as unicast to a
    particular peer. However, we don't really need to retransmit those as
    there's no starvation when sending such a request; so we just change
    such requests to be one-off unicast requests that are not subject to
    retransmission or duplicate suppression. This is the same behaviour as
    babeld has for such requests.
    
    Minor changes from committer.

commit 2b7643e1f8ecb0bd4cf9af4183b4fd53b655d19c
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Dec 18 20:10:14 2022 +0100

    BSD: Use ip_mreqn on FreeBSD 12.1+ and OpenBSD 6.9+

commit 6825f94570b05f933f09ae1bd7e520954d903e6a
Author: Alexander Chernikov <melifaro@FreeBSD.org>
Date:   Fri Dec 16 19:35:02 2022 +0100

    FreeBSD: use interface index instead of IP address when specifying multicast interface
    
    Minor changes from committer.

commit 176fc68aed32a5675aa643e3b7c6f65ff9ad13d0
Author: Alexander Chernikov <melifaro@FreeBSD.org>
Date:   Fri Dec 16 19:20:05 2022 +0100

    Netlink: move OS-specific headers and defines to sysdep
    
    Minor changes from committer.

commit 7b6c9649775b288653b0d61df6004d79f0d83ccf
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Dec 16 19:03:41 2022 +0100

    BSD: Add missing makefile for bsd-netlink target
    
    Use symlinks to linux/netlink* to avoid limitations of our buildsystem.

commit 1e47b9f203aaaad0fb658d40a1670f1d0437f1f8
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Dec 11 17:28:14 2022 +0100

    NEWS and version update

commit 34ebc4e1ba41c618e5d46112696011ed596c5ebc
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Dec 11 16:28:28 2022 +0100

    BSD: Workaround for direct routes on FreeBSD 13.0
    
    FreeBSD 13.0 added some safechecks for syscalls, rejecting sockaddrs that
    are too small, later versions loosen up the check.

commit 937ebf2536e6b4d65f996af53a29ac550ac0cc2a
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Dec 10 18:03:41 2022 +0100

    BGP: Log unacceptable hold time as decimal number
    
    Thanks Johannes Moos for the suggestion.

commit 4c19a8a984c39c7269cf497808735f147243800b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Dec 10 17:32:42 2022 +0100

    CLI: Fix for long-lived sessions during high loads
    
    When there is a continuos stream of CLI commands, cli_get_command()
    always returns 1 (there is a new command). Anyway, the socket receive
    buffer was reset only when there was no command at all, leading to a
    strange behavior: after a while, the CLI receive buffer came to its end,
    then read() was called with zero size buffer, it returned 0 which was
    interpreted as EOF.
    
    The patch fixes that by resetting the buffer position after each command
    and moving remaining data at the beginning of buffer.
    
    Thanks to Maria Matejka for examining the bug and for the original bugfix.

commit 1124f39f731610687eb8fdd6d7079c20063809c1
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Dec 10 03:02:26 2022 +0100

    Client: Unknown command should return nonzero errorcode

commit e48f898fdaf06b61754ae520410729a9984ab65b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Dec 9 22:43:27 2022 +0100

    Doc: Document issue with import tables
    
    The import table does not work reliably together with re-evaluation of
    routes due to recursive next hops or flowspec validation. We will at
    least document that here, as import tables are completely redesigned and
    this issue is fixed in BIRD 3.x branch.

commit a80cd4707464cedb526eb72e7704b097af20beb7
Author: Alexander V. Chernikov <melifaro@ipfw.ru>
Date:   Fri Dec 9 15:59:06 2022 +0100

    Netlink on FreeBSD support
    
    Netlink support was added to FreeBSD recently. It is not as full-featured
    as its Linux counterpart yet, however the added subset is enough to make
    a routing daemon work. Specifically, it supports multiple tables,
    multipath, nexthops and nexthops groups. No MPLS support yet.
    
    The attached change adds 'bsd-netlink’ sysconf target, allowing to build
    both netlink & rtsock versions on FreeBSD.

commit 3859e4efc1597368df647323c5a3cc1771cb64ca
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri Dec 9 05:51:30 2022 +0100

    BGP: Improve handling of hold and keepalive timers
    
    The effective keepalive time now scales relative to the negotiated
    hold time, to maintain proportion between the keepalive time and the
    hold time. This avoids issues when both keepalive and hold times
    were configured, the hold time was negotiated to a smaller value,
    but the keepalive time stayed the same.
    
    Add new options 'min hold time' and 'min keepalive time', which reject
    session attempts with too small hold time.
    
    Improve validation of config options an their documentation.
    
    Thanks to Alexander Zubkov and Sergei Goriunov for suggestions.

commit e80156d9363a594ff23524f56d59f0eee160859d
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Dec 6 19:40:02 2022 +0100

    Nest: Avoid spurious announcements triggered by filtered routes
    
    When filtered routes (enabled by 'import keep filtered' option) are
    updated, they trigger announcements by rte_announce(). For regular
    channels (e.g. type RA_OPTIMAL or RA_ANY) such announcement is just
    ignored, but in case of RA_ACCEPTED (BGP peer with 'secondary' option)
    it just reannounces the old (and still valid) best route.
    
    The patch ensures that such no-change is ignored even for these channels.

commit a50d2fa65f3350ee55f5106b87a884d1b98e7761
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Nov 30 02:45:07 2022 +0100

    CI: Remove docker rebuild phase
    
    It is unnnecessary and takes too much time

commit ff38ee598648ae2fc76cc18dada7602dcfc90668
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Nov 29 18:30:16 2022 +0100

    CI: Try new workers

commit 543c8ba0971e91da3fe507dbfc1e1f9b556642b1
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Nov 29 19:43:38 2022 +0100

    BSD: Fix krt socket code w.r.t. rte/rta changes

commit 140c534fb81d0e165b7d674e869c646455ed19d1
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Nov 29 03:50:33 2022 +0100

    Fix build variables for OpenBSD

commit bbac9ca958c73fd08b4691ea40067d1cc3ac275a
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Nov 9 22:02:46 2022 +0100

    Conf: Make 'configure check' command restricted
    
    While it does not directly change BIRD state, it can trigger reading
    arbitrary files and eating significant memory.

commit 371eb49043d225d2bab8149187b813a14b4b86d2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Nov 9 21:09:16 2022 +0100

    Conf: Free stored old config before parsing new one
    
    BIRD keeps a previous (old) configuration for the purpose of undo. The
    existing code frees it after a new configuration is successfully parsed
    during reconfiguration. That causes memory usage spikes as there are
    temporarily three configurations (old, current, and new). The patch
    changes it to free the old one before parsing the new one (as user
    already requested a new config). The disadvantage is that undo is
    not available after failed reconfiguration.

commit 84545a26cc3f7ce68408a663c1ad4a50edccdacc
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Nov 8 10:20:55 2022 +0100

    Added more netlab tests for automatic run.
    
    This commit uses bird-tools in version
    f35e8bce829f4bff61ec7eb07ec9c67aa867bc9a

commit 57308fb277788ab082a0047e8764fe8023aff6df
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Nov 3 12:38:57 2022 +0100

    Page allocator: Fixed minor bugs and added commentary

commit 9d03c3f56ced3d3191982f57029f9a3d12fa2e5a
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Nov 1 18:40:56 2022 +0100

    Memory pages are not munmapped, instead we just madvise()
    
    Memory unmapping causes slow address space fragmentation, leading in
    extreme cases to failing to allocate pages at all. Removing this problem
    by keeping all the pages allocated to us, yet calling madvise() to let
    kernel dispose of them.
    
    This adds a little complexity and overhead as we have to keep the
    pointers to the free pages, therefore to hold e.g. 1 GB of 4K pages with
    8B pointers, we have to store 2 MB of data.

commit 37b644413723670928f6b54f2abe0c852eb0b652
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Nov 1 08:56:26 2022 +0100

    Moved config-related allocations to config_pool and showing its size in memory usage

commit 5aebce5e0cc59c4c8459ab92a201df5868f46e7a
Author: Alexander Zubkov <green@qrator.net>
Date:   Tue Oct 18 04:25:29 2022 +0200

    Doc: Add documentation for "show route (import|export) table"

commit e471f9e0fb7ade475dd3eb8b230bcb440877ee7e
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Oct 18 03:58:19 2022 +0200

    Filter: Fix handling of variables in anonymous filters
    
    Define scope for anonymous filters, and also explicitly distinguish block
    scopes and function/filter scopes instead of using anonymous / named
    distinction.
    
    Anonymous filters forgot to push scope, so variables for them were in
    fact defined in the top scope and therefore they shared a frame. This got
    broken after rework of variables, which assumed that there is a named
    scope for every function/filter.

commit 324252975004154cc70623c94f05083bff100209
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Oct 12 17:57:26 2022 +0200

    Netlink: Parse onlink flag even on direct routes
    
    While onlink flag is meaningful only with explicit next hops, it can be
    defined also on direct routes. Parse it also in this case to avoid
    periodic updates of the same route.
    
    Thanks to Marcin Saklak for the bugreport.

commit 8f79e6b93e32a4eb7e4dda9bd4a9d04400b79d45
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Oct 10 05:06:19 2022 +0200

    BGP: Add option 'next hop prefer global'
    
    Add BGP channel option 'next hop prefer global' that modifies BGP
    recursive next hop resolution to use global next hop IPv6 address instead
    of link-local next hop IPv6 address for immediate next hop of received
    routes.

commit 8478de8817c58af02f7aed1d621013891115a2dc
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Oct 3 18:53:21 2022 +0200

    Nest: Add channel config flag to distinguish new or copy
    
    It is useful to distinguish whehter channel config returned from
    channel_config_get() was allocated new, or existing from template.
    Caller may want to initialize new ones.

commit 92a856554780c262f188acb4cdcee363bf6dd1bb
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Sep 27 16:47:52 2022 +0200

    Filter: Add some minor functions for f_tree and EC
    
    Add some supportive functions for f_tree and EC. These functions are used
    by L3VPN code.

commit da0b589e7bbcd8177702caa925063d36e7f316ec
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Sep 27 16:13:27 2022 +0200

    BGP: Some fixes related to VRF and MPLS interactions
    
     - When next hop is reset to local IP, we should remove BGP label stack,
       as it is related to original next hop
    
     - BGP next hop or immediate next hop from one VRF should not be passed
       to another VRF, as they are different IP namespaces

commit 54430df953d6c590e5f446530a21d18277eeda56
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Sep 8 19:41:02 2022 +0200

    BGP: Do not assume that all channels are struct bgp_channel
    
    In principle, the channel list is a list of parent struct proto and can
    contain general structures of type struct channel, That is useful e.g.
    for adding MPLS channels to BGP.

commit 605ff0a0ebdd32b1a98316737c3e65acb528a156
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Oct 3 17:09:02 2022 +0200

    RPKI: wait for retry_time if we get error immediately after connected

commit 0f2be469f897b6d9f925563bbf522438c83522ea
Author: Alexander Zubkov <green@qrator.net>
Date:   Wed Sep 21 17:07:11 2022 +0200

    KRT: Fix setting default preference
    
    Changes in commit eb937358 broke setting of channel preference for alien
    routes learned during scan. The preference was set only for async routes.
    Move common attribute processing part of functions krt_learn_async() and
    krt_learn_async() to a separate function to have only one place for such
    changes.

commit c73343de67afc703dfe812b8e94034b1b1dcfca8
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Sep 16 10:11:51 2022 +0200

    Revert "Reducing filter stack size to allow for lesser thread stack size"
    
    This reverts commit 2c13759136951ef0e70a3e3c2b2d3c9a387f7ed9.

commit 71b3456eede17be6646b7deebff84f34ee5755f7
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Oct 22 19:43:55 2021 +0200

    Better profylaction recursive route loops
    
    In some specific configurations, it was possible to send BIRD into an
    infinite loop of recursive next hop resolution. This was caused by route
    priority inversion.
    
    To prevent priority inversions affecting other next hops, we simply
    refuse to resolve any next hop if the best route for the matching prefix
    is recursive or any other route with the same preference is recursive.
    
    Next hop resolution doesn't change route priority, therefore it is
    perfectly OK to resolve BGP next hops e.g. by an OSPF route, yet if the
    same (or covering) prefix is also announced by iBGP, by retraction of
    the OSPF route we would get a possible priority inversion.

commit d2c1036a42881d413ec97203ede92a69f8cd218f
Merge: dc28c6ed 16ac6c3c
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Aug 18 22:07:50 2022 +0200

    Merge branch 'mq-fix-eattr-setting' into backport

commit dc28c6ed1c6643ec19d2e8f94f92955f58c357a7
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Aug 18 18:32:33 2022 +0200

    Simplified the protocol hookup code in Makefiles

commit 16ac6c3c74020f043204ecf44aba30ba7257a3e3
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Aug 18 17:44:00 2022 +0200

    Fixed initialization of Linux kernel route attributes

commit bc4ad83dacb07ad6bb454b75d78daa2f9c953088
Merge: 73abd91a 082905a8
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 3 15:04:42 2022 +0200

    Merge commit '082905a8' into HEAD

commit 73abd91ac661f28d9341c7fbb80d2f7a71db186d
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Jul 22 16:09:37 2022 +0200

    rip_rte_better() uses the IGP_METRIC_UNKNOWN instead of protocol-specific infinity

commit 082905a8338b4ba20a08ada0d562bbc5e15c707b
Merge: 2e484f8d ddb1bdf2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Wed Jul 27 00:47:24 2022 +0200

    Merge branch 'master' into backport

commit ddb1bdf2819ce69248d5a51e71d803f13548b217
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jul 26 18:45:20 2022 +0200

    Netlink: Restrict route replace for IPv6
    
    Seems like the previous patch was too optimistic, as route replace is
    still broken even in Linux 4.19 LTS (but fixed in Linux 5.10 LTS) for:
    
      ip route add 2001:db8::/32 via fe80::1 dev eth0
      ip route replace 2001:db8::/32 dev eth0
    
    It ends with two routes instead of just the second.
    
    The issue is limited to direct and special type (e.g. unreachable)
    routes, the patch restricts route replace for cases when the new route
    is a regular route (with a next hop address).

commit 722daa950046a7ad307fd7aca8e0506f30b3d000
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Mon Jul 25 00:11:40 2022 +0200

    Netlink: Simplify handling of IPv6 ECMP routes
    
    When IPv6 ECMP support first appeared in Linux kernel, it used different
    API than IPv4 ECMP. Individual next hops were updated and announced
    separately, instead of using RTA_MULTIPATH as in IPv4. This has several
    drawbacks and requires complex code to merge received notifications to
    one multipath route.
    
    When Linux came with IPv6 RTA_MULTIPATH support, the initial versions
    were somewhat buggy, so we kept using the old API for updates (splitting
    multipath routes to sequences of route updates), while accepting both
    old-style routes and RTA_MULTIPATH routes in scans / notifications.
    
    As IPv6 RTA_MULTIPATH support is here for a long time, this patch fully
    switches Netlink to the IPv6 RTA_MULTIPATH API and removes old complex
    code for handling individual next hop announces.
    
    The required Linux version is at least 4.11 for reliable operation.
    
    Thanks to Daniel Gröber for the original patch.

commit 2e484f8d2977186f6d97213827a66847738d2c31
Merge: 4d48ede5 971721c9
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jul 24 20:08:02 2022 +0200

    Merge branch 'master' into backport

commit 534d0a4b44aa193da785ae180475a448f57805e2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jul 24 02:15:20 2022 +0200

    KRT: Scan routing tables separetely on linux to avoid congestion
    
    Remove compile-time sysdep option CONFIG_ALL_TABLES_AT_ONCE, replace it
    with runtime ability to run either separate table scans or shared scan.
    
    On Linux, use separate table scans by default when the netlink socket
    option NETLINK_GET_STRICT_CHK is available, but retreat to shared scan
    when it fails.
    
    Running separate table scans has advantages where some routing tables are
    managed independently, e.g. when multiple routing daemons are running on
    the same machine, as kernel routing table modification performance is
    significantly reduced when the table is modified while it is being
    scanned.
    
    Thanks Daniel Gröber for the original patch and Toke Høiland-Jørgensen
    for suggestions.

commit 432dfe3b9b97062be243609d69e0f49bdb0bcaf6
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Jul 22 15:48:20 2022 +0200

    Fixed a rarely used part of Babel: comparing two routes in table by their metric

commit 4d48ede51dfff9a59572a6b7a21a1bbf159dec60
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Jul 22 15:37:21 2022 +0200

    Revert "Export table: Delay freeing of old stored route."
    
    This reverts commit cee0cd148c9b71bf47d007c850193b5fbf9486c1.
    This change is not needed in version 2 and the surrounding code has
    disappeared mostly in version 3.

commit 971721c9b50d361e886762f1c7d0392e10f74021
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Jul 12 15:03:17 2022 +0200

    BGP: Minor improvements to BGP roles
    
    Add support for bgp_otc in filters and warning for configuration
    inside confederations.

commit c73b5d2d3d94204d2a81d93efd02c4c115859353
Author: Eugene Bogomazov <eb@qrator.net>
Date:   Mon Jul 11 17:19:34 2022 +0200

    BGP: Implement BGP roles
    
    Implement BGP roles as described in RFC 9234. It is  a mechanism for
    route leak prevention and automatic route filtering based on common BGP
    topology relationships. It defines role capability (controlled by 'local
    role' option) and OTC route attribute, which is used for automatic route
    filtering and leak detection.
    
    Minor changes done by commiter.

commit b5c8fce284a2bb529aee6ff201fe044f09a0e418
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 11 13:04:01 2022 +0200

    Added forgotten route source locking in flowspec validation

commit 2e5bfeb73ac25e236a24b6c1a88d0f2221ca303f
Merge: d429bc5c cb339a30
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 11 11:08:10 2022 +0200

    Merge remote-tracking branch 'origin/master' into backport

commit d429bc5c841a8e9d4c81786973edfa56d20a407e
Merge: 7e9cede1 beb5f78a
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 11 10:41:17 2022 +0200

    Merge commit 'beb5f78a' into backport

commit 7e9cede1fd1878fb4c00e793bccd0ca6c18ad452
Merge: 652be92a b867c798
Author: Maria Matejka <mq@ucw.cz>
Date:   Sun Jul 10 14:19:24 2022 +0200

    Merge version 2.0.10 into backport

commit cb339a30677901f2c248de08ff535cf0a9efab3d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 14 20:36:20 2022 +0100

    Filter: Implement for loops
    
    For loops allow to iterate over elements in compound data like BGP paths
    or community lists. The syntax is:
    
      for [ <type> ] <variable> in <expr> do <command-body>

commit 1ac8e11bba15551ad6473a57a585649757fefa6b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 10 01:02:45 2022 +0100

    Filter: Implement mixed declarations of local variables
    
    Allow variable declarations mixed with code, also in nested blocks with
    proper scoping, and with variable initializers. E.g:
    
    function fn(int a)
    {
      int b;
      int c = 10;
    
      if a > 20 then
      {
        b = 30;
        int d = c * 2;
        print a, b, c, d;
      }
    
      string s = "Hello";
    }

commit a2527ee53d9d8fe7a1c29b56f8450b9ef1f9c7bc
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 9 02:32:29 2022 +0100

    Filter: Improve handling of stack frames in filter bytecode
    
    When f_line is done, we have to pop the stack frame. The old code just
    removed nominal number of args/vars. Change it to use stored ventry value
    modified by number of returned values. This allows to allocate variables
    on a stack frame during execution of f_lines instead of just at start.
    
    But we need to know the number of returned values for a f_line. It is 1
    for term, 0 for cmd. Store that to f_line during linearization.

commit f31f4e6eef1762a4b9bf54a274f1ba9e9e161802
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 9 00:31:39 2022 +0100

    Filter: Simplify handling of command sequences
    
    Command sequences in curly braces used a separate nonterminal in grammar.
    Handle them as a regular command.

commit 1e6acf34bbf2d9c31246c6fc450ac3b0232531e2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 6 22:57:33 2022 +0100

    Filter: Fix bug in variable shadowing
    
    When a new variable used the same name as an existing symbol in an outer
    scope, then offset number was defined based on a scope of the existing
    symbol ($3) instead of a scope of the new symbol (sym_). That can lead
    to two variables sharing the same memory slot.

commit 946cedfcfe3bdfd850613c4d891f8abfd6b2cafd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 6 16:37:30 2022 +0100

    Filter: Implement soft scopes
    
    Soft scopes are anonymous scopes that most likely do not contain any
    symbol, so allocating regular scope is postponed when it is really
    needed.

commit 26bc4f9904b014c9949489e8ae28366da473e85d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Mar 6 02:18:01 2022 +0100

    Filter: Implement direct recursion
    
    Direct recursion almost worked, just crashed on function signature check.
    Split function parsing such that function signature is saved before
    function body is processed. Recursive calls are marked so they can be
    avoided during f_same() and similar code walking.
    
    Also, include tower of hanoi solver as a test case.

commit fb1d8f65136aa6190b527b691f24abe16a461471
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Mar 4 17:51:50 2022 +0100

    Filter: Apply constant promotion for FI_EQ / FI_NEQ
    
    Equality comparison is defined on all values, even of different
    types, but we still want to do constant promotion if possible.

commit b2d6d2948af268812a8f55f260d340194eb3f7ac
Author: Alexander Zubkov <green@qrator.net>
Date:   Fri Mar 4 14:07:58 2022 +0100

    Filter: Add literal for empty set
    
    Add literal for empty set [], which works both for tree-based sets
    and prefix sets by using existing constant promotion mechanism.
    
    Minor changes by committer.

commit 8f3c6151b4ff11d98a20f6f9919723f0fb719161
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Mar 4 02:01:34 2022 +0100

    Nest: Cleanups in as_path_filter()
    
    Use struct f_val as a common argument for as_path_filter(), as suggested
    by Alexander Zubkov. That allows to use NULL sets as valid arguments.

commit 9b302c133f02f96edc5caa769dfd21dc9ef038b5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 3 20:34:44 2022 +0100

    Filter: Ensure that all expressions declared return type
    
    All instructions with a return value (i.e. expressions, ones with
    non-zero outval, third argument in INST()) should declare their return
    type. Check that automatically by M4 macros.
    
    Set outval of FI_RETURN to 0. The instruction adds one value to stack,
    but syntactically it is a statement, not an expression.
    
    Add fake return type declaration to FI_CALL, otherwise the automatic
    check would fail builds.

commit cde8094c1f81a74d8a434c4cbf41b4d9183e2879
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 3 15:11:05 2022 +0100

    Filter: Improve description of type system

commit 93d6096c8714f3c7c9450df89e812021a212b978
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 3 03:38:12 2022 +0100

    Filter: Implement type checks for function calls
    
    Keep list of function parameters in f_line and use it to verify
    types of arguments for function calls. Only static type checks
    are implemented.

commit 4c0c507b1fabbdab557d66eb9d90a2d3c8009880
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 1 02:04:35 2022 +0100

    Filter: Clean up function call instruction
    
    Pass instructions of function call arguments as vararg arguments to
    FI_CALL instruction constructor and move necessary magic from parser
    code to interpreter / instruction code.

commit beb5f78ada79ac90f31f2c4923302c74d9ab38bf
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jun 27 19:04:22 2022 +0200

    Preexport callback now takes the channel instead of protocol as argument
    
    Passing protocol to preexport was in fact a historical relic from the
    old times when channels weren't a thing. Refactoring that to match
    current extensibility needs.

commit b867c798c3e42c875311a79fe53a36d4a5bfd126
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Jun 16 02:58:37 2022 +0200

    NEWS and version update

commit 141fb51f1a3c22c45025426775c00f66c06406a7
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jun 7 10:35:48 2022 +0200

    IPv4 flowspec literals should reject IPv6 prefices in a well-behaved way
    
    When writing flow4 { dst 2001:db8::dead:beef/128; }, BIRD crashed on an
    not-well-debuggable segfault as it tried to copy the whole 128-bit
    prefix into an IPv4-sized memory.

commit ad686c55c3fad13f39e44ee5732c38296caff782
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun Jun 5 04:03:43 2022 +0200

    Babel: Do not try to remove multicast seqno request objects from neighbour list
    
    The Babel seqno request code keeps track of which seqno requests are
    outstanding for a neighbour by putting them onto a per-neighbour list. When
    reusing a seqno request, it will try to remove this node, but if the seqno
    request in question was a multicast request with no neighbour attached this
    will result in a crash because it tries to remove a list node that wasn't
    added to any list.
    
    Fix this by making the list remove conditional. Also fix neighbor removal
    which were changing seqno requests to multicast ones instead of removing
    them.
    
    Fixes: ebd5751cdeb4 ("Babel: Seqno requests are properly decoupled from
    neighbors when the underlying interface disappears").
    
    Based on the patch from Toke Høiland-Jørgensen <toke@toke.dk>,
    bug reported by Stefan Haller <stefan.haller@stha.de>, thanks.

commit f39e9aa20363eccc38289958f23c789d037c269b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Jun 4 17:54:08 2022 +0200

    IO: Improve resolution of latency debugging messages

commit a8a3d95be5db1a8a7d5a17e2eb8e233417b1d8c7
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat Jun 4 17:34:57 2022 +0200

    Nest: Improve GC strategy for rtables
    
    Use timer (configurable as 'gc period') to schedule routing table
    GC/pruning to ensure that prune is done on time but not too often.
    
    Randomize GC timers to avoid concentration of GC events from different
    tables in one loop cycle.
    
    Fix a bug that caused minimum inter-GC interval be 5 us instead of 5 s.
    
    Make default 'gc period' adaptive based on number of routing tables,
    from 10 s for small setups to 600 s for large ones.
    
    In marge multi-table RS setup, the patch improved time of flushing
    a downed peer from 20-30 min to <2 min and removed 40s latencies.

commit 652be92a21f5575e5f74f6abe98eb4200b86776c
Merge: f196b12c 9e60b500
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon May 30 15:20:21 2022 +0200

    Merge remote-tracking branch 'origin/master' into haugesund-to-2.0

commit f196b12c62633e382541ba156e6df1534860c568
Merge: 097f1571 9eec503b
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon May 30 15:20:05 2022 +0200

    Merge commit '9eec503b251c3388579032b300d32640403d8612' into haugesund-to-2.0

commit 097f1571821caa775aec3ada52a1b02b5ffc89bb
Merge: 5299fb9d 692055e3
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon May 30 15:17:52 2022 +0200

    Merge commit '692055e3df6cc9f0d428d3b0dd8cdd8e825eb6f4' into haugesund-to-2.0

commit 9e60b500c76945ccdea94d3a67e7acfde5e3f969
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Fri May 27 16:07:24 2022 +0200

    CI: Remove broken FreeBSD builds
    
    We currently do not have FreeBSD CI workers.

commit a9c19b923c886ddfaefd0fa5052d4799b80579e2
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat May 21 16:21:34 2022 +0200

    BGP: Display neighbor port on show protocol

commit 7bb06b34a110bbf40e7308eb19f32202a66d58ba
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sat May 21 16:03:08 2022 +0200

    RPKI: Display cache server port on show protocol
    
    Thanks to Luiz Amaral for the idea.

commit 9a9439d5e1d3b1372dadb25207d67d83a2e1e98c
Author: Luiz Amaral <email@luiz.eng.br>
Date:   Thu May 19 19:43:59 2022 +0200

    RPKI: Implement VRF support

commit ba2a076001be6e4140fbd2703cd134e5aa51450b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Sun May 15 15:05:13 2022 +0200

    BGP: Improve tx performance during feed/flush
    
    The prefix hash table in BGP used the same hash function as the rtable.
    When a batch of routes are exported during feed/flush to the BGP, they
    all have similar hash values, so they are all crowded in a few slots in
    the BGP prefix table (which is much smaller - around the size of the
    batch - and uses higher bits from hash values), making it much slower due
    to excessive collisions. Use a different hash function to avoid this.
    
    Also, increase the batch size to fill 4k BGP packets and increase minimum
    BGP bucket and prefix hash sizes to avoid back and forth resizing during
    flushes.
    
    This leads to order of magnitude faster flushes (on my test data).

commit 5299fb9db0e3fb75c37f233e9a8b737c46e61265
Author: Alexander Zubkov <green@qrator.net>
Date:   Wed May 4 15:37:23 2022 +0200

    Fixed spurious undef of route attributes

commit 207ac4853316ceffa6d56ff06f8904320d3bf45f
Author: Vincent Bernat <vincent@bernat.ch>
Date:   Fri Apr 22 17:06:27 2022 +0200

    Doc: fix mating -> matching in flowspec section

commit d8298001389f021f68ead1ed2b4809edb60ae416
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Fri Apr 22 17:04:56 2022 +0200

    Babel: Fix compilation when LOCAL_DEBUG is set in packets.c
    
    The debug output was not updated with the rest of the code, so packets.c
    fails to compile if LOCAL_DEBUG is set.

commit 4aef70136d8bae68e171fa7178889e6ad9fff9b8
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Fri Apr 22 16:41:52 2022 +0200

    Babel: Send out low-interval hello on shutdown
    
    When shutting down a Babel instance we send a wildcard retraction to make
    sure all peers can quickly switch to other route origins. Add another small
    optimisation borrowed from babeld: sending a Hello message (along with the
    retraction) with a very low interval.
    
    This will cause neighbours to modify their expiry timers for the node's
    state to quickly time it out, thus conserving resources in the network.

commit 98fd158e28d89f10ee7a41b4f6a14fbd0021ef35
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Apr 13 17:05:12 2022 +0200

    RIP: fixed the EA_RIP_FROM attribute
    
    The interface pointer was improperly converted to u32 and back. Fixing
    this by explicitly allocating an adata structure for it. It's not so
    memory efficient, we'll optimize this later.

commit 9eec503b251c3388579032b300d32640403d8612
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Apr 13 11:28:15 2022 +0200

    Fixed a munmap abort bug
    
    When BIRD was munmapping too many pages, it sometimes aborted, saying
    that munmap failed with "Not enough memory" as the address space was
    getting more and more fragmented.
    
    There is a workaround in place, simply keeping that page for future use,
    yet it has never been compiled in because I somehow forgot to include
    errno.h. And because I also thought that somebody may have ENOMEM not
    defined (why?!), there was a check which quietly omitted that
    workaround.
    
    Anyway, ENOMEM is POSIX. It's an utter nonsense to check for its
    existence. If it doesn't exist, something is broken.

commit 692055e3df6cc9f0d428d3b0dd8cdd8e825eb6f4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Apr 7 19:33:40 2022 +0200

    BFD: Add 'strict bind' option
    
    Add BFD protocol option 'strict bind' to use separate listening socket
    for each BFD interface bound to its address instead of using shared
    listening sockets.

commit d39ef961d1dde230c55fcc931b53f44cb34a1e63
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Apr 5 15:09:56 2022 +0200

    BGP uses lp_save / lp_restore instead of linpool flushing
    
    It is too cryptic to flush tmp_linpool in these cases and we don't want
    anybody in the future to break this code by adding an allocation
    somewhere which should persist over that flush.
    
    Saving and restoring linpool state is safer.

commit 7e86ff2076f3046c6dcca53e7756f112362aeee9
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Apr 4 22:34:14 2022 +0200

    All linpools use pages to allocate regular blocks

commit dabd7bccb3b9e2b7482cf4ae7619a67559f3ac94
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 22 14:39:32 2022 +0100

    BGP: Fixed LLGR depreferencing in bgp_rte_mergable

commit 4a23ede2b056a41456790cc20a0c3d92a7137693
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Mar 18 22:05:50 2022 +0100

    Protocols have their own explicit init routines

commit 0f68515263e91dd49b2d845cdff35af40c064dc2
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Mar 14 11:13:48 2022 +0100

    Unsetting route attributes without messing with type system

commit 63cf5d5d8c8e156a1f427614c8017ca71c32191c
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Mar 14 10:06:44 2022 +0100

    Eattr flags (originated and fresh) get their own struct fields

commit af8568a8700b83f4d1946b7075fa3eac96d1d5b6
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 16 10:22:49 2022 +0100

    Minor fix: f_val literals should always have named struct fields

commit 170b20701c46b36e6272d85fd00cc65f72c70b0d
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Apr 4 20:31:25 2022 +0200

    Converted Slab allocator to typed lists

commit ebd807c0b8eb0b7a3dc3371cd4c87ae886c00885
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Apr 4 20:31:14 2022 +0200

    Slab allocator can free the blocks without knowing the parent structure

commit 3a6eda995ecfcebff3130d86ee3baeab12a41335
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Apr 4 20:28:23 2022 +0200

    Typed lists for easier walking and stronger type checking

commit 4b1aa37f931888febfd768309d5e2ef36f5e7194
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 16 23:16:26 2022 +0100

    Netlink: Remove superfluous sysdep/linux/netlink.c.orig
    
    Thanks to Vincent Bernat for notice.

commit 269bfff9bf4b2349248bb48ff61009cf1c5a4aec
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 16 19:50:16 2022 +0100

    Lib: Allow use of 240.0.0.0/4 as a private range
    
    There were several requests to allow use of 240.0.0.0/4 as a private
    range, and Linux kernel already allows such routes, so perhaps we can
    allow that too.
    
    Thanks to Vincent Bernat and others for suggestion and patches.

commit c53f547a0bf437fb95923b2a0b9ac497e474aef1
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 15 11:21:46 2022 +0100

    Printf variant with a result allocated inside a pool / linpool

commit 3c42f7af6a23de3f135235521318301e5b34f2de
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Mar 14 17:29:39 2022 +0100

    Slab memory allocator unit test

commit c3828879a395c84bd7aac089903c88bb3a9c149d
Author: Vincent Bernat <vincent@bernat.ch>
Date:   Fri Mar 11 15:47:00 2022 +0100

    Pkg: Improve RPM package unit file
    
    Update the RPM package unit file to check configuration before start and
    to use "birdc configure" instead of "kill -HUP".

commit 9b0b2c0d410fd26e1b48d158a667e42f4bbec52c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Mar 11 03:40:03 2022 +0100

    Client: Use exit status to report errors
    
    When birdc is called with a command as an argument, it should set exit
    status to non-zero when BIRD replied with an error reply code.
    
    Thanks to Vincent Bernat and others for suggestion.

commit 4e60b3ee7270a432357e203824a7d519a3134f01
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 13:27:49 2022 +0100

    Fixed a static assert in page allocator

commit 9b6db9f9b8e561d215e1df01169b15a9dfaba1b9
Merge: 19e727a2 5ddf98f6
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 11:51:00 2022 +0100

    Merge remote-tracking branch 'origin/master' into haugesund

commit 19e727a248d15e9f8871986ac286cf74b3d86e61
Merge: 8a4bc4fd 60880b53
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 11:28:34 2022 +0100

    Merge commit '60880b539b8886f76961125d89a265c6e1112b7a' into haugesund

commit 8a4bc4fdbf2f4c6ccaa684c922779ddc11489e68
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 11 22:29:13 2022 +0100

    BGP Flowspec validation: Removed in-route optimization for multithreading compatibility

commit 24773af9e099530aa6ccf4c730ad31c452284228
Merge: 83d9920f e42eedb9
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 11:01:44 2022 +0100

    Merge commit 'e42eedb9' into haugesund

commit 83d9920f90738e4df75b3cf57335b43c094051cd
Merge: ff47cd80 5cff1d5f
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 10:56:06 2022 +0100

    Merge commit '5cff1d5f' into haugesund
    
    Conflicts:
          proto/bgp/attrs.c
          proto/pipe/pipe.c

commit ff47cd80dd04bc11692248a40cbf52ee8d351064
Merge: 9e60a1fb d5a32563
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 10:50:38 2022 +0100

    Merge commit 'd5a32563' into haugesund

commit 9e60a1fbc3ef9ab93b414dcf451bbe741e2e8827
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 10:30:03 2022 +0100

    Fixed resource initialization in unit tests

commit b90c9b164fedd44115c01fb2b07f71fb40ab3b77
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 10:30:33 2022 +0100

    Linpools with pages fixed to the final page allocator version

commit eeec9ddbf2a3536417c6dd434da9a7dd2bbdaa42
Merge: c78247f9 0c59f7ff
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:13:55 2022 +0100

    Merge commit '0c59f7ff' into haugesund

commit 0c59f7ff0112abd1261afb8f21b7c00fc5e37885
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:13:31 2022 +0100

    Revert "Bound allocated pages to resource pools with page caches to avoid unnecessary syscalls"
    
    This reverts commit 7f0e59820899c30a243c18556ce2e3fb72d6d221.

commit c20506dc07e1b99cf1d9f2cf9d00e9211cd9e2f4
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:13:21 2022 +0100

    Revert "fixup! Bound allocated pages to resource pools with page caches to avoid unnecessary syscalls"
    
    This reverts commit bea582cbb53e30dd32a5b6829c7443e0e5558d11.

commit 1c7df2c24029d6721745b99fd4137935db03e257
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:13:20 2022 +0100

    Revert "Multipage allocation"
    
    This reverts commit 6cd37713781a3092f8166b2178fae35cbfec1e28.

commit 1740ff57e8ea05d7d9f15d1a6830ce42add3e4bd
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:13:18 2022 +0100

    Revert "fixup! Multipage allocation"
    
    This reverts commit a54f75f454b7ed8c8ff2c1787a506528f22cbae7.

commit c78247f9b97802d6fe76d9b7cddf2c1940134d33
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 9 09:10:44 2022 +0100

    Single-threaded version of sark-branch memory page management

commit 06ece3265e222f218224bb394c250cb414e44ab4
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 2 11:22:32 2022 +0100

    Replacing BGP temporary linpools by the common temporary linpool

commit d814a8cb9381e8cb22c3f37d3c970ca7972656a6
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 2 10:59:52 2022 +0100

    Replaced custom linpools in tests for the common tmp_linpool

commit 48bf1322aa141ca6259b26b37551402758cff0cc
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 2 10:35:21 2022 +0100

    Introducing an universal temporary linpool flushed after every task

commit 2e8b8bfcc46ec1493f9e0efe9c796b88df85ada4
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 2 11:22:01 2022 +0100

    Static list initializer

commit 5ddf98f6bdfec213d64957a580e0425c3ed4d660
Author: Ondrej Filip <feela@network.cz>
Date:   Wed Mar 2 10:52:09 2022 +0100

    Small improvement in directory test

commit d071aca7aaf7a4add9e0d1d93029fb9a0fad560a
Merge: fcb4dd0c 2c137591
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 2 10:01:44 2022 +0100

    Merge commit '2c13759136951ef0e70a3e3c2b2d3c9a387f7ed9' into haugesund

commit fcb4dd0c831339c4374ace17d8f2ae6ebfeed279
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 27 03:10:38 2022 +0100

    Babel: Fix bug in iface reconfiguration
    
    A recent change in Babel causes ifaces to disappear after
    reconfiguration. The patch fixes that.
    
    Thanks to Johannes Kimmel for an insightful bugreport.

commit eb859a3fb063b261fb76304e5b8eca206e7a162a
Author: Ondrej Filip <feela@network.cz>
Date:   Sun Feb 20 15:30:47 2022 +0100

    Small change to fix doc building on Debian

commit 9b13fa4d9c3cd8894f61ed84a38ef3c69fe4fe6f
Author: Ondrej Filip <feela@network.cz>
Date:   Sun Feb 20 14:28:06 2022 +0100

    Small changes related to the new release

commit 64d5d6d2c34fc198753f232959108305b5bd4b4c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 13 16:45:49 2022 +0100

    NEWS: Fix formatting and add some notes

commit 71c9484b00b4428ae6c7d7c8eea6d96073683a54
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Feb 9 03:47:49 2022 +0100

    NEWS and version update

commit 2fc8b4c4bac576427b0054a13cc78e395b93d6c4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 8 22:42:00 2022 +0100

    Alloc: Use posix_memalign() instead of aligned_alloc()
    
    For compatibility with older systems use posix_memalign(). We can
    switch to aligned_alloc() when we commit to C11 for multithreading.

commit ef614f29843ab2bdfb0ff5ed5da0a989eeaa33a6
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 8 22:21:08 2022 +0100

    Netlink: Minor cleanup

commit edc1a2401752c3db30df1b9c6c796c06a8c59cc1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Feb 7 04:39:49 2022 +0100

    Lib: Update alignment of slabs
    
    Alignment of slabs should be at least sizeof(ptr) to avoid unaligned
    pointers in slab structures. Fixme: Use proper way to choose alignment
    for internal allocators.

commit 53a25406878ed686a58ec3e7379d6cb45b784942
Merge: 4c6ee53f 24600c64
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 6 23:32:15 2022 +0100

    Merge branch 'oz-trie-table'

commit 24600c642a1f50e2404f4d9dd98bd8a0c9844860
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 6 22:53:55 2022 +0100

    Trie: Fix trie format
    
    After switching to 16-way tries, trie format ignored unaligned / internal
    prefixes and only reported the primary prefix of a trie node.
    
    Fix trie format by showing internal prefixes based on the 'local' bitmask
    of a node. Also do basic (intra-node) reconstruction of prefix patterns
    by finding common subtrees in 'local' bitmask.
    
    In future, we could improve that by doing inter-node reconstruction, so
    prefixes entered as one pattern for a subtree (e.g. 192.168.0.0/18+)
    would be reported as such, like with aligned prefixes.

commit 5a89edc6fd0b03716ccb77084e8d1a1910f52ab0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Feb 4 05:34:02 2022 +0100

    Nest: Implement locking of prefix tries during walks
    
    The prune loop may may rebuild the prefix trie and therefore invalidate
    walk state for asynchronous walks (used in 'show route in' cmd). Fix it
    by adding locking that keeps the old trie in memory until current walks
    are done.
    
    In future this could be improved by rebuilding trie walk states (by
    lookup for last found prefix) after the prefix trie rebuild.

commit de6318f70a06854a324b436b3a4cca0b3d60024b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Feb 3 06:08:51 2022 +0100

    Nest: Implement prefix trie pruning
    
    When rtable is pruned and network fib nodes are removed, we also need to
    prune prefix trie. Unfortunately, rebuilding prefix trie takes long time
    (got about 400 ms for 1M networks), so must not be atomic, we have to
    rebuild a new trie while current one is still active. That may require
    some considerable amount of temporary memory, so we do that only if
    we expect significant trie size reduction.

commit ba5aec94cdf643350677f6b0ac4d335039c22396
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Feb 2 05:06:49 2022 +0100

    Trie: Add prefix counter
    
    Add counter of prefixes stored in trie. Works only for 'restricted' tries
    composed of explicit prefixes (pxlen == l == h), like ones used in rtables.

commit d0f9a77f641d44472679caf85b7bef6e13ce926a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Dec 31 18:42:50 2021 +0100

    Doc: Describe routing table options

commit 1f2eb2aca8e348fefc1822ec2adcad0cc97768d8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 20 20:25:35 2021 +0100

    BGP: Implement flowspec validation procedure
    
    Implement flowspec validation procedure as described in RFC 8955 sec. 6
    and RFC 9117. The Validation procedure enforces that only routers in the
    forwarding path for a network can originate flowspec rules for that
    network.
    
    The patch adds new mechanism for tracking inter-table dependencies, which
    is necessary as the flowspec validation depends on IP routes, and flowspec
    rules must be revalidated when best IP routes change.
    
    The validation procedure is disabled by default and requires that
    relevant IP table uses trie, as it uses interval queries for subnets.

commit 1ae42e522374ae60c23fe4c419c62b2209fbeea8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 22 04:32:26 2021 +0100

    Nest: Add routing table configuration blocks
    
    Allow to specify sorted flag, trie fla, and min/max settle time.
    
    Also do not enable trie by default, it must be explicitly enabled.

commit fde1cff0122ee9d68f141976395e7f89ba28c311
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 20 20:44:36 2021 +0100

    Nest: Add convenience functions to check rtable net type

commit 61375bd0b3803fada0d7bb5b81b5824bab16b7c1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Dec 2 04:05:17 2021 +0100

    Nest: Avoid unnecessary net_format() in 'show route' command
    
    When output of 'show route' command was generated, the net_format() was
    called for each network prematurely, even if the result was not needed.
    
    Fix the code to call net_format() only when needed. This makes queries
    that process many networks but show only few (e.g. 'show route where ..',
    or 'show route count') much faster (like 5x - 10x faster).

commit 9ac16df3d7239bc82d8016591755b41b14285608
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Dec 2 03:30:39 2021 +0100

    Nest: Add trie iteration code to 'show route'
    
    Add trie iteration code to rt_show_cont() CLI hook and use it to
    accelerate 'show route in <addr>' commands using interval queries.

commit ea97b8905197180bee5244bce378d03e4b741d88
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Dec 2 02:22:30 2021 +0100

    Nest: Implement 'show route in <addr>' command
    
    Implement 'show route in <addr>' command, which shows all routes in
    networks that are subnets of given network. Currently limited to IP
    network types.

commit 836a87b8acd5da40bde6b89702090c6616e06dfb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 29 19:23:42 2021 +0100

    Nest: Attach prefix trie to rtable for faster LPM and interval queries
    
    Attach a prefix trie to IP/VPN/ROA tables. Use it for net_route() and
    net_roa_check(). This leads to 3-5x speedups for IPv4 and 5-10x
    speedup for IPv6 of these calls.
    
    TODO:
     - Rebuild the trie during rt_prune_table()
     - Better way to avoid trie_add_prefix() in net_get() for existing tables
     - Make it configurable (?)

commit 4c6ee53f31a7ac667bc597b0fe19b6365abad415
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 28 18:13:18 2022 +0100

    BGP: Make routing loops silent
    
    One of previous commits added error logging of invalid routes. This
    also inadvertently caused error logging of route loops, which should
    be ignored silently. Fix that.

commit 963b2c7ce219df6bf9c179fff2dd2386cf26edf9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 28 05:35:22 2022 +0100

    BGP: Use proper class in attribute error messages
    
    Most error messages in attribute processing are in rx/decode step and
    these use L_REMOTE log class. But there are few that are in tx/export
    step and these should use L_ERR log class.
    
    Use tx-specific macro (REJECT()) in tx/export code and rename field
    err_withdraw to err_reject in struct bgp_export_state to ensure that
    appropriate error reporting macros are called in proper contexts.

commit 75d01ecc2d32f3f673f82d90552f17b753e5e739
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 28 05:03:03 2022 +0100

    BGP: Improve 'invalid next hop' error reporting
    
    Distinguish multiple causes of 'invalid next hop' message and report
    the relevant next hop address.
    
    Thanks to Simon Ruderich for the original patch.

commit 9dbb7eb6ebda016cd14ce8fef403c2b3f7bdd504
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jan 24 03:44:21 2022 +0100

    BGP: Log route updates that were changed to withdraws
    
    Typical BGP error handling is treat-as-withdraw, where an invalid route
    is replaced with a withdraw. Log route network when it happens.

commit a9646efd40569f3a1d749bc1bd13219876b33a00
Author: Matous Holinka <matous.holinka@nic.cz>
Date:   Thu Jan 6 09:53:23 2022 +0100

    .gitlab-ci.yml: minor changes inside the .yml file.
    
    + ubuntu:21.10 added into the pipeline,
    - ubuntu:20.10 removed from the pipeline,
    
    + misc/docker/ubuntu-21.10-amd64/Dockerfile added,
    - misc/docker/ubuntu-20.10-amd64/Dockerfile removed.

commit 81ee6cda2e60bbd3d97ab63da30657a54b09feda
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jan 17 05:11:29 2022 +0100

    Netlink: Add option to specify netlink socket receive buffer size
    
    Add option 'netlink rx buffer' to specify netlink socket receive buffer
    size. Uses SO_RCVBUFFORCE, so it can override rmem_max limit.
    
    Thanks to Trisha Biswas and Michal for the original patches.

commit bbc33f6ec310d98b9100fb883a2b8908ede1b5a8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Jan 15 22:39:40 2022 +0100

    Netlink: Add another workaround for older kernel headers
    
    Unfortunately, SOL_NETLINK is both recently added and arch-dependent,
    so we cannot just define it.

commit 8988264a64dc9985303332568832b108dba3acd3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 14 23:15:05 2022 +0100

    Netlink: Add workaround for older kernel headers

commit e818f16448e918ed07633480291283f3449dd9e4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 14 21:53:40 2022 +0100

    Netlink: Enable strict checking for KRT dumps
    
    Add strict checking for netlink KRT dumps to avoid PMTU cache records
    from FNHE table dump along with KRT.
    
    Linux Kernel added FNHE table dump to the netlink API in patch:
    
    https://patchwork.ozlabs.org/project/netdev/patch/8d3b68cd37fb5fddc470904cdd6793fcf480c6c1.1561131177.git.sbrivio@redhat.com/
    
    Therefore, since Linux 5.3 these route cache entries are dumped together
    with regular routes during periodic KRT scans, which in some cases may be
    huge amount of useless data. This can be avoided by using strict checking
    for netlink dumps:
    
    https://lore.kernel.org/netdev/20181008031644.15989-1-dsahern@kernel.org/
    
    The patch mitigates the risk of receiving unknown and potentially large
    number of FNHE records that would block BIRD I/O in each sync. There is a
    known issue caused by the GRE tunnels on Linux that seems to be creating
    one FNHE record for each destination IP address that is routed through
    the tunnel, even when the PMTU equals to GRE interface MTU.
    
    Thanks to Tomas Hlavacek for the original patch.

commit d0dd1d20cd40e75e417d58569fac3ff0bf1db41a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 14 19:07:57 2022 +0100

    Netlink: Explicitly skip received cloned routes
    
    Kernel uses cloned routes to keep route cache entries, but reports them
    together with regular routes. They were skipped implicitly as they
    do not have rtm_protocol filled. Add explicit check for cloned flag
    and skip such routes explicitly.
    
    Also, improve debug logs of skipped routes.

commit 60e9def9ef7b5d16f868b0fb4ab1192d59fd7541
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jan 9 02:40:58 2022 +0100

    BGP: Add option 'free bind'
    
    The BGP 'free bind' option applies the IP_FREEBIND/IPV6_FREEBIND
    socket option for the BGP listening socket.
    
    Thanks to Alexander Zubkov for the idea.

commit 87a02489f3880689a4e2ad72b0b981649dad2154
Author: Alexander Zubkov <green@qrator.net>
Date:   Sat Jan 8 18:31:56 2022 +0100

    IO: Support nonlocal bind in socket interface
    
    Add option to socket interface for nonlocal binding, i.e. binding to an
    IP address that is not present on interfaces. This behaviour is enabled
    when SKF_FREEBIND socket flag is set. For Linux systems, it is
    implemented by IP_FREEBIND socket flag.
    
    Minor changes done by commiter.

commit bcb25084d31fdb90fcf1666f10e73fe0f863afc0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 5 20:07:27 2022 +0100

    Test: Activate some remaining build tests

commit f5c8fb5fba959d356ce1ea0fb5879223f76137f7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 5 19:25:42 2022 +0100

    Netlink: Do not ignore dead routes from BIRD
    
    Currently, BIRD ignores dead routes to consider them absent. But it also
    ignores its own routes and thus it can not correctly manage such routes
    in some cases. This patch makes an exception for routes with proto bird
    when ignoring dead routes, so they can be properly updated or removed.
    
    Thanks to Alexander Zubkov for the original patch.

commit 77d032c71f62e44293a10ccc22f8c157442df179
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 5 18:46:41 2022 +0100

    Netlink: Improve multipath parsing errors
    
    Function nl_parse_multipath() should handle errors internally.

commit 29dda184e56ce3a1ec72db4612198f6b3ba84e82
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 5 16:38:49 2022 +0100

    Conf: Fix parsing full-length IPv6 addresses
    
    Lexer expression for bytestring was too loose, accepting also
    full-length IPv6 addresses. It should be restricted such that
    colon is used between every byte or never.
    
    Fix the regex and also add some test cases for it.
    
    Thanks to Alexander Zubkov for the bugreport

commit 75aceadaf746f8ed0acce0424f89903283dacf16
Author: Matous <bralor92@email.cz>
Date:   Thu Oct 14 12:16:46 2021 +0200

    gitlab-ci.yml: failing gitlab runner fixed.
    
    'registry.labs.nic.cz' -> 'registry.nic.cz' changed

commit 77042292ff1ebeb5451f3a4119c3cbde0629f5b1
Author: Alexander Zubkov <green@qrator.net>
Date:   Tue Dec 28 04:09:36 2021 +0100

    Doc: Document min/max operators for lists

commit 0e1fd7ea6af8aaeb68a23e320c2a0a0a8480d6de
Author: Alexander Zubkov <green@qrator.net>
Date:   Tue Dec 28 04:05:05 2021 +0100

    Filter: Add operators to find minimum and maximum element of sets
    
    Add operators .min and .max to find minumum or maximum element in sets
    of types: clist, eclist, lclist. Example usage:
    
    bgp_community.min
    bgp_ext_community.max
    filter(bgp_large_community, [(as1, as2, *)]).min
    
    Signed-off-by: Alexander Zubkov <green@qrator.net>

commit e15e465720c428e765ab88fd587afb4f4f5d70ae
Author: Alexander Zubkov <green@qrator.net>
Date:   Tue Dec 28 03:48:42 2021 +0100

    Doc: Document community components access operators

commit a2a268da4f0c05012d691b57f9b358e3f35ef121
Author: Alexander Zubkov <green@qrator.net>
Date:   Tue Dec 28 03:46:13 2021 +0100

    Filter: Add operators to pick community components
    
    Add operators that can be used to pick components from
    pair (standard community) or lc (large community) types.
    For example:
    
    (10, 20).asn --> 10
    (10, 20).data --> 20
    
    (10, 20, 30).asn --> 10
    (10, 20, 30).data1 --> 20
    (10, 20, 30).data2 --> 30
    
    Signed-off-by: Alexander Zubkov <green@qrator.net>

commit a39cd2cc0b0c64235457c07e2b618318bbdfcacd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 27 19:10:35 2021 +0100

    BSD: Assume onlink flag on ifaces with only host addresses
    
    The BSD kernel does not support the onlink flag and BIRD does not use
    direct routes for next hop validation, instead depends on interface
    address ranges. We would like to handle PtMP cases with only host
    addresses configured, like:
    
      ifconfig wg0 192.168.0.10/32
      route add 192.168.0.4 -iface wg0
      route add 192.168.0.8 -iface wg0
    
    To accept BIRD routes with onlink next-hop, like:
    
      route 192.168.42.0/24 via 192.168.0.4%wg0 onlink
    
    BIRD would dismiss the route when receiving from the kernel, as the
    next-hop 192.168.0.4 is not part of any interface subnet and onlink
    flag is not kept by the BSD kernel.
    
    The commit fixes this by assuming that for routes received from the
    kernel, any next-hop is onlink on ifaces with only host addresses.
    
    Thanks to Stefan Haller for the original patch.

commit b9f38727a7ba7c9c7e383ade80dbf77086dfce05
Author: Job Snijders <job@fastly.com>
Date:   Sat Dec 18 16:35:28 2021 +0100

    RPKI: Add contextual out-of-bound checks in RTR Prefix PDU handler
    
    RFC 6810 and RFC 8210 specify that the "Max Length" value MUST NOT be
    less than the Prefix Length element (underflow). On the other side,
    overflow of the Max Length element also is possible, it being an 8-bit
    unsigned integer allows for values larger than 32 or 128. This also
    implicitly ensures there is no overflow of "Length" value.
    
    When a PDU is received where the Max Length field is corrputed, the RTR
    client (BIRD) should immediately terminate the session, flush all data
    learned from that cache, and log an error for the operator.
    
    Minor changes done by commiter.

commit 00410fd6c17697a5919cb32a44f7117dd3a0834a
Author: Simon Ruderich <simon@ruderich.org>
Date:   Sat Dec 18 03:17:48 2021 +0100

    Doc: bgp: remove "advertise ipv4"
    
    The option was removed in d15b0b0a ("BGP redesign", 2016-12-07)
    but the documentation wasn't updated.

commit b21104c97e59128973501fc23570e2d929f48923
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Dec 18 00:58:47 2021 +0100

    Nest: Do not ignore secondary flag changes in ifa updates
    
    Compare all IA_* flags that are set by sysdep iface code.
    
    The old code ignores IA_SECONDARY flag when comparing whether iface
    address updates from kernel changed anything. This is usually not an
    issue as kernel removes all secondary addresses due to removal of the
    primary one, but it breaks when sysctl 'promote_secondaries' is enabled
    and kernel promotes secondary addresses to primary ones.
    
    Thanks to 'Alexander' for the bugreport.

commit 78ddfd2600a31305a78dc205b65deba6fb2e0240
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 29 19:00:24 2021 +0100

    Trie: Clarify handling of less-common net types
    
    For convenience, Trie functions generally accept as input values not only
    NET_IPx types of nets, but also NET_VPNx and NET_ROAx types. But returned
    values are always NET_IPx types.

commit f772afc525156498900770ffe5a98349df89a45c
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Nov 27 00:21:12 2021 +0100

    Memory statistics split into Effective and Overhead
    
    This feature is intended mostly for checking that BIRD's allocation
    strategies don't consume much memory space. There are some cases where
    withdrawing routes in a specific order lead to memory fragmentation and
    this output should give the user at least a notion of how much memory is
    actually used for data storage and how much memory is "just allocated"
    or used for overhead.
    
    Also raising the "system allocator overhead estimation" from 8 to 16
    bytes; it is probably even more. I've found 16 as a local minimum in
    best scenarios among reachable machines. I couldn't find any reasonable
    method to estimate this value when BIRD starts up.
    
    This commit also fixes the inaccurate computation of memory overhead for
    slabs where the "system allocater overhead estimation" was improperly
    added to the size of mmap-ed memory.

commit 14fc24f3a53ebc5525b854ccdc93274aa74a400f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Nov 26 03:26:36 2021 +0100

    Trie: Implement longest-prefix-match queries and walks
    
    The prefix trie now supports longest-prefix-match query by function
    trie_match_longest_ipX() and it can be extended to iteration over all
    covering prefixes for a given prefix (from longest to shortest) using
    TRIE_WALK_TO_ROOT_IPx() macro.

commit 644e9ca94e2d10ba0c2de45f94523da2414328e3
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Nov 24 17:30:13 2021 +0100

    Directly mapped pages are kept for future use if temporarily not needed

commit 062e69bf520e5788913bdd564076ad9892b24a87
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Nov 19 18:04:32 2021 +0100

    Trie: Implement trie walking code
    
    Trie walking allows enumeration of prefixes in a trie in the usual
    lexicographic order. Optionally, trie enumeration can be restricted
    to a chosen subnet (and its descendants).

commit 71c18d9f53ec0ea5eb512fdb6510d0c3350f96b4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Nov 13 21:11:18 2021 +0100

    Trie: Simplify network matching code
    
    Introduce ipX_prefix_equal() and use it to simplify network matching code.

commit 60880b539b8886f76961125d89a265c6e1112b7a
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Nov 9 17:42:36 2021 +0100

    Extended route trace: logging Path Identifiers

commit 9f24fef5e91fb4df301242ede91ee7ac1b46b8a8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Oct 20 01:51:28 2021 +0200

    Conf: Fix crash during shutdown
    
    BIRD implements shutdown by reconfiguring to fake empty configuration.
    Such fake config structure is created from the last running config and
    shares some data, including symbol table. This allows access to (removed)
    routing tables and causes crash when 'show route' command is used during
    shutdown.
    
    Clean up symbol table, table list and links to default tables, so removed
    routing tables cannot be accessed during shutdown.

commit 0b295d695acab007dd7baab3e9e97c682f716ee8
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Sep 14 11:20:16 2021 +0200

    Dropping the unused rte_same hook

commit 89ff49f8f0bcd2015f157134728d28ec428e1262
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 17 12:42:14 2020 +0100

    Dropping rte-local dumper entries

commit e42eedb912428aa9af450b0426e53b0a7004dfb1
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Feb 13 16:59:53 2020 +0100

    Kernel: Convert the rte-local attributes to extended attributes and flags to pflags

commit 5cff1d5f022755df61af6fc21cc4f2e5d384404e
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Apr 10 17:08:29 2020 +0200

    Route: moved rte_src pointer from rta to rte
    
    It is an auxiliary key in the routing table, not a route attribute.

commit d5a32563df1653952937117133f09143929ff0c2
Author: Maria Matejka <mq@jmq.cz>
Date:   Sun Apr 12 21:54:20 2020 +0200

    Preexport: No route modification, no linpool needed

commit 541881bedf391d9a19f071b856dcbd55e850dece
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Sep 16 11:00:19 2021 +0200

    RIP fixup + dropping the tmp_attrs mechanism as obsolete

commit 3660f19dd534224da4870a507efcef5b36794506
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 17 11:18:32 2020 +0100

    Dropping the RTS_DUMMY temporary route storage.
    
    Kernel route sync is done by other ways now and this code is not used
    currently.

commit eb937358c087eaeb6f209660cc7ecfe6d6eff739
Author: Maria Matejka <mq@jmq.cz>
Date:   Mon Feb 10 08:41:05 2020 +0100

    Preference moved to RTA and set explicitly in protocols

commit cee0cd148c9b71bf47d007c850193b5fbf9486c1
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Mar 20 21:16:12 2021 +0100

    Export table: Delay freeing of old stored route.
    
    This is needed to provide the protocols the full old route after filters
    when export table is enabled.

commit ddd89ba12d03d648e9bb820c6a4f48b1f96f15d2
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 10 15:01:36 2020 +0100

    BGP: Moved the suppressed and stale flags to pflags

commit c507fb41bb2e62f336357121598debab95a7c767
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Feb 13 13:22:15 2020 +0100

    Babel: Convert the rte-local attributes to extended attributes

commit 8216ec3027d01b790e59a266227d378ba77a623e
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Sep 8 15:30:09 2021 +0000

    There may be a symbol with NULL protocol when reconfiguring

commit 5f0cb61d82315035a3a7f10eef510884da9f94c6
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Feb 11 21:24:15 2020 +0100

    OSPF: Convert the rte-local attributes to extended attributes

commit 8ac20511e17af14d62cd84fcc4e460474820a584
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Sep 8 08:33:25 2021 +0000

    Show route may be accidentally called on shutdown also when not all default tables are present

commit a0e4c66404681c5613ef7f6e80f8b8c3022446d4
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Sep 14 20:12:33 2021 +0200

    RIP: convert the rte-local attributes to extended attributes

commit 6e13df70fdaeb0f08ae5171f62240402501783ea
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Sep 14 19:53:03 2021 +0200

    Extended route attributes may include also pointers

commit d471d5fc7ce587ed836ca7fa10a79331bc181d45
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Mar 20 23:18:34 2021 +0100

    IGP metric getter refactoring to protocol callback
    
    Direct protocol hooks for IGP metric inside nest/rt-table.c make the
    protocol API unnecessarily complex. Instead, we use a proper callback.

commit a54f75f454b7ed8c8ff2c1787a506528f22cbae7
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Oct 13 19:08:35 2021 +0200

    fixup! Multipage allocation

commit 6cd37713781a3092f8166b2178fae35cbfec1e28
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Sep 8 11:29:49 2021 +0200

    Multipage allocation
    
    We can also quite simply allocate bigger blocks. Anyway, we need these
    blocks to be aligned to their size which needs one mmap() two times
    bigger and then two munmap()s returning the unaligned parts.
    
    The user can specify -B <N> on startup when <N> is the exponent of 2,
    setting the block size to 2^N. On most systems, N is 12, anyway if you
    know that your configuration is going to eat gigabytes of RAM, you are
    almost forced to raise your block size as you may easily get into memory
    fragmentation issues or you have to raise your maximum mapping count,
    e.g. "sysctl vm.max_map_count=(number)".

commit 3a31c3aad6c53ea9673743f983e13728d8551149
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Sep 7 16:22:32 2021 +0000

    CLI socket accept() may also fail and should produce some message, not a coredump.

commit d322ee3d548a87d6e996dd20b2b415aad4b53f62
Author: Maria Matejka <mq@ucw.cz>
Date:   Sun Sep 5 13:00:08 2021 +0200

    OSPF: explicitly stop the periodic tick on shutdown to avoid recalculation races

commit e5a8eec6d720408139d0a209ef149848c5dcfbe3
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Sep 3 19:48:38 2021 +0200

    Linpools may use pages instead of xmalloc

commit bea582cbb53e30dd32a5b6829c7443e0e5558d11
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Oct 13 18:59:45 2021 +0200

    fixup! Bound allocated pages to resource pools with page caches to avoid unnecessary syscalls

commit 067f69a56de0e0e61d423ec5aa68095aa28e3124
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Sep 25 16:00:30 2021 +0200

    Filter: Add prefix trie benchmarks
    
    Add trie tests intended as benchmarks that use external datasets
    instead of generated prefixes. As datasets are not included, they
    are commented out by default.

commit e709dc09e61c4604821d10b81604d38616b81a0b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 21 13:49:29 2020 +0200

    Filter: Improve prefix trie tests
    
    Add tests explicitly matching insides and outsides of trie and update
    tests to do testing of both IPv4 and IPv6 tries.

commit dd61278c9db1d4bea29f0a21aa460c7fe931eb32
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Apr 6 14:20:16 2020 +0200

    Filter: Update trie documentation

commit 562a2b8c29a50cca5731b0a19e99a87a261ab4ef
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 5 03:56:07 2020 +0200

    Filter: Fix trie test
    
    Generated prefixes must be valid.

commit 13225f1dbff54619476f2d8f6bc779dbb4983e3e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 5 03:24:46 2020 +0200

    Filter: Faster prefix sets
    
    Use 16-way (4bit) branching in prefix trie instead of basic binary
    branching. The change makes IPv4 prefix sets almost 3x faster, but
    with more memory consumption and much more complicated algorithm.
    
    Together with a previous filter change, it makes IPv4 prefix sets
    about ~4.3x faster and slightly smaller (on my test data).

commit 7f0e59820899c30a243c18556ce2e3fb72d6d221
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Sep 1 00:46:46 2021 +0200

    Bound allocated pages to resource pools with page caches to avoid unnecessary syscalls

commit 2c13759136951ef0e70a3e3c2b2d3c9a387f7ed9
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 25 22:20:48 2021 +0200

    Reducing filter stack size to allow for lesser thread stack size

commit ceef6de459b25d8fcc5dd416e0cecf179bd243e7
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu May 27 10:35:38 2021 +0200

    OSPF: Setting a list node NULL before use

commit 923a6644b206f70435c3d01b93b6880701938b49
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu May 27 10:35:33 2021 +0200

    Fixed memory poisoning in slab

commit 227e2d5541e86210b383c8e8054805692ad3cf14
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed May 26 16:42:02 2021 +0200

    Debug output uses local buffer to avoid clashes between threads.

commit eb2025165546d12114ca5ca4f2b338765f338af6
Author: Maria Matejka <mq@jmq.cz>
Date:   Mon Apr 27 22:33:10 2020 +0200

    Filter: Additional consistency checks

commit 47d92d8f9d9891a9b40f3fbef1d762537af4ae25
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jun 17 16:56:51 2021 +0200

    Nest: Clean up main channel handling
    
    Remove assumption that main channel is the only channel.

commit f761be6b30633054a54369eee7d08b951a366e5e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jun 17 16:56:51 2021 +0200

    Nest: Clean up main channel handling
    
    Remove assumption that main channel is the only channel.

commit 1b9bf4e192a252db861acadc7f800d7046435a3f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jun 14 20:02:50 2021 +0200

    Nest: Fix export of tmpattrs through pipes
    
    Pipes copy the original rte with old values, so they require rte to be
    exported with stored tmpattrs. Other protocols access stored attributes
    using eattr list, so they require rte to be exported with expanded
    tmpattrs. This is temporary hack, we plan to remove whoe tmpattr mechanism.
    
    Thanks to Paul Donohue for the bugreport.

commit 3ebabab2778d05212cc07ebccf583159d5e0890a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jun 14 17:58:37 2021 +0200

    Revert "Nest: Fix export of tmpattrs through pipes"
    
    This reverts commit f8e273b5e7a3c721f4a30cf27a0b4fe54602e83f.

commit f8e273b5e7a3c721f4a30cf27a0b4fe54602e83f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jun 14 16:30:59 2021 +0200

    Nest: Fix export of tmpattrs through pipes
    
    In most cases of export there is no need to store back temporary
    attributes to rte, as receivers (protocols) access eattr list anyway.
    But pipe copies the original rte with old values, so we should store
    tmpattrs also during export.
    
    Thanks to Paul Donohue for the bugreport.

commit 3f19100f5a47dce96d336d68e0cbe72de5d9ba60
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jun 11 01:31:10 2021 +0200

    CI: Allow Babel tests

commit 596f2e32e38bef076001f4b9a4c75b07fd0264b7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 9 19:54:01 2021 +0200

    Nest: Allow both 'password' and 'key' keywords for authentication keys

commit 6d26f853951675bd188dbf88d539ccb9d02d7eb1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 9 19:31:55 2021 +0200

    Babel: Simplify auth expiration
    
    Just use hello_expiry for that, keep init_expiry for initial
    unauthentized neighbors.

commit 8eea396baf2bd73ea846a48e82d5c42fc2aec6d5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 6 19:10:33 2021 +0200

    Nest: Fix password list parsing code
    
    One of previous patches broke password list parsing code, fix that.

commit ee9516dbe85b7205c6c8e400780c5a25787d6bff
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 6 17:23:45 2021 +0200

    Lib: Fix static assert macro

commit b174cc0abc0a9d7e84cc6fae46d9e19b714fbcfb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 6 15:22:59 2021 +0200

    Babel: Add MAC authentication support - update
    
    Some cleanups and bugfixes to the previous patch, including:
    
     - Fix rate limiting in index mismatch check
    
     - Fix missing BABEL_AUTH_INDEX_LEN in auth_tx_overhead computation
    
     - Fix missing auth_tx_overhead recalculation during reconfiguration
    
     - Fix pseudoheader construction in babel_auth_sign() (sport vs fport)
    
     - Fix typecasts for ptrdiffs in log messages
    
     - Make auth log messages similar to corresponding RIP/OSPF ones
    
     - Change auth log messages for events that happen during regular
       operation to debug messages
    
     - Switch meaning of babel_auth_check*() functions for consistency
       with corresponding RIP/OSPF ones
    
     - Remove requirement for min/max key length, only those required by
       given MAC code are enforced

commit b218a28f61e1e9a93c3a4f2e180590f85df62e79
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Sat Apr 17 15:04:16 2021 +0200

    Babel: Add MAC authentication support
    
    This implements support for MAC authentication in the Babel protocol, as
    specified by RFC 8967. The implementation seeks to follow the RFC as close
    as possible, with the only deliberate deviation being the addition of
    support for all the HMAC algorithms already supported by Bird, as well as
    the Blake2b variant of the Blake algorithm.
    
    For description of applicability, assumptions and security properties,
    see RFC 8967 sections 1.1 and 1.2.

commit 69d10132a6020e00ea2e8f899fdebf8128329699
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Thu Apr 15 20:15:53 2021 +0200

    Babel: Refactor TLV parsing code for easier reuse
    
    In preparation for adding authentication checks, refactor the TLV
    walking code so it can be reused for a separate pass of the packet
    for authentication checks.

commit 589f7d1e4f3aaca3fec6c38474bb962a9c578ebe
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Thu Apr 15 04:38:49 2021 +0200

    Nest: Allow MAC algorithms to specify min/max key length
    
    Add min/max key length fields to the MAC algorithm description and
    validate configured keys before they are used.

commit 35f88b305ab6a0e27b5ff1b445f63f544986e14e
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Wed Apr 14 21:39:43 2021 +0200

    Nest: Allow specifying security keys as hex bytes as well as strings
    
    Add support for specifying a password in hexadecimal format, The result
    is the same whether a password is specified as a quoted string or a
    hex-encoded byte string, this just makes it more convenient to input
    high-entropy byte strings as MAC keys.

commit f1a824190c22f8159ad0f9378c2dd23e521eaf61
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Wed Apr 14 20:00:03 2021 +0200

    Lib: Add tests for blake2s and blake2b
    
    Import the blake2-kat.h header with test vector output from the blake
    reference implementation, and add tests to mac_test.c to compare the
    output of the Bird MAC algorithm implementations with that reference
    output.
    
    Since the reference implementation only has test vectors for the full
    output size, there are no tests for the smaller-sized output variants.

commit 725d9af94a6eaf3cbce1b107e36c8cf342828ea6
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Sat Apr 10 17:33:28 2021 +0200

    Lib: Add Blake2s and Blake2b hash functions
    
    The Babel MAC authentication RFC recommends implementing Blake2s as one of
    the supported algorithms. In order to achieve do this, add the blake2b and
    blake2s hash functions for MAC authentication. The hashing function
    implementations are the reference implementations from blake2.net.
    
    The Blake2 algorithms allow specifying an arbitrary output size, and the
    Babel MAC spec says to implement Blake2s with 128-bit output. To satisfy
    this, we add two different variants of each of the algorithms, one using
    the default size (256 bits for Blake2s, 512 bits for Blake2b), and one
    using half the default output size.
    
    Update to BIRD coding style done by committer.

commit e5724f71d2c054bc51d66092beb6af4da21e0c62
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Apr 8 01:15:17 2021 +0200

    sysdep: Add wrapper to get random bytes - update
    
    Simplify the code and fix an issue with getentropy() return value.

commit c48ebde5ce6db3da8cd571d213d1a1f265de8983
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Thu Apr 1 19:20:13 2021 +0200

    sysdep: Add wrapper to get random bytes
    
    Add a wrapper function in sysdep to get random bytes, and required checks
    in configure.ac to select how to do it. The configure script tries, in
    order, getrandom(), getentropy() and reading from /dev/urandom.

commit 91d04583891f7a6f4aee612cf3f143cc84a73991
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jun 1 01:59:20 2021 +0200

    BGP: Ensure that freed neighbor entry is not accessed
    
    Routes from downed protocols stay in rtable (until next rtable prune
    cycle ends) and may be even exported to another protocol. In BGP case,
    source BGP protocol is examined, although dynamic parts (including
    neighbor entries) are already freed. That may lead to crash under some
    race conditions. Ensure that freed neighbor entry is not accessed to
    avoid this issue.

commit ebd5751cdeb4c753c6c9df31b82dcd6afee2cd39
Author: Maria Matejka <mq@ucw.cz>
Date:   Sun May 30 13:07:16 2021 +0200

    Babel: Seqno requests are properly decoupled from neighbors when the underlying interface disappears
    
    When an interface disappears, all the neighbors are freed as well. Seqno
    requests were anyway not decoupled from them, leading to strange
    segfaults. This fix adds a proper seqno request list inside neighbors to
    make sure that no pointer to neighbor is kept after free.

commit 10498b8e89a4509bdd447bd14f07a3b3e35ae575
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed May 26 18:57:32 2021 +0200

    OSPF: Fix OSPFv3 in IPv4 mode with multiple areas
    
    Some area handling code got confused by IPv4 setup in OSPFv3 mode.

commit 8650e26dd1566032d587a654376092a9f31a1123
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu May 20 15:02:48 2021 +0200

    CI: Try different locale for Centos 7

commit 0c4dca7ffd2957cca3635d607cb4acc8dfd4af90
Author: Matous Holinka <bralor92@email.cz>
Date:   Wed May 19 19:10:09 2021 +0200

    CI: Package build for more platforms
    
    .gitlab-ci.yml:
    + pkg targets for some distros added
    + artifacts added
    - some distros were commented out (due to errors).
    
    misc/docker/*:
    + Dockerfiles updated with the necessary packages.

commit 98ef34c0c77d49d766def88f263dab0e91817288
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 19:52:19 2021 +0200

    CI: Try utf-8 locale to workaround apkg issue

commit 445d0e699f2b98e5a892c812af9f021671920c1b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 11:24:46 2021 +0200

    CI: Build documentation where tools are available

commit 656c744080d308f75cc9707b139e2a3ec31ad5b7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 03:37:54 2021 +0200

    CI: Update docker images for building of documentation

commit 5ea3c5bfee6ed24139bc8e82cc35f08c49d6aaff
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 03:07:25 2021 +0200

    Pkg: Enable docs subpackage for Debian

commit 81666d2f126b94e99042ed963e45de5a95f63df5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Apr 23 00:20:36 2021 +0200

    CI: Test of apkg build
    
    Also temporarily disable cf-ospf-auth, as there is some problem with it.

commit 312aeda393f9775f603a78c7feb0a11f3c789c02
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Apr 22 19:23:18 2021 +0200

    Tools: Improve make-dev-archive
    
    Use git-archive to avoid unrelated and temporary files and fix some
    minor issues (e.g. dependency on bash as system shell).

commit 280d133a9b50dab88d51871927f26cd967211f85
Author: Jakub Ružička <jakub.ruzicka@nic.cz>
Date:   Tue Apr 13 20:29:11 2021 +0200

    ubuntu: use any init-system-helpers
    
    init-system-helpers (>= 1.56~) can't be satisfied on:
    
    * Ubuntu 18.04 (1.51)
    * Ubuntu 16.04 (1.29)
    * Debian 9 (1.48)
    
    Remove the specific version requirement in order to enable build on
    older platforms.

commit 53cabf94f8de41f740ed08456877f6b8b5889170
Author: Jakub Ružička <jakub.ruzicka@nic.cz>
Date:   Fri Apr 9 18:36:25 2021 +0200

    suse: fix bird.spec to work on SUSE
    
    SUSE is more strict about .spec.
    
    * use SPDX license id
    * add missing %ghost file directive

commit 60167856af243f5683840d7365493ed0b3fa6cd0
Author: Jakub Ružička <jakub.ruzicka@nic.cz>
Date:   Fri Apr 9 16:35:10 2021 +0200

    docs: disable docs subpackage to fix FTBFS
    
    Adressing following FTBFS on all older debian/ubuntu distros:
    
        Can't locate LinuxDocTools/Data/Latin1ToSgml.pm in @INC (you may need to install the LinuxDocTools::Data::Latin1ToSgml module)

commit 329d6e3fbc5a09a9bc8800bd8a5d239dec1a3d24
Author: Jakub Ružička <jakub.ruzicka@nic.cz>
Date:   Tue Apr 6 18:13:16 2021 +0200

    add apkg-powered upstream packaging for deb, rpm
    
    Files in a single new distro/ dir allow apkg to build BIRD packages for
    various distros directly from upstream sources as well as from upstream
    archives.
    
    Please see distro/README.md for more detail as well as apkg docs:
    
    https://apkg.rtfd.io
    
    I've used these files to build bird-2.0.8 on all currently supported
    releases of following distros:
    
    * Debian
    * Ubuntu
    * Fedora
    * CentOS
    * openSUSE
    
    Please note that latest apkg with accumulated fixes for bird is needed:
    https://gitlab.nic.cz/packaging/apkg/-/merge_requests/35

commit c3c691e95cd40d8654b720be8d9a8ae9fb050951
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 18 20:41:01 2021 +0200

    Flowspec: Documentation update

commit abc9ccc5cb7a3adcbb2090ba7314031b835b0e04
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 18 20:18:06 2021 +0200

    Flowspec: Label field should use numeric operator and not bitmask operator

commit dd8481cc1c92af32ec69cded42b985b7bad40b26
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 18 19:54:18 2021 +0200

    Flowspec: Do not use comma for bitmask operators
    
    For numeric operators, comma is used for disjunction in expressions like
    "10, 20, 30..40". But for bitmask operators, comma is used for
    conjunction in a way that does not really make much sense. Use always
    explicit logical operators (&& and ||) to connect bitmask operators.
    
    Thanks to Matt Corallo for the bugreport.

commit e5468d16855600aeb8172e29936789c46ea58da0
Author: Trisha Biswas <tbiswas@fastly.com>
Date:   Mon May 17 17:50:04 2021 +0200

    Filter: Add MPLS label route attribute
    
    Add support to set or read outgoing MPLS labels using filters. Currently
    this supports the addition of one label per route for the first next hop.
    
    Minor changes by committer.

commit d114959e3aeef872441dccea34552047380af742
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri May 14 18:44:52 2021 +0200

    Flowspec: Fix values for true/false operators
    
    RFC 8955 is pretty clear that 000 is false and 111 is true.

commit 69a33c92ffce12d173794508cc9d8acfa87d1dc3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri May 14 18:33:15 2021 +0200

    Flowspec: Add code for conversion of flowspec parts to interval lists
    
    Implement function flow_explicate_part() to convert flowspec numeric
    expressions to a simple list of (disjoint, sorted) intervals. That could
    be used in filters to build f_tree-based int-sets from them.

commit c1511b92cc9c215224314be38c28ed80843f55e4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon May 10 20:09:31 2021 +0200

    Babel: Log the reason when refusing to run on an interface
    
    The babel protocol code checks whether iface supports multicast, and
    whether it has a link-local address assigned. However, it doesn not give
    any feedback if any of those checks fail, it just silently ignores the
    interface. Fix this by explicitly logging when multicast check fails.
    
    Based on patch from Toke Høiland-Jørgensen, thanks!

commit b17adf073594974b05a60ddaaa6e36da4eac4831
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Mon May 10 19:49:43 2021 +0200

    BSD: Propagate OS-level IFF_MULTICAST to internal IF_MULTICAST flag
    
    The BSD code did not propagate the OS-level IFF_MULTICAST flag to the
    Bird-internal IF_MULTICAST flag, which causes problems with Wireguard
    interfaces on FreeBSD. The Linux sysdep code does propagate the flag
    already, so just copy over the same check and flag update.

commit 2a0af925b83f699d126cf0e733a49c75ffd86033
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon May 10 13:39:55 2021 +0200

    OSPF: Allow ifaces with host address as unnumbered PtP or PtMP ifaces
    
    Ifaces with host address (/32) were forced to be stubby, but now they
    can be used as PtP or PtMP. For these ifaces we need to:
    
     - Do not force stub mode
     - Accept packets from any IP as local
     - Accept any configured neighbor as local
     - Detect ifaces properly as unnumbered
     - Use ONLINK flag for nexthops

commit bc591061f618cdc35cf21c7973a660f8d7018b43
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun May 9 15:16:13 2021 +0200

    OSPF: Packets on PtP networks should be always sent to AllSPFRouters
    
    As specified in RFC 2328 8.1: "On physical point-to-point networks,
    the IP destination is always set to the address AllSPFRouters."
    
    Note that this likely break setups with multiple neighbors on a network
    configured as PtP, which worked before. These should be configured as
    PtMP.
    
    Thanks to Senthil Kumar Nagappan for the original patch and to Joakim
    Tjernlund for suggestions.

commit 1647923bd8d2f8e53337365abc5be7e343aa570c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun May 9 14:51:39 2021 +0200

    OSPF: Minor refactoring of packet sending code
    
    Common behavior for LSupd and delayed LSack moved to ospf_send_to_iface()
    and other minor changes.

commit 255722e0fcf251c101ff5bec92f1867edf841daa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 02:34:46 2021 +0200

    CI: Fix debian-10-i386 docker file

commit 58510024bead8df9cba6e316f8275423a38fd51b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Apr 25 01:07:14 2021 +0200

    Doc: Include full LinuxDocTools code
    
    BIRD uses hacked LinuxDocTools for building documentation, keeping some
    parts locally and using remaining parts from system-installed one. This
    setup breaks when LinuxDocTools makes some internal changes and is hard
    to keep consistent.
    
    Just include full LinuxDocTools code (both hacked and unmodified parts)
    to avoid consistency issues. Note that we still need some binaries from
    LinuxDocTools, so it still needs to be installed to build documentation.

commit b646c0098120bbb10ec91fa2fbf1df416c5849bd
Author: Matous <bralor92@email.cz>
Date:   Wed Apr 21 13:22:23 2021 +0200

    CI/CD: some latest releases added.
    
    /misc/docker/:
    + debian 11 (i386+amd64) added,
    + fedora 32 added,
    + fedora 33 added,
    + fedora 34 added,
    + opensuse 15.2 added,
    + opensuse 15.3 added,
    + ubuntu 20.04 added,
    + ubuntu 20.10 added,
    + ubuntu 21.04 added,
    - ubuntu 19.10 removed.
    
    /.gitlab-ci.yml:
    + stages 'image' and 'build' updated.

commit 3d90241f62393e6d614c1d20fde4013c9ff24685
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Apr 19 15:13:20 2021 +0200

    Internal route tables have a reduced cleanup routine
    
    This fixes an internal table cleanup bug introduced
    in ff397df7edcbe7a8abca5b419729b9c64c063847.

commit a7c9515ebc88c42f26ce97255c98b2e61ad52934
Author: Stefan Haller <stefan.haller@stha.de>
Date:   Mon Apr 19 15:06:42 2021 +0200

    BSD: Fix invalid pointer derefence in logging code
    
    For logging purposes a stack allocated net_addr struct was passed by
    value as vararg (instead of the expected pointer). This resulted in
    a segfault when the specific error condition got logged.

commit 9c41e1ca3e93d4498eaa085139caf1545e08c1d8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Apr 12 17:01:31 2021 +0200

    Lib: Fix handling of buffers in timestamp formatting
    
    The code in tm_format_real_time() mixed up two buffers and their
    sizes, which may cause crash in MRT dumping code.
    
    Thanks to Piotr Wydrych for the bugreport.

commit a2277975d787fb388e753432673acefd69454b1a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Apr 7 16:14:20 2021 +0200

    Unix: Expand accepted ranges of iproute2 constants
    
    We support 32bit table and realm/flow ids, we should also accept them as
    constants.
    
    Thanks to Patrick Hemmer for the bugreport.

commit 5caf32efa209bc3e9d741fe2acfc992d2cfad3e7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Apr 3 20:09:32 2021 +0200

    Doc: Fix flowspec example
    
    Thanks to Matt Corallo for the bugreport.

commit 7c8b7649f95c72c207bcf95064d08e831d5738ce
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 30 21:44:35 2021 +0200

    Allocation of ea_list in one contiguous memory block
    
    This saves some bytes of memory for complex ea's.

commit ff397df7edcbe7a8abca5b419729b9c64c063847
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 30 18:51:31 2021 +0200

    Routing table is now a resource allocated from its own pool
    
    This also fixes memory leaks from import/export tables being never
    cleaned up and freed.

commit a9938b179203a4d5c54eae6c814bfa8766f4fde0
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 30 16:03:33 2021 +0200

    Resources: added mb_move() to complement rmove() for memory blocks

commit 4635314cefd55aaa2a0146b6722df55e7efba4b8
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Mar 30 15:09:53 2021 +0200

    Routing tables list iteration should use explicit node struct position

commit 7a74ad5a61c82ab0062a62dbc9ea6ab91d480485
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 30 16:59:11 2021 +0200

    BGP: Do not keep BAF_EXT_LEN flag internally
    
    The flag makes sense just in external representation. It is reset during
    BGP export, but keeping it internally broke MRT dumps for short attributes
    that used it anyways.
    
    Thanks to Simon Marsh for the bugreport and the patch.

commit a06469d9fc1d3ec4b17b3109627aff7d9877ba0e
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Mar 25 20:51:23 2021 +0100

    Dropping automatic tests for Debian 7 Wheezy.
    
    Debian 7 Wheezy has been superseded by Debian 8 Jessie on Apr 25, 2015,
    with LTS support ending on May 31, 2018.
    
    Debian 7 Wheezy's default GCC doesn't fully support C11. It should
    anyway still be possible to build BIRD for Debian 7 if you backport
    a C11-capable compiler there.

commit 886dd92eeefa070d8db6aaf0245a67f7a9e9b983
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jul 22 00:09:15 2020 +0200

    Slab: head now uses bitmask for used/free nodes info instead of lists
    
    From now, there are no auxiliary pointers stored in the free slab nodes.
    This led to strange debugging problems if use-after-free happened in
    slab-allocated structures, especially if the structure's first member is
    a next pointer.
    
    This also reduces the memory needed by 1 pointer per allocated object.
    OTOH, we now rely on pages being aligned to their size's multiple, which
    is quite common anyway.

commit 82f19ba95e421f00a8e99a866a2b8d9bbdba6cdc
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 18 20:18:38 2021 +0100

    NEWS and version update

commit f1ffe6a23144a4b13f020194f23055ac8c20dea6
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 18 15:54:44 2021 +0100

    Add new BGP tests

commit 5a6e8380f89deb4fff21805a7879658d2352471a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 18 15:44:04 2021 +0100

    BGP: Do not show statistics
    
    BGP statistics code was preliminary and i wanted to replace it by
    separate 'show X stats' command. The patch hides the preliminary
    output in 'show protocols all' so it is not part of the released
    version.

commit 454ae3044598466ca7c50c12c6882d84ea545afa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 17 17:24:00 2021 +0100

    RPKI: Improve error handling of DNS resolver

commit 0a3db4c68040473ab45b974a7f9256c277c5d31c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 17 15:56:12 2021 +0100

    Minor fixes for restricted builds

commit 2f981534902302cbd13cdb12d4f0c6e9a255687a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 16 20:10:00 2021 +0100

    Pipe: Propagate debug flags from protocol to channels
    
    Pipe channels are kind-of implicit, so setting protocol debug flags
    should also set pipe debug flags.

commit ae9ae864d3fec20a74ce2567536e186ce178d032
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 16 16:34:42 2021 +0100

    OSPFv3: Update neighbor authentication state from Hello packets
    
    In OSPFv3, only Hello and DBDes packets contain flags specifying whether
    RFC 7166 authentication trailer is used. Other packets are processed
    based on stored authentication state in neighbor structure. Update this
    state with each received Hello to handle authentication change from
    reconfigurations.
    
    Thanks to Joakim Tjernlund and Kenth Eriksson for the bugreport.

commit 94abefc00bb22b93493831798391d5d5b21f9d4c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 15 18:35:23 2021 +0100

    Filter: Update 'gw' to handle IPv6 link-local addresses
    
    When a link-local address is set, use the existing iface for scope.
    
    Thanks to Marcel Krüger for the bugreport.

commit 0d1a11cca3136828808b8e73f4d5e547cc787fb8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 15 17:51:33 2021 +0100

    Doc: Document automatic RPKI reload

commit 6489a2450e0ab4aa63c25ac2f9be354fdbd711d2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 15 16:16:32 2021 +0100

    Doc: Document channel debug options

commit 7be3af7fa662958782d2e23989d79cc2c652b6bf
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Mar 12 15:35:56 2021 +0100

    Rate-limit scheduling of work-events
    
    In general, events are code handling some some condition, which is
    scheduled when such condition happened and executed independently from
    I/O loop. Work-events are a subgroup of events that are scheduled
    repeatedly until some (often significant) work is done (e.g. feeding
    routes to protocol). All scheduled events are executed during each
    I/O loop iteration.
    
    Separate work-events from regular events to a separate queue and
    rate limit their execution to a fixed number per I/O loop iteration.
    That should prevent excess latency when many work-events are
    scheduled at one time (e.g. simultaneous reload of many BGP sessions).

commit 9cf3d533110313d55b60d47c134f1b7050d6be78
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 10 15:07:19 2021 +0100

    Static: Implement reload hook

commit 211fe69c984c657095930d2831f46896197ec65b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Mar 8 20:45:22 2021 +0100

    Nest: No automatic ROA reload on non-reloadable channels

commit d3782c72b9243f4609e61edf5f29e6adeaa41e9c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Feb 12 05:05:18 2021 +0100

    Nest: Add option to control automatic RPKI reload
    
    Also, no automatic reload for BGP channels without import/export table.

commit 77ce849ecf0f89455eeabefbe520c6b4888837b0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Feb 10 17:29:14 2021 +0100

    Tests: Add missing mockup function to tests

commit 714238716ef36f1dfc5721055e2ec4affd42ebfa
Author: Vincent Bernat <vincent@bernat.ch>
Date:   Wed Feb 10 16:53:57 2021 +0100

    BGP: Add support for BGP hostname capability
    
    This is an implementation of draft-walton-bgp-hostname-capability-02.
    It is implemented since quite some time for FRR and in datacenter, this
    gives a nice output to avoid using IP addresses.
    
    It is disabled by default. The hostname is retrieved from uname(2) and
    can be overriden with "hostname" option. The domain name is never set
    nor displayed.
    
    Minor changes by committer.

commit 00b85905b9f5081eb2fce0ed79542085278e9f42
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Feb 10 03:09:57 2021 +0100

    Nest: Automatic channel reloads based on RPKI changes
    
    If there are roa_check() calls in channel filters, then the channel
    subscribes to ROA table notifications, which are sent when ROA tables
    are updated (subject to settle time) and trigger channel reload or
    refeed.

commit d06a875b042b608e61b2d5a2bb594641d3e1322f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 7 19:21:42 2021 +0100

    Filter: Recursive filter iteration code
    
    Add macros for recursive filter iteration that allows to examine
    all instructions reachable from a filter.

commit 5d414309ec5a01024d4de4c4f9521f8daa5c06ff
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 22 04:34:15 2021 +0100

    MRT: Fix MP-BGP next hops
    
    Flag signalling that MP-BGP mode should be used got reset after first
    batch of routes, so remaining routes were processed without that, leading
    to missing MP_REACH_NLRI attribute.
    
    Thanks to Piotr Wydrych for the bugreport.

commit df83f626973fda1e67769d295c47d4d246e4c1c4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 14 01:51:09 2021 +0100

    Netlink: Ignore dead routes
    
    With net.ipv4.conf.XXX.ignore_routes_with_linkdown sysctl, a user can
    ensure the kernel does not use a route whose target interface is down.
    Such route is marked with a 'dead' / RTNH_F_DEAD flag.
    
    Ignore these routes or multipath nexthops during scan.
    
    Thanks to Vincent Bernat for the original patch.

commit a40ddf5c616465a93287e4ac41a98d04b4fb2b37
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jan 12 15:43:54 2021 +0100

    Build: Fix tags generation

commit d774f6d721b0e52ed800c4b9a3a482c8ce9dd074
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jan 12 15:37:01 2021 +0100

    MRT: Fix IPv6 table dumps
    
    Add fake MP_REACH_NLRI attribute with BGP next hop when encoding MRT
    table dumps for IPv6 routes. That is necessary to encode next hop as
    NEXT_HOP attribute is not used for MP-BGP.
    
    Thanks to Santiago Aggio for the bugreport.

commit 910adaa08bbd416288797505399ab47f990817e6
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jan 10 15:29:02 2021 +0100

    BFD: Dispatch sessions also by interface index
    
    Direct BFD sessions needs to be dispatched not only by IP addresses, but
    also by interfaces, in order to avoid collisions between neighbors with
    the same IPv6 link-local addresses.
    
    Extend BFD session hash_ip key by interface index to handle that. Use 0
    for multihop sessions.
    
    Thanks to Sebastian Hahn for the original patch.

commit 17663b6a7c505226cfe9ccc0671611075a3dff57
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 7 05:56:34 2021 +0100

    RPKI: Remove port (and SSH username) from 'Cache server' output line
    
    It was mixed-up if hostname is IPv6 address, and reporting separate
    values (like port) on separate lines fits better into key-value style
    of 'show protocols all' output. Also, the patch simplifies transport
    identification formatting (although it is unused now).
    
    Thanks to Alarig Le Lay for the suggestion.

commit 2a8cc7259e236773f1b8423ef63305a5b8bfd652
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 7 01:56:00 2021 +0100

    Kernel: Do not check templates
    
    So one can define kernel protocol template without channels.
    For other protocols, it is either irrelevant or already done.
    
    Thanks to Clemens Schrimpe for the bugreport.

commit a141959f0729b2381a90aaa9b7ed0e41a5f9513e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 7 01:20:56 2021 +0100

    Doc: Describe per-nexthop static route options
    
    Also remove description of (no longer supported) per-route 'bfd' option,
    and add examples of IPv6 routes with link-local nexthops.

commit 7a1f4baac11cbfad82a2d09a130b3ae7bb48e9bd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 6 14:51:49 2021 +0100

    Nest: remove last_tx_filter_change
    
    No longer needed after redesign of export handling.

commit 4155104c90bc2f3fb680e8041e079ceb3d80a3b1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 6 14:44:23 2021 +0100

    BGP: Deprecate 'missing lladdr' option
    
    The option is not implemented since transition to 2.0 and no plan to add it.
    Also remove some deprecated RTS_* valus from documentation.
    
    Thanks to Sébastien Parisot for notification.

commit 21f9acd2a01306af01f19914105985a8a0f9bcba
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 6 05:25:59 2021 +0100

    Kernel: Fix handling of krt_realm with ECMP routes
    
    For ECMP routes, RTA_FLOW attribute must be set per-nexthop, not
    per-route. Our corresponding krt_realm attribute is per-route.
    
    Thanks to Mikhail Petrov for the bugreport.

commit 455c13dc9971ae4aa701135b5c1709d61477bdec
Author: James Lu <james@overdrivenetworks.com>
Date:   Tue Dec 29 02:23:54 2020 +0100

    Nest: Read Babel metric as IGP metric
    
    (Minor syntactic changes by committer)

commit ea3c6c1a15ce9b93f583f96919c70f7a2fd34e98
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 28 21:19:27 2020 +0100

    Static: Fix handling of 'net' attribute in per-route filters
    
    We need to define 'net' field temporarily as it may be accessed by
    per-route filters.
    
    Thanks to Damian Zaremba for the bugreport.

commit 9e2635505a08e3453eef487360e49b4b70987ceb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 28 15:23:28 2020 +0100

    Filter: Fix return on top-level
    
    Broken detection of top-level case caused crash when return was called
    from top-of-stack position. It should behave as reject/accept.
    
    Thanks to Damian Zaremba for the bugreport.

commit 61dae32b29cc57b9884a1c13e5d630096e157a38
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 7 22:19:40 2020 +0100

    Nest: Per-channel debug flags
    
    The patch add support for per-channel debug flags, currently just
    'states', 'routes', and 'filters'. Flag 'states' is used for channel
    state changes, remaining two for routes passed through the channel.
    The per-protocol debug flags 'routes'/'filters' still enable reporting
    of routes for all channels, to keep existing behavior.
    
    The patch causes minor changes in some log messages.

commit 8cc5bb09e344038a1f8dff96946e05ec80607c93
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 2 05:02:26 2020 +0100

    Filter: Add 'weight' route attribute
    
    Add 'weight' route attribute that allows to get and set ECMP weight of
    nexthops. Similar to 'gw' attribute, it is limited to the first nexthop,
    but it is useful for handling BGP multipath, where an ECMP route is
    merged from multiple regular routes.

commit 246586771296d1c42a012c06bdc75b36a7ce0b4f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 25 15:44:00 2020 +0100

    BGP: Zero the newly allocated bucket structure
    
    This fixes an issue with dirty node passed to add_tail().
    
    Thanks to Andreas Rammhold for the initial patch.

commit 62d57b9bdf82cc978f889f0118c8aa19ae999a3d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 25 15:15:13 2020 +0100

    Log: Fix locking during log reconfiguration
    
    The log subsystem should be locked earlier, as default_log_list() may
    internally manipulate with the current_log_list (if it is also a default
    log list).

commit 0ef082c51e5d905e9137e1484036b9d9b32e9a75
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 25 15:04:34 2020 +0100

    Log: Reinitialize the static logging structures
    
    The static logging structures are reused, we need to reinitialize them
    otherwise add_tail() would fail in debug build. Reinitializing these
    structures should be fine as the list they belong to is being
    reinitialized on entry to the very same function.
    
    Thanks to Andreas Rammhold and Mikael Magnusson for patches.

commit 30b846826905b4da76f59a212a31928bd55e9783
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 24 04:09:11 2020 +0100

    Minor cleanups with cfg_allocz()
    
    Also fixes some more failed asserts due to add_tail().

commit 1678bc07467e6d977fc2f6bf830274ca92e0a6e5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 24 03:42:23 2020 +0100

    Fix some failed asserts due to add_tail()
    
    When config structures are copied due to template application,
    we need to reset list node structure before calling add_tail().
    
    Thanks to Mikael Magnusson for patches.

commit c9ae81656f97bcc55910e80b6f00d3ee9383d848
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 24 03:21:44 2020 +0100

    Some minor sl_allocz() cleanups

commit db2d29073acfd4086fca18ba43a5ed6baccaa8ad
Author: Toke Høiland-Jørgensen <toke@toke.dk>
Date:   Tue Nov 24 02:32:13 2020 +0100

    lib/slab: introduce sl_allocz() function and use it in Babel
    
    The babel protocol code was initialising objects returned from the slab
    allocator by assigning to each of the struct members individually, but
    wasn't touching the NODE member while doing so. This leads to warnings on
    debug builds since commit:
    
    baac7009063d ("List expensive check.")
    
    To fix this, introduce an sl_allocz() variant of the slab allocator which
    will zero out the memory before returning it, and switch all the babel call
    sites to use this version. The overhead for doing this should be negligible
    for small objects, and in the case of babel, the largest object being
    allocated was being zeroed anyway, so we can drop the memset in
    babel_read_tlv().

commit 3347aaafec5b269637604d1ea5f5969797beadea
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Nov 19 16:38:39 2020 +0100

    Static: Support for multiple routes with the same network
    
    Add support for proper handling of multiple routes with the same network
    to the static protocol. Routes are distinguished by internal index, which
    is assigned automatically (sequentially for routes within each network).
    Having different route preference or igp_metric attribute is optional.

commit df65d519d6a5a7511cc893d2be55399b38b838be
Author: Nigel Kukard <nkukard@lbsd.net>
Date:   Wed Nov 18 18:00:12 2020 +0100

    Doc: Added example of static routes with BGP large communities

commit 00ddd18b02a4a4db973adecf6ef63a350c909cbd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 18 17:37:29 2020 +0100

    OSPFv3: Fix intra-area-prefix-LSA origination on DR
    
    When a new link-LSA is originated, we need to notify intra-area-prefix-LSA
    handling, like when a new link-LSA is received. Otherwise a new network
    prefix added to a DR is not propagated immediately.
    
    Thanks to Bala Sajja for the bugreport.

commit 6ea8a46ccb540701dfe747566e6a5b7bc318db01
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 15 16:28:13 2020 +0100

    Doc: Fix typo
    
    Thanks to Hexhu for the bugreport.

commit b962967e20f186f797c163f69c673b0ee4ef3b2b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 15 16:01:19 2020 +0100

    Nest: Fix crash in receive limit handling in import table
    
    Logging as a result of triggered receive limit in import table code
    accesset rte->net, which was not filed yet.
    
    Thanks to Pier Carlo Chiodi for the bugreport.

commit 4a42e7e92520e7d07e585d542ef54e1de302fb1d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Nov 12 04:50:45 2020 +0100

    BFD: Update documentation about per-session options

commit 3b56bf8849283977f2f4fa7b8f3dc62fdd8d7587
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Nov 12 04:02:38 2020 +0100

    BFD: Better handling of BFD options in BGP configs
    
    Merge multiple BFD option blocks in BGP configs instead of using the last
    one. That is necessary for proper handling of templates when BFD options
    are used both in a BGP template and in a BGP protocol derived from that
    template.

commit 99ad208dd73d357156672a53f48b77dcf6515c30
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Nov 12 02:37:42 2020 +0100

    BFD: Fix superfluous reconfiguration of sessions

commit 9d3fc3062b236f51b2c72a4c2c7b068f1946261d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 8 15:33:22 2020 +0100

    BFD: Allow per-request session options
    
    BFD session options are configured per interface in BFD protocol. This
    patch allows to specify them also per-request in protocols requesting
    sessions (currently limited to BGP).

commit fc1e3211b109400c0e96f889829c9f5145ac7226
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Oct 11 00:53:19 2020 +0200

    RPKI: Add 'ignore max length' option
    
    Add 'ignore max length' option to RPKI protocol, which ignores received
    max length in ROA records and instead uses max value (32 or 128). This
    may be useful for implementing loose RPKI check for blackholes.

commit 6c11dbcf28faa145cfb7310310a2a261fd4dd1f2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Oct 5 14:52:55 2020 +0200

    Doc: Fix missing semicolons
    
    Thanks to Marco Gartmann for the bugreport.

commit 14ce8904e7b9f6ceeaf2587faeab200cd67401d9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Oct 5 14:45:01 2020 +0200

    Doc: Fix typo
    
    Thanks to Sergey Kulikov for the bugreport.

commit 600eb695b1a273f8b3fd4f2c524d8eeef25483aa
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Aug 31 15:41:39 2020 +0200

    OSPF: Fixed a debug assert

commit dc8d9dec4a3484f358d2117328fe860e8e7b16bb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Aug 12 19:42:44 2020 +0200

    OSPF: Skip out-of-state packets earlier
    
    Sometimes multicast OSPF packet is received when neighbor adjacency is
    not established. Such packet should be ignored earlier in packet
    processing as otherwise it causes strange error messages when OSPFv3
    authentication is enabled.

commit c0e1f534c95f5f395fda62b01ea1c245323e3aed
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jul 16 15:02:10 2020 +0200

    Nest: Keep route ordering during route updates
    
    Put new non-best routes to the end of list instead of the second
    position. Put updated routes to their old position. Position is changed
    just by best route selection.

commit c26c6bc2d78a2fe76f27dcc9fbb5afc95c3a7626
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu May 14 03:48:17 2020 +0200

    Show info from multiple protocols when protocol is not specified
    
    Most commands like 'show ospf neighbors' fail when protocol is not
    specified and there are multiple instances of given protocol type.
    This is annoying in BIRD 2, as many protocols have IPv4 and IPv6
    instances. The patch changes that by showing output from all protocol
    instances of appropriate type.
    
    Note that the patch also removes terminating cli_msg() call from these
    commands and moves it to the common iterating code.

commit a948cf9a5c338518773e6c98e895c829c469f56b
Author: Kazuki Yamaguchi <k@rhe.jp>
Date:   Sun Jun 28 15:37:01 2020 +0200

    Filter: Improve handling of sets in BGP path masks
    
    Compare the content of PM_ASN_SET in path masks. A reconfiguration
    was not properly triggering a reload of affected protocols when the
    members of a set in a path mask change.
    
    Also, update the printing code to so that it can display sets in a path
    mask.

commit 4ef0a966392672d04a567c25758462fe3bbb0fb4
Author: Kazuki Yamaguchi <k@rhe.jp>
Date:   Sun Jun 28 15:33:26 2020 +0200

    Filter: Fix comparison of BGP path mask
    
    Add a missing return statement. Path masks with the same length were all
    considered the same. Comparing two with different length would cause
    out-of-bounds memory access.

commit 82937b465b3a50bdcb00eff0b7aa6acb3fc21772
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 10 13:27:14 2020 +0200

    OSPF: Fix bad header length test
    
    Thanks to Slava Aseev for the thorough bugreport.

commit 71e08edd942557ec333902bb45c57794f7a66bf8
Author: Kenth Eriksson <kenth.eriksson@infinera.com>
Date:   Wed Jun 3 23:05:29 2020 +0200

    Doc: Add 'ptp address' to OSPF doc overview

commit 63451c19611b5972769ed519bd7eb6c1b995a8a0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 3 16:15:29 2020 +0200

    Test: Fix unit test mockups

commit f1b5f179dbd8aaef5eca4936b557e753e377d818
Author: Kazuki Yamaguchi <k@rhe.jp>
Date:   Wed Jun 3 15:18:02 2020 +0200

    Netlink: Fix parsing of MPLS multipath routes
    
    Add support for RTA_MULTIPATH attribute parsing for AF_MPLS routes.
    
    BIRD is capable of installing a multipath route into kernel on Linux,
    but it would not be seen because parsing fails. This made BIRD attempt
    to install the same route repeatedly.
    
    (The patch minorly updated by committer)

commit 19f8f173202d6f5cbf97ca2a9f66fcea6b9bb44f
Author: Kazuki Yamaguchi <k@rhe.jp>
Date:   Wed Jun 3 15:05:35 2020 +0200

    RPKI: Fix unnecessary reconnection on reconfiguration
    
    Compare the new timing parameters with the old configuration, not with
    the temporary state of the current connection.
    
    The timing values in struct rpki_cache is updated by a version 1 End Of
    Data PDU, unless this behavior is suppressed by the configuration
    explicitly by the "keep" keyword. Consequently, every reconfiguration
    of BIRD triggers a reconnection even if it is not necessary.

commit fae5448134dfec004be818d18ff1583cc61e5549
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun May 31 13:21:55 2020 +0200

    Log: Do not open logfiles when parse-and-exit option is active
    
    This is a quick workaround for an issue where configured logfiles are
    opened/created during parsing of a config file even when parse-and-exit
    option is active. We should later refactor the logging code to avoid
    opening log during parsing altogether.

commit eee8af4db2d36a5017eac4447075cac3346e8b23
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jun 2 16:58:06 2020 +0200

    OSPF: setting list node to zero before enlisting

commit 4e8f8afc68cc7ba09ca42d989e47dbfcb17d2772
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 26 23:43:13 2020 +0200

    Babel: Set onlink flag for IPv4 routes with unreachable next hop
    
    If the next hop of a route is not a reachable address, the route should be
    installed as onlink. This enables a configuration common in mesh networks
    where the mesh interface is assigned a /32 and babel handles the routing by
    installing onlink routes.
    
    Thanks to Toke Hoiland-Jorgensen for the patch.

commit c1632ad0f39f7221d649a9e469cacc38105528e2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 26 18:21:43 2020 +0200

    OSPF: Fix handling of unnumbered PtPs
    
    This issue has a long history. In 2012, we changed data field for
    unnumbered PtP links from iface id (specified by RFC) to IP address based
    on reports of bugs in Quagga that required it, and we used out-of-band
    information to distinquish unnumberred PtPs with the same local IP
    address.
    
    Then with OSPF graceful restart implementation, we found that we can no
    longer use out-of-band information, and we need to use only LSAdb info
    for routing table calculation, but i forgot to finish handling of this
    case, so multiple unnumbered PtPs with the same local IP addresses were
    broken.
    
    Considering that even recent Mikrotik RouterOS has broken next hop
    calculation that depends on IP address in PtP link data field, we
    cannot just switch back to the iface id for unnumbered PtP links.
    
    The patch makes two changes: First, it goes back to use out-of-band
    (position) info for distinguishing local interfaces in SPF when graceful
    restart is not enabled, while still uses LSAdb-only approach for SPF
    calculation when graceful restart is enabled.
    
    Second, it adds OSPF interface option 'ptp address', which controls
    whether IP address or iface id is used in data field. It is enabled
    by default except for unnumbered PtP links with enabled graceful
    restart.
    
    Thanks to Kenth Eriksson for the bugreport and Joakim Tjernlund for
    suggestions.

commit 1ca7665fa4a9858a6d4c591ccff5b61e5e6aed13
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 19 02:50:47 2020 +0200

    Nest: Allow key id 0
    
    There is nothing in RFCs specifying that id 0 is not allowed. Some
    implementations does not support it, while some other use key id 0 by
    default. We allow it but start with key id 1 by default.
    
    Thanks to Kenth Eriksson for the bugreport.

commit b729e731f99aa6ece085597091618ed559a9f656
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon May 18 22:16:37 2020 +0200

    RIP: Triggered RIP (demand circuit) documentation

commit ec430a7feefd3b32ee39c641a48c44528d0eab25
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon May 18 16:25:08 2020 +0200

    Nest: Implement BGP path mask loop operator
    
    Implement regex-like '+' operator in BGP path masks to match previous
    path mask item multiple times. This is useful as ASNs may appear
    multiple times in paths due to path prepending for traffic engineering
    purposes.

commit 5fc8407177fd34f2d57441a8ff9a068f4162fbfb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 12 03:46:47 2020 +0200

    RIP: Fix handling of passive mode for demand circuit interfaces

commit b8bbbbaf569799ab8faff0ee185528b6a2129154
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon May 11 04:29:36 2020 +0200

    Nest: Fix neighbor handling for colliding ranges
    
    Resolve neighbors using longest prefix match. Although interface ranges
    should not generally collide, it may happen for unnumbered links.
    
    Thanks to Kenth Eriksson for the bugreport.

commit f7c34aa227693194e53ca0435dba52c2a839bae8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue May 5 02:20:30 2020 +0200

    Tests: Activate BGP-int test

commit e6785c469b418785568c33241157d17107afd55c
Author: Matous Holinka <matous.holinka@nic.cz>
Date:   Wed Apr 29 16:15:17 2020 +0200

    Tests: Change unsupported Ubuntu 19.04 for supported version 19.10

commit 82bfee76f0adfd50d51833343c63ba9e2afcb60e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Apr 29 15:07:33 2020 +0200

    Filter: Remove quitbird command
    
    No need for this debug filter command and it can be abused from CLI.

commit b12442c985f2bd8c9fd47ca63151724962fabdc2
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri May 1 15:41:42 2020 +0200

    Fixed a harmless warning in production build

commit 048eb2ddf1ee9587d9fa30cbb3f87d6f650a2133
Merge: 17de3a02 59238768
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri May 1 15:34:17 2020 +0200

    Merge remote-tracking branch 'origin/mq-static-analysis'

commit 59238768b3b05fa134348d2232b42537d0403994
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Aug 19 14:43:14 2019 +0200

    Slab: Init node in slab head to NULLs.

commit ea259d6201973eb0f764cbb2bb6549b6ac79b316
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 16:09:29 2019 +0200

    Timer: Adding missing initializer.

commit 0c3b8ffe25f43e59dfe8b1aeb219ff1cb4c6aa2b
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 15:03:09 2019 +0200

    Lexer: strtoul shall never set endptr to NULL; it should be an error

commit cdde3550dc188f493daf82ef9d9acf8b85d9d722
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 14:57:41 2019 +0200

    Unix socket: Path length check directly before copying the path.
    
    This is not needed as the string is always short enough, anyway
    it may be needed in future and one strlen during BIRD start is
    cheap enough.

commit 9ac13d7af25d6b26866bf4f4a4fab371925fb1df
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Aug 19 14:36:51 2019 +0200

    Lists: Replaced replace_node() by update_node() which is the only use of that function.

commit e26a5195dd6c62e6f4b80d13b6ecd5f40ee68546
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 14:03:47 2019 +0200

    Lists: fix a stupid sanitizer bug

commit 3bb10b4d31d68a8139e284c27f7eb6fca897721d
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 14:18:41 2019 +0200

    Uninitialized list nodes fixes

commit 258be56539a3d4b47fe779f9658ca3d88761878d
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 13:36:36 2019 +0200

    Nest: Added const to ea_show just to declare that this shouldn't really change anything

commit a7d9b8f116d00194e94c7505cbc8ed7f8784eeab
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 10:28:55 2019 +0200

    OSPF: Zero-initialization of a temporary neighbor

commit 0fa8bf91cd474e393ded85b329fde30ba35f6a26
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 10:20:46 2019 +0200

    Nest: Several assumptions to tame the static analyzer

commit bbe49ae569534d0cf7ff226d19e729dcc764e606
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 08:59:06 2019 +0200

    Nest: Assumption in rt-show for not-so-intuitive invariant.

commit a08853a26989d343c507a41257dedcdea3befd73
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Aug 17 08:54:08 2019 +0200

    Static scanner and expensive debugging setup fix

commit 5f60d14edeb48824d28e6393e7eb1aa50d5f2cd1
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Aug 16 21:22:56 2019 +0200

    RPKI: fixed rare va_list leak

commit b7482209065a03c3186d74e5e4129539ce7a3ce4
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Aug 16 21:15:49 2019 +0200

    Static check: Don't report dead code

commit 9e64ac4b7c23aa3b8b9149794c05305315cf31e5
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Aug 16 14:04:53 2019 +0200

    OSPF: Adding a note about a static analyzer result.

commit dccee408262262ab9a63403141b74a0d937284bc
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Aug 16 12:47:13 2019 +0200

    OSPF: variable-length array of size 0 replaced by alloca()'d pointer
    
    NULL pointer is safer than a random pointer onto stack if this function
    gets changed and eventually broken.

commit baac7009063d94799821422ecc63ea2af41561ea
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 16:23:58 2019 +0200

    List expensive check.

commit a0d0a71a1828cce725c3132f8c243bf0c537786f
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 16:22:39 2019 +0200

    Expensive check declaration
    
    Intended to be run at every operation with complex data structures
    to check their consistency and validity.

commit a1b61a271af40a9d6ef0837424ab2c98d29f1575
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 12:29:04 2019 +0200

    IPv6 address parser: fail on incomplete addresses

commit d65a926a67749f8e8ffb6df9b3e2e123669b0656
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 11:49:20 2019 +0200

    Filter: Don't alloc varargs array if its length would be zero

commit 30ba7c1661a13d665ae0aaa4e40cb5ed24023450
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 11:31:03 2019 +0200

    Filter: Removed forgotten dead code

commit bf9486bf20ee16af71e338ee690fc36805d98fe5
Author: Maria Matejka <mq@jmq.cz>
Date:   Mon Apr 27 22:33:10 2020 +0200

    Non-null function argument declaration

commit 17de3a023f7bde293892b41bfafe5740c8553fc8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Apr 29 02:50:29 2020 +0200

    BGP: Fix handling of strange IPv6 link-local-only next hops
    
    There are three common ways how to encode IPv6 link-local-only next hops:
    (:: ll), (ll), and (ll ll). We use the first one but we should accept all
    three. The patch fixes handling of the last one.
    
    Thanks to Sebastian Hahn for the bugreport.

commit 8029ae527edde4d47a51b55efdbdea546296c5ef
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Aug 1 14:25:01 2019 +0200

    More assertion categories

commit d607205486d7ea11f2cbf3dcc3d5e7e6b53f1d0f
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 10:28:23 2019 +0200

    Not calling memcpy with n=0.

commit 124d860f648f4c1c080e77b5f070b97d094f5285
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 11:06:49 2019 +0200

    Filter: fixed omitted overflow check in EC constructor

commit 59a86cbc7c5d5640b16ca9d8a99be979b11a4c68
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 14 10:14:15 2019 +0200

    Makefile rule for static analyzer

commit b465604eb13fc57ebe240556ebf0d4469690c906
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 28 14:58:43 2020 +0200

    Tests: Activate BGP-auth test

commit 716e11a58437498c09ffdb321b0de4e28a7383d8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 28 03:52:47 2020 +0200

    Tests: Activate OSPF-VRF test

commit 3c838ad9fdc553c658ee2fbb466ab8ab4cd14805
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Apr 22 16:03:37 2020 +0200

    Tests: Activate BGP test

commit a6548d5b5be1d0186dfab43b76790803f8c8625e
Author: Nasato Goto <goto@mfeed.ad.jp>
Date:   Wed Apr 15 03:46:53 2020 +0200

    BGP: Fix handling of 16bit-only ASN translation
    
    The bug generated invalid AGGREGATOR attribute during translation of
    32bit ASN to 16bit-only BGP peer. The patch fixes that.

commit fd9f0c0640fd02a26b96b4f9d3cbbffbb6544a84
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Apr 8 22:25:15 2020 +0200

    Configuration strings are constant.
    
    This is merely a const propagation. There was no problem in there.

commit a109056145a6bc8a6b498ecb6e309ebc143c8b3c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Mar 28 17:17:51 2020 +0100

    Doc: Update prefix set comment

commit 2928c5bcc7c3caaeb6de34a84ca63de9a12e1f1a
Author: Maria Matejka <mq@jmq.cz>
Date:   Sun Apr 5 01:12:06 2020 +0200

    Fletcher16 test fixed to work at bigendian architectures.
    
    To be honest, it was wrong in concept, anyway it accidentally worked.

commit c9d11e6230c49cdfd1f17829be0e877aba05e90b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 26 04:53:23 2020 +0100

    Filter: Remove mixed address tests and fix formatting

commit 27550028907fd135051a43dda0abe76e9118b7e9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 26 03:57:48 2020 +0100

    Filter: Optimize IPv4 prefix sets
    
    Use separate IPv4 and IPv6 implementation of prefix sets. Just this
    change makes IPv4 prefix sets 60% smaller and 50% faster.

commit d516c68ad838351fa5e20e3e10bd3fb2b3157618
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Mar 14 17:04:49 2020 +0100

    RIP: Improvements to demand circuit mode
    
    Restart iface after changing demand circuit mode during reconfiguration.
    Fix next_regular interval reset during reconfiguration. Send flushing
    response when iface goes down.

commit dc042d87cb68e44b49e9f4f153db444afaa00fba
Author: Maria Matejka <mq@jmq.cz>
Date:   Mon Jan 27 17:42:11 2020 +0100

    Perf: changed route update pattern to be more like common protocols

commit e2630a494ebc90bee97729ebe92a1bb9fd8bb611
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 5 23:51:28 2020 +0100

    Netlink: Handle interfaces with missing broadcast addresses

commit 1ad98965c5eacd5c5f468beac146dfd0d63c83f2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 5 22:01:30 2020 +0100

    Tests: Enforce cleanup before running a test

commit ead531ffefdad0f6b5d654330d0e4aba94757569
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 5 17:39:52 2020 +0100

    Tests: Activate OSPF tests

commit e6746da6de45bcacc42010cea828129eae38ba67
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 3 19:04:05 2020 +0100

    Flowspec: Fix tests
    
    Missing dst no longer generates error.

commit 78e4a123bb937bb45f7eaebb0ea475095443bfd0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 3 17:45:16 2020 +0100

    BGP: Handle flowspec rules without dst part
    
    The RFC 5575 does not explicitly reject flowspec rules without dst part,
    it just requires dst part in validation procedure for feasibility, which
    we do not implement anyway. Thus flow without dst prefix is syntactically
    valid, but unfeasible (if feasibilty testing is done).
    
    Thanks to Alex D. for the bugreport.

commit 757cab18d6427d9246618ce48c158f2b05183838
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Feb 27 16:16:48 2020 +0100

    BGP: Support for MD5SIG together with remote range
    
    When dynamic BGP with remote range is configured, MD5SIG needs to use
    newer socket option (TCP_MD5SIG_EXT) to specify remote addres range for
    listening socket.
    
    Thanks to Adam Kułagowski for the suggestion.

commit 22c3cf955dbbb65aa29e322efa70dabb749f0232
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Feb 21 02:35:50 2020 +0100

    RIP: Demand circuit support (RFC 2091)

commit 3343088a7164a54b1e6c6cf9648d8036a61e9827
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Feb 14 22:37:07 2020 +0100

    RIP: Fix crash when interface is removed
    
    Recent changes in neighbor code caused RIP to access neighbor field which
    is NULL during interface/neighbor removal and caused crash when debug
    messages are enabled. Use correct field to get iface from neighbor.

commit ab089f4fb5e1ac762a9c95ed4638e2477803678e
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 4 10:34:46 2020 +0100

    Conf: Better error message when reading iproute2 config
    
    Reported by: Martin Weinelt <martin@darmstadt.freifunk.net>

commit 027a3e66f786be8863784aefb043097b41090896
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 4 10:15:35 2020 +0100

    RPKI: Allow build without libSSH

commit 4bbc10614f3431c37e6352f5a6ea5c693c31021e
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 4 10:11:16 2020 +0100

    Added missing extern
    
    Thanks to Robert Scheck <bird@robert-scheck.de> who reported it
    and Toke Høiland-Jørgensen <toke@toke.dk> who suggested this patch.

commit 7f9adafc109d576d5249c25ef284606dbac4adfa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jan 28 18:07:25 2020 +0100

    BFD: Option to specify which class of BFD sessions are accepted
    
    Allows to configure IPv4/IPv6-only or direct/multihop-only BFD protocol
    instances.

commit 9f2670277cc0d56d3364d4784348056174175aba
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 9 02:59:59 2020 +0100

    OSPF: Fix bad initialization of tx_hdrlen field
    
    Function ifa_tx_hdrlen() uses fields autype and passwords, so it must be
    called after these are set.
    
    Thanks to Kenth Eriksson for the bugreport.

commit 7d767c5a3d001a6a1a5c3e800553202fd492190c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jan 7 18:35:03 2020 +0100

    KRT: Improve syncer code to avoid using temporary data in rtable
    
    The old code stored route verdicts and temporary routes directly in
    rtable. The new code do not store received routes (it immediately
    compares them with exported routes and resolves conflicts) and uses
    internal bitmap to keep track of which routes were received and which
    needs to be reinstalled.
    
    By not putting 'invalid' temporary routes to rtable, we keep rtable
    in consistent state, therefore scan no longer needs to be atomic
    operation and could be splitted to multiple events.

commit ef8c45749c82e246d477ea4d7f749668a9c7e9ee
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jan 7 01:24:30 2020 +0100

    Filter: Fix typecheck for AND/OR.
    
    Do not apply dynamic type check for second argument of AND/OR, as it is
    not evaluated immediately like regular argument would be.
    
    Thanks to Mikael for the bugreport.

commit cc75b3e1dc4a7440479d6f4d73e7e1b9ba65332f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Dec 19 16:34:35 2019 +0100

    KRT: Remove KRF_SYNC_ERROR flag
    
    This info is now stored in an internal bmap. Unfortunately, net.flags
    is still needed for temporary kernel data.

commit 90a9c97e38e3769b400b434723516213eccb3ab0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 17 16:30:29 2019 +0100

    KRT: Fix removal of KRF_INSTALLED
    
    Use route id from net->routes to check export_map. Route received from
    sysdep KRT code does not have proper id.

commit 3dabf7b8d09c3188ea41b7e2f763397946943778
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 17 00:01:53 2019 +0100

    Test: Improve filter_test
    
    Initial parsing of test.conf must be done directly in filter_test main,
    while reconfiguration is handled as a regular test. Also fix several
    minor issues in test code.

commit 3232d1718636eb7617fedc7b27378cd1d8f8691d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 16 18:05:56 2019 +0100

    Doc: Fix documentation of BGP gateway option
    
    Thanks to Nico Schottelius for the bugreport.

commit c132acae362b6106c2eecbef2d8c163acde84035
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 16 02:40:28 2019 +0100

    KRT: Remove KRF_INSTALLED flag
    
    The same information is stored in export_map of kernel protocol.

commit d3aa4f2aeddf7f546b3c0c9bd5fc7958ecb3814a
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 12 15:42:29 2019 +0100

    Filter: fix filter comparison test

commit dfb3eb771683ae4cc5ae43a990352578ab20f0fa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 10 18:53:16 2019 +0100

    Filter: Fix function comparison
    
    Check the SYM_FLAG_SAME in new symbols. The old code checked that
    in old symbols (f2).

commit 4ab54f1aefd6a3ecc5e2340cbc15d492444daff5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 10 18:18:02 2019 +0100

    Nest: Fix bitmap cleanup
    
    Channel currently does not have independent pool and uses protocol pool,
    which is freed when protocol changes state to down, while channel is
    still in flushing. Move some some cleanup code to channel_do_flush()
    so it is done before freeing of protocol pool.

commit ff2ca10cba9c5a3be690ec1a77a068e23395ef20
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 9 04:23:01 2019 +0100

    Filter: Add support for src/dst accessors for Flowspec and SADR

commit 21d09632a524c0d2a7f44a51f877370ad07b983c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 3 18:05:41 2019 +0100

    BGP: Add some statistics
    
    Add some statistic counters to BGP consistent with BGP MIB (RFC 4273),
    including persistent 'FSM established transitions'.

commit 92249894b333f7785e62b2f629dca1bbe6597c2f
Author: Matous Holinka <matous.holinka@nic.cz>
Date:   Tue Nov 26 19:33:01 2019 +0100

    CI: Add more build tests
    
    Add more Docker images with distributions (CentOS 8, Debian 10,
    Fedora 27-31, OpenSUSE 15.0 & 15.1, and Ubuntu 18.04 & 19.04).
    Fix some issues with older ones.

commit 0adfa0ec076196275a3cf034ba3ce82ffbcd2fbd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 11 00:24:07 2019 +0100

    CI: Cleanup of job templates
    
    Env templates were used for separate IPv4/IPv6 build, that is no longer
    needed.

commit 6a314d26cbcc0e75c872d6c222f93661049466b7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 10 22:58:23 2019 +0100

    CI: Update new netlab location

commit 148bd9ee92c55ba23be2d60a278dfa7ad0005971
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 10 03:43:30 2019 +0100

    CI: Minor update

commit faa43a755eba5194c50fae20dddc0e3837fe5dc5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 10 03:02:58 2019 +0100

    Apply relevant changes from branch mh-test-gitlab

commit 5176455f1a4506e9397e23895e1de525c3c190c9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Nov 1 00:13:59 2019 +0100

    Gitlab test

commit 5ea39eaa96625ec8274703b1eb2c8f59042a8a32
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Sep 9 02:55:32 2019 +0200

    Nest: Use bitmaps to keep track of exported routes
    
    Use a hierarchical bitmap in a routing table to assign ids to routes, and
    then use bitmaps (indexed by route id) in channels to keep track whether
    routes were exported. This avoids unreliable and inefficient re-evaluation
    of filters for old routes in order to determine whether they were exported.

commit af02b83b888c693c292960072195f0e1caf1d2a1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Sep 9 02:43:39 2019 +0200

    Lib: Basic and hierarchical bitmaps
    
    Basic bitmap is obvious. Hierarchical bitmap is structure of several
    bitmaps, where higher levels are conjunctions of intervals on level
    below, allowing for efficient lookup of first unset bit.

commit d033e6327d1e63f5d212981fca785b5086491905
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 26 16:43:09 2019 +0100

    CLI: Fix continuation lines after final one
    
    Continuation lines may use short form (with space instead of message
    number), but this should not be done when previous line is final.
    
    Thanks to Kenth Eriksson for the bugreport and analysis.

commit 0f88200247cc61175c7a1d98a3e935aedce93f3b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 18 17:44:34 2019 +0100

    BGP: Fix processing of IPv6 Flowspec
    
    During NLRI parsing of IPv6 Flowspec, dst prefix was not properly
    extracted from NLRI, therefore a received flow was stored in a different
    position in flowspec routing table, and was not reachable by command
    'show route <flow>'.
    
    Add proper prefix part accessors to flowspec code and use them from BGP
    NLRI parsing code.
    
    Thanks to Alex D. for the bugreport.

commit 53401bef63013dfee01b65d071ffbd88e457539f
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Nov 12 18:13:21 2019 +0100

    Netlink: Handle IPv4 routes with IPv6 nexthops
    
    Accept RTA_VIA attribute in all cases. The old code always used
    RTA_GATEWAY for IPv4 / IPv6 and RTA_VIA for MPLS. The new code uses
    RTA_VIA in cases where AF of network and AF of nexthop differs.

commit 0b228fca04c8a9a81af6a4973877ceba9aede3f0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 10 02:06:07 2019 +0100

    BGP: Add option to enforce first AS in AS_PATH
    
    This is optional check described in RFC 4271. Although this can be also
    done by filters, it is widely implemented option in BGP implementations.
    
    Thanks to Eugene Bogomazov for the original patch.

commit becda5638a8ff8b056ec04b5e156e86b168cb9ef
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 5 16:29:47 2019 +0100

    Doc: Minor fix

commit d54a69ac7f0a29846cd9dbc697d1d369f51988bb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 5 16:00:25 2019 +0100

    Doc: Add documentation for BGP option 'allow as sets'

commit 10c4cd9677555e88a4ac8c95784aa281655e3326
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 5 15:14:57 2019 +0100

    Filter: Add type info for more instructions

commit 87512e97516160ec980e9d0621522ada405438fe
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 5 15:13:57 2019 +0100

    Filter: Improve typecheck error messages

commit c00c20a79941b2bbed9e957134259763dcbb29f0
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Oct 23 22:56:23 2019 +0200

    Filter: Better constant promotion
    
    We use constant promotion from IPv4 to Router-ID values, as they have
    same literals. Instead of ad-hoc code in filter instructions, add
    constant promotion code to parse-time typecheck code.

commit 26194bd684b2926740a74ebdfe73e6afc3c145b6
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Oct 23 22:53:23 2019 +0200

    Filter: Improved parse-time typechecks

commit 6fbcd8914aa2b0e0f50c6f20a15cd6eb1ba44497
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Oct 22 19:19:36 2019 +0200

    Filter: Parse-time typechecks
    
    Most expressions can be type-validated in parse time. It is not
    strong enough to eliminate runtime checks, but at least one gets
    errors immediately during reconfigure.

commit a52476c9be41e8d33e4a22e3dc733240ce791b42
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 4 22:07:03 2019 +0100

    BGP: Add option to reject AS_SETs
    
    There is a pending draft to make them obsolete

commit 0edf0c8cd919a8b3fbf5bc036f27ea0b4ed0b91a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 3 20:26:54 2019 +0100

    Support for address family constants
    
    We already had them defined on BGP level, but they are more general.

commit 08c4c9a30b7ed61be39ddc71aebd69a0fea6a55a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 3 20:25:42 2019 +0100

    Nest: Fix bug in export table
    
    For regular channels do not compare src in export table, as we want to
    keep here only the best (exported) route per network.

commit be7c1aef429092bb90167a7f1b5c33b74a8030c2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Oct 26 01:28:38 2019 +0200

    BGP: RFC 8654 got released

commit 498d8145c0984acf6b39d7e312950315571e7030
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Oct 25 13:28:51 2019 +0200

    Nest: Fix primary flag in show route
    
    The route is changed by rte_make_tmp_attrs(), so we need to compare
    net->routes to the original one.
    
    Thanks to Kenth Eriksson for the bugreport.

commit ec331acf48535211fb5b50c87e74bf1c8370283a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 24 17:47:45 2019 +0200

    BGP: Fix handling of transitive extended communities
    
    Transitive extended communities should be removed on external sessions,
    the old code them in all cases.
    
    Thanks to Jean-Daniel Pauget for the original patch.

commit 5ce881be82d6698c32e36add9ed6e1643150c3f3
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Oct 22 16:20:38 2019 +0200

    Accept uppercase letters in iproute2 names
    
    Names read from texfiles in /etc/iproute2/* are normalized by replacing
    non-alphanumeric chars with underscore. The patch fixes handling of
    uppercase letters, which were handled as non-alphanumberic.
    
    Thanks to Igor Gavrilov for the bugreport.

commit f9eb9b4cab65b850c61738dd56632bae0e7329ca
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Sat Oct 19 12:50:27 2019 +0200

    Nest: Fix build without protocols
    
    (CHECK keyword added by commiter)

commit 4e23b499696da81acf0ed5ad181573b94ccdb9a3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Oct 19 03:37:43 2019 +0200

    RPKI: Fix handling of IPv6 cache addresses
    
    The old code used just sizeof(struct sockaddr) bytes of IP address.

commit b000a94275d7bb81868b9d6ad7582e5a3939532a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Oct 11 00:18:38 2019 +0200

    NEWS and version update

commit 6c9cda6f924ec400e6e55ed009bfaf7a7fd9819d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 10 23:33:40 2019 +0200

    BGP: Fix reconfiguration with import table
    
    Change of some options requires route refresh, but when import table is
    active, channel reload is done from it instead of doing full route
    refresh. So in this case we request it internally.

commit eeb2c61653cb8a912a1c92ad3b98932245c2c202
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 10 22:43:41 2019 +0200

    Doc: Minor documentation fixes
    
    Thanks to Christoph for the bugreport.

commit 843b10c8b0c28ed3bea9a37b166500aabf5e930f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 10 15:25:36 2019 +0200

    Nest: Handle non-MPLS on MPLS case in recursive route update
    
    When non-MPLS recursive route resolves to MPLS underlying route,
    then it should get MPLS labels from the the underlying route.

commit 9eace84342bc879abf371a84f8af3bd697e1c0a2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 10 15:06:32 2019 +0200

    Nest: Handle PtP links in recursive route update
    
    Underlying (IGP) route may lead to PtP link, in this case it does not
    need gateway. Which is different than direct route without gateway.
    
    When recursive (BGP) route uses PtP route, it should not use recursive
    next hop as immediate next hop, while for direct routes it should.

commit cb2b6e0494e685fc4cce52a1d449ffd69bec351e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Oct 10 14:01:16 2019 +0200

    Nest: Fix recursive route update
    
    Missing cleanup can lead to dangling pointer to old next hops.

commit 09ee846d9275b4cb0b77f7e458aba6a71b111c52
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Sep 28 14:17:20 2019 +0200

    BGP: AIGP metric support (RFC 7311)

commit 759b204be33fa8485c9e28038ee029a49e2e9d3f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Oct 1 17:01:29 2019 +0200

    Lib: Support for 64-bit numbers in bvsnprintf()
    
    Use 'l' for s64/u64 instead of for long/ulong, as that is much more
    useful. Also make number() correct with regard to signed/unsigned
    typecasts.

commit cc95b4594ac924b40325a4f1adcae5312179db40
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Sep 30 13:54:14 2019 +0200

    Build: Pass -g to cc called as linker to explicitly keep debug info

commit d6eea6caee187dc5f6d8ed585a59031039a5c523
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Sep 23 15:41:55 2019 +0200

    Testing measures times

commit 368f70604f347e310ca70828bfdd2504fd116064
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Sep 25 16:37:16 2019 +0200

    LTO: debug info also kept with the final binary

commit 6dda6931d1d8f99d944d85770e235bfe75db0eb6
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Aug 21 17:35:27 2019 +0200

    Perf: allow testing with cached route attributes.

commit 15a758378716a0af1d198c55d56a66da4ef08c93
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Tue Oct 8 14:20:25 2019 +0200

    Doc: Fix duplicated lines
    
    Thanks to elados93 for the patch.

commit c41a914d6e9be91cda40c7e7c05a8b4f2b515089
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Sep 30 13:53:24 2019 +0200

    Testing: Don't call vsnprintf with NULL format

commit 24493e9169d3058958ab3ec4d2b02c5753954981
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Oct 4 12:20:02 2019 +0200

    Fixed undefined behavior on signals.
    
    The C11 specification allows only sig_atomic_t and _Atomic variable
    access. All other accesses to global variables are undefined behavior.
    
    Using int was probably OK on x86 and x86_64; yet there were some reports
    from other architectures (especially some MIPS) that in rare cases,
    after issuing SIGHUP, BIRD did strange things.

commit 4821251ebb13c05e8752f6f54b8e5ad6d87fecaa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Sep 30 19:10:14 2019 +0200

    BFD: Fix reconfiguration of neighbors
    
    The bfd_reconfigure_neighbors() returned after first reconfigured
    neighbor instead of continuing with the next one.
    
    Thanks to Winston Chen for the bugreport and a patch.

commit ca2dacfcee92d8cfecff74dd020c2d16202b0d5c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 24 17:12:15 2019 +0200

    Nest: Fix bug in export table
    
    Exported route may be in modified state, we need to get cached one for
    rte_same() and rta_clone() to work properly.

commit ea0917bcba86d354f9c8516a4f114c38d04f890b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 24 00:18:48 2019 +0200

    Filter: Fix eval command

commit 9c79022153c6ef3a6c35b2db8be6b259104e67f3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Sep 22 23:32:22 2019 +0200

    Nest: Fix help for 'graceful restart' command
    
    Multi-worded commands are not automatically added to top-level
    help output.
    
    Thanks to Christoph for the bugreport.

commit 3f477ccb03ed99cf6754baaca179fcf791bcda55
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Sep 20 10:16:51 2019 +0200

    Filters: Function body comparison result now used.
    
    Function bodies were compared in post-parse time, yet the result was not
    used and the functions were incorrectly considered the same as before.
    
    Now the result is used to reload affected protocols.

commit eb1e43a9af9e1905b754f1f191d228e2676ce181
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 17 14:45:14 2019 +0200

    BGP: Fix setup with multiple dynamic BGP ranges
    
    Based on a patch from Liam Nattrass, thanks.

commit 5235c3f78da15826b0654ba68dc7a897faa42c98
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 10 17:34:41 2019 +0200

    NEWS and version update

commit 532471967e6d92ae7a480367cc6d935cca75c7b2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 10 17:28:06 2019 +0200

    Doc: Update BGP mask documentation

commit 452e90ba72f57c44b44f9940ac951d2fde417583
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Sep 10 13:45:18 2019 +0200

    Filter: Fix crash with 'where' filters and function calls
    
    The old 'where' code computed size value incorrectly, which leads
    to invalid instruction lines and filter errors or crashes.

commit 1127887a8b111dab18c592f1f3f575920f38bfe3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Sep 9 13:17:30 2019 +0200

    BGP: Fix handling of bgp_aggregator atttribute
    
    The attribute should not be modifiable by filters as we do not
    support its type.

commit 8388f5a7e14108a1458fea35bfbb5a453e2c563c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Sep 9 03:13:35 2019 +0200

    BGP: Fix bugs in handling of shutdown messages
    
    There is an improper check for valid message size, which may lead to
    stack overflow and buffer leaks to log when a large message is received.
    
    Thanks to Daniel McCarney for bugreport and analysis.

commit 56d8b1e7f6252158caf0ecd3147376b858b16d97
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Aug 29 20:58:16 2019 +0200

    OSPF: Fix 'show ospf lsadb' cmd without proto arg
    
    It crashed when used without protocol argument.
    
    Thanks to Alexander for the bugreport.

commit 32a254050d3da57ca6d7627aa606a8dce11907ee
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Aug 26 21:53:56 2019 +0200

    Channel refeed with import table splitting between routes for one prefix

commit 5ab3447de18235de566eb5116c0aec24050f5f85
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Aug 21 17:30:00 2019 +0200

    Sysdep: Drop supplementary groups when dropping GID
    
    We forgot to do that. Oops.

commit 4fa0e472cf3e8c61a3f67e91d201dbc12ea94221
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Aug 21 17:16:08 2019 +0200

    BGP: Use reallocation for capability structure
    
    Instead of having large stack buffer for max amount of AFI/SAFI pairs.
    The old code is not correct w.r.t. extendeded option length, as more
    AFI/SAFI pairs may fit into the capability option.

commit 524d2538537b2530bf031daa1d5c8e4653f92c5c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 20 19:12:59 2019 +0200

    BGP: Implement extended optional parameters length
    
    Extends BGP options/capabilities data length to 16bit, to avoid issues
    with too many capabilities. See draft-ietf-idr-ext-opt-param-07

commit a297a4f044bcc7c38549710a720bc1f97df9ba65
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 13 18:57:40 2019 +0200

    Nest: Fix crash in route reload when some channels are not up.
    
    Only channels that are up can be reloaded.

commit b7d7599ce3576f28310af18b403fed49a0840b67
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 13 18:22:07 2019 +0200

    BGP: implement Adj-RIB-Out
    
    The patch implements optional internal export table to a channel and
    hooks it to BGP so it can be used as Adj-RIB-Out. When enabled, all
    exported (post-filtered) routes are stored there. An export table can be
    examined using e.g. 'show route export table bgp1.ipv4'.

commit dfe63ed84d42178a53b01071c64f23250e74d6d9
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Aug 13 16:45:27 2019 +0200

    Filter: Fixing empty block and never-executed-statement bug

commit 70a4320bdd44122d7a93bc71c77a9d684b3c9adc
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Aug 12 00:41:36 2019 +0200

    RAdv: Allow solicited RAs to be sent as unicast
    
    Add option to send solicited router advertisements as unicast directly
    to soliciting nodes instead of as multicast to all-nodes group.

commit 9f3e09832081bc029dc98ae6dda49ee86d138fde
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 6 18:54:19 2019 +0200

    Filter: Allow to use set constants / expressions in path masks
    
    Allow to not only use set literals in path masks, but also existing
    set constants or set expressions.

commit ef113c6f725349a2ab52f3cbef18403f82c84134
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 6 16:58:13 2019 +0200

    Filter: Allow to use sets in path masks

commit e2b530aa729f9c5973e498b45dd6f55ab669d1ac
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 6 15:29:06 2019 +0200

    BGP: Improve reconfiguration
    
    Several BGP channel options (including 'next hop self') could be
    reconfigured without session reset, with just route refeed/refresh.
    The patch improves reconfiguration code to do it that way.

commit f6a6a77640a9749c79a91300d130ba6b5941d408
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 6 15:09:42 2019 +0200

    BGP: Fix 'deterministic med' to work with 'merge paths'
    
    The 'deterministic med' option is implemented by suppressing other than
    best-in-group routes (grouped by ASN) from best route selection. This
    interferes with 'merge paths' as supressed routes are no longer mergable
    with best route. This is fixed by suppressing only those routes that are
    not mergable with best-in-group route.

commit 8c42205e35e24537122a4c821bd3128d698abf1b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Aug 6 14:53:02 2019 +0200

    Configure: CFLAGS update
    
     - add -flto only to default CFLAGS
     - add -fno-strict-aliasing, -fno-strict-overflow always
     - remove -Wno-implicit-fallthrough

commit cc02da816fb062c93b4f0d61b0cfa02b673a5e00
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Aug 1 14:49:03 2019 +0200

    Show LDFLAGS in configure

commit 3ffb0c4f25eff926989867b4a7f604f54d68281b
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Aug 1 14:45:23 2019 +0200

    Enable more threads for flto

commit de41d24a3d67c98d7330551bcf7549c007b89ae8
Author: Ondrej Zajicek <santiago@crfreenet.org>
Date:   Thu Aug 1 14:27:20 2019 +0200

    Fix output of CFLAGS in configure script

commit 543875e080969876c33d365474589899c1f960e3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 31 23:35:29 2019 +0200

    NEWS and version update

commit 96e4d0960c2b1bb01dc90ebfe341af8e4284090a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 31 19:45:29 2019 +0200

    Change 'graceful down' command to 'graceful restart' and update docs
    
    The command initiating planned graceful restart including bird shutdown
    should be called 'graceful restart' instead of 'graceful down', as the
    later should be reserved for graceful shutdown in style of RFC 8326.

commit 8c703ecf73d7ccbd5e767858ba47a5f3ad0bc439
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 30 19:21:06 2019 +0200

    Doc: Update documentation about VRFs and BFD

commit 2de1e2062eba66893a36f5a84f922c880ab6c351
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 30 14:28:40 2019 +0200

    Conf: Fixed symbol redefinition

commit 48addc88be27c46d83805ec2854bf1b5e0f0ddb3
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 30 12:11:49 2019 +0200

    Log: Fixed race condition in reconfigure while BFD is running

commit 3b62417c356796a35229ce07238abf98fb569ccb
Author: Vincent Bernat <vincent@bernat.ch>
Date:   Mon Jul 29 15:42:30 2019 +0200

    RPKI: Fix allocation of hostname when using an IPv6 address

commit 00284f0ed67370c7c697adf20b08840482ea18ea
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jul 25 14:24:16 2019 +0200

    BFD: Fix formatting of 'show bfd sessions'
    
    The formatting was broken due to longer date in 'since' column.

commit cec40a74679821513e627f93b924067a404f6475
Merge: 18f70a62 8263690e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 24 15:38:32 2019 +0200

    Merge remote-tracking branch 'origin/mq-filter-stack'

commit 18f70a6229f586d5e4f387075be42d7a1ef5d269
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 24 15:08:03 2019 +0200

    Nest: VRF of protocol can be explicitly specified as 'default'
    
    Protocol can have specified VRF, in such case it is restricted to a set
    of ifaces associated with the VRF, otherwise it can use all interfaces.
    
    The patch allows to specify VRF as 'default', in which case it is
    restricted to a set of iface not associated with any VRF.

commit 048c2f0e8cc1451b1fa48e915e0bb5e124aa9d26
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 23 17:02:41 2019 +0200

    OSPF: Fix formatting of 'show ospf neighbors'
    
    The formatting was broken when too short router-id was used.

commit 15b0a9229431dc75425c229b2f94e680db49d594
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 23 01:52:18 2019 +0200

    RPKI: Fix reconfiguration when ssh parameters are undefined

commit d843c274781bf9d30bfba93229b9f02a88f26fe2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jul 18 02:39:35 2019 +0200

    Lib: Improve printf() tests
    
    Includes patch from Maximilian Eschenbacher

commit 39edf4abcafda429f33f98c31ae11bf6a27ab18e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jul 18 01:57:26 2019 +0200

    Lib: Fix print of 64-bit router id
    
    Mismatched types to printf(). The old code coincidentally worked on amd64
    due to its calling conventions.
    
    Thanks to Maximilian Eschenbacher for the bugreport.

commit cf7ff99513728e4e405508e5ccd7522289d4ec82
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 17 16:20:35 2019 +0200

    BFD: Support for VRFs
    
    Allow multiple BFD instances in separate VRFs, dispatch BFD requests
    according to VRFs.
    
    Thanks to Alexander Zubkov for notice and patches.

commit 2eaf65ec607b68748744fa8e0d596cf1f3ba117a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jul 15 18:16:55 2019 +0200

    Netlink: Fix parsing of multipath routes with MPLS labels

commit 8235c4747dcc92de2ea991f78cdf9c6b8fa7f522
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Jul 15 16:23:18 2019 +0200

    Netlink: Use route replace for IPv4
    
    Use route replace netlink op instead of delete+add netlink ops for kernel
    IPv4 route replace. This avoids some packetloss during route replace.
    Still use the old behavior for IPv6, as some kernel bugs are hidden in
    IPv6 ECMP handling.

commit 8263690e754a83b8f3c58bd0080a1628d6cba556
Merge: efd7c87b 1aec7112
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 16:07:16 2019 +0200

    Merge remote-tracking branch 'origin/master' into mq-filter-stack

commit efd7c87b5bcd476ba74ffe9f369e2f6fe978cbb1
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 15:43:47 2019 +0200

    Filter: further split of print & die to FI_PRINT, FI_FLUSH and FI_DIE

commit 3782454e8dead1184e698fa84f7491182b54454e
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 15:23:35 2019 +0200

    Filter: Simpler filter context allocation

commit f634adc7dcf8cfc2a8ea8a61fe2f85d8aadf5a75
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 15:17:04 2019 +0200

    Filter: FID_MEMBER debug string is a C constant string

commit c0999a149c223fa9c622552a314c767e6a640bf6
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 15:12:18 2019 +0200

    Filter: Converted FI_PRINT and FI_PATHMASK_CONSTRUCT to VARARG

commit c29d73a06a8052f653e85f6472c663f70f6706cc
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 15:06:52 2019 +0200

    Filter: fixed excessive stack allocation in functions with args but no local vars

commit 0da06b7103a5601fb7c224ab82a6d3799cb55308
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 13:19:01 2019 +0200

    Filter: lots of documentation

commit 1b9db6d4a7d8ab9f3ada5d21f8f05c3c8bf3c2e2
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 12:03:47 2019 +0200

    Filter: Don't write out when re-evaluating filter for internal purposes.

commit 547be53b8cefc6d346cf13dcedb3e527c3472b06
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 15 12:03:13 2019 +0200

    Filter: Don't fail badly when trying to access non-existent route in config time

commit 1aec7112f7314c3e9a4d8b9440dd85a782295310
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 10 18:25:36 2019 +0200

    OSPF: Fix handling of NSSA option flags
    
    Per RFC 3101, N-bit signalling NSSA support should be used only in Hello
    packets, not in DBDES packets. BIRD since 2.0.4 verifies N-bit in
    neighbor structure, which is learned from DBDES packets, therefore
    NSSA-LSAs are not propagated to proper implementations of RFC 3101.
    
    This patch fixes that. Both removing the check and removing N-bit from
    DBDES packet. This will fix compatibility issues with proper
    implementations, but causes compatibility issues with BIRD 2.0.4.

commit bfa15a642f8e262af5c18ba5898597a20bdf4e2f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jul 10 16:46:31 2019 +0200

    Filter: Minor cleanups

commit b2a4feeb4c877ff56d9b2ebd8119225c53ea40db
Merge: eac9250f 422a9334
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jul 10 11:27:08 2019 +0200

    Merge branch 'master' into mq-filter-stack

commit 422a9334294dd9a5b13abd8563a3dc7233e64b13
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jul 10 11:12:41 2019 +0200

    Debug: growing message format buffer
    
    This led in corner cases to undefined buffer content
    and garbage output.

commit deb84d79896cca3ac10ff9f853604f845c9420a7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 9 15:57:46 2019 +0200

    OSPF: Minor fix in graceful restart
    
    Most LSA origination is blocked in ospf_update_topology(), this fix
    blocks LSA origination from ospf_rt_spf().

commit e840cb9cd54162efca72137f53fddbb0e490d6fe
Author: Vincent Bernat <bernat@luffy.cx>
Date:   Tue Jul 9 15:25:40 2019 +0200

    Doc: Fix typo in BGP dynamic names feature description

commit 74a38adb6b4b4bf2a67e7a779a7c95b0ef1b9894
Merge: 1322e205 2872ab92
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 9 14:53:15 2019 +0200

    Merge branch 'master' of gitlab.labs.nic.cz:labs/bird

commit 1322e205e2066c0da8526bed505dc699d0f5b92a
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 8 11:19:04 2019 +0100

    Test: Fixed annoying warnings (and possible obscure bugs).

commit bb001af0e8022f6445ff50b7f32c9ac102cc244e
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 9 14:34:26 2019 +0200

    Test: better random u64 generator

commit 2872ab927ecb94b1555f5e3c8bd33021261d0c54
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 9 03:48:02 2019 +0200

    OSPF: Update DR when local priority changes
    
    When priority is reconfigured locally, we need to trigger DR election.
    
    (recommiting, was reset by the previous commit)

commit 85840d4c03552a69927b666774fa39921e7b1047
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 9 03:31:54 2019 +0200

    OSPF: Fix handling of external routes on graceful restart
    
    We need to flush learned external LSAs a bit later than other LSAs (after
    first feed after end of the graceful restart) to avoid flap of external
    routes.

commit 05e3933c06b488e71c9c149c25aec9c733a8bd1f
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 8 13:04:50 2019 +0200

    Nest: Uninitialized variable fix
    
    Thanks to Vincent Bernat for reporting this.

commit 2ce25ebbefd2eaf517361a446fe40679e78e23e9
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 8 13:00:13 2019 +0200

    Libdmalloc macros fixed

commit fa1e0ba35416561bda3708ec808d24641dd8995f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jul 4 13:34:42 2019 +0200

    OSPF: Update DR when local priority changes
    
    When priority is reconfigured locally, we need to trigger DR election.

commit eac9250fd5b10809830361b94438339b3b31b270
Merge: 8816b6cd 026bfedb
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jul 3 11:09:52 2019 +0200

    Merge branch 'master' into mq-filter-stack

commit 8816b6cdd98d24535eece6b5e35730aac57cd9f7
Merge: c376555c 84ac62d3
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jul 3 08:44:42 2019 +0200

    Merge branch 'mq-filter-stack' of gitlab.labs.nic.cz:labs/bird into mq-filter-stack

commit 84ac62d3967f5294f4dc208b803a273a101744a8
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Jul 3 08:13:07 2019 +0200

    Filter: CLI command to dump all the linearized filters

commit 0206c070ace90c48a806a74fac52ba6e6ff9858b
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Jul 3 01:23:49 2019 +0200

    Filter: Split printing and dying

commit 3265c9169dfc185ccdb787c6c83d9d8e2d0429c1
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Jul 3 00:04:24 2019 +0200

    Removed obsolete comment at as_path_cut()

commit 78976974e711e52c3b8fa6a80b290cf2fa4f692d
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Jul 3 00:00:11 2019 +0200

    Dynamic attributes definition split whether it is bitmask or not.

commit 263fa2c4a6bf226172a6aef9a6b8198a5901c5bf
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Jul 2 22:57:00 2019 +0200

    Filter: Dropped some more irrelevant whitespace from generated files

commit 59d3a3611f05c05040cec4bf09f31c26ade0fa0a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 2 18:23:06 2019 +0200

    Netlink: Handle alien routes with unsorted nexthops
    
    Nest requires that nexthops are sorted, the kernel protocol have to
    ensure that for alien routes.

commit 84c58aabd0d7a6a3d1508de004a29fd22423fde6
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Jul 2 17:59:21 2019 +0200

    Filter: Nicer whitespaces in generated inst-gen.h

commit 550a6488c9e2241e2979317c04d6d73752618402
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Jul 2 17:39:56 2019 +0200

    Filter: documentation of the M4 preprocessor

commit 1187627a1dded6a3673c0d43033f431f15cd1b8f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jul 2 16:30:36 2019 +0200

    Netlink: Do unified scan for both IPv4 and IPv6
    
    Instead of separate scans for IPv4, IPv6 and MPLS, do one AF_UNSPEC scan.
    
    This also avoids kernel issue when kernel reported IPv4 and IPv6 routes
    during MPLS scan if MPLS is not active.

commit c376555cecbfea83314e9f76bce5002185d3566a
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 2 13:13:29 2019 +0200

    Filter: GCC, don't complain about indentation in generated code.

commit b40c0f028f37086991fefa9197708ba8c7b3d571
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jul 2 10:45:53 2019 +0200

    Filter: Pre-evaluation of constant expressions

commit 30667d50417f926fc948905aaab3e679b416b2e1
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 1 14:12:05 2019 +0200

    Filter: Resolving of defined constants in config time

commit 26bfe59f450c2497dabc536c3e2a604e8aa5839a
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 1 13:13:06 2019 +0200

    Filter: Moved singleton member definitions to f-inst.c

commit 4212c0e7e5647e107e6e06238a417afc44fd7f75
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 1 12:49:02 2019 +0200

    Filter: Moved f_inst allocation to separate function

commit f74d19765ea3fafdff8fd3443f50a7b309babe89
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 1 12:07:06 2019 +0200

    Filter: Getting rid of RESULT_OK. Adding RESULT_VOID.
    
    This is a preparation for filter pre-evaluation.

commit 236828d06f512b44457970795e44068d9d38ad3e
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jul 1 11:57:35 2019 +0200

    Filter: The interpreter code now shares its diversion with constructor
    
    This is a preparation for filter pre-evaluation.

commit 026bfedb332d8c0dde28c693c177fe993b5df26d
Author: Maria Jan Matejka <mq@jmq.cz>
Date:   Tue Jun 11 13:19:21 2019 +0000

    BGP: Prefix hash is too small, increase its max size.
    
    This doesn't make any change for you until you have
    millions of updates waiting to be sent. Increasing
    the max hash size from 2^20 to 2^24.

commit 9dac814ee89fe41856923a532c87ffd14dbc0f79
Author: Maria Jan Matejka <mq@jmq.cz>
Date:   Tue Jun 11 09:35:25 2019 +0000

    BGP: split tx explicitly
    
    If BGP has too many data to send and BIRD is slower than the link, TX is
    always possible until all data is sent. This patch limits maximum number
    of generated BGP messages in one iteration of TX hook.

commit bb57d9171f2b4567f54169c8864953c4e5e18025
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 30 22:30:56 2019 +0200

    Add mock-up function for unit tests
    
    They failed without it.

commit 6c0f85d5de1588b6427f6f47c1be4a220799cd70
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 30 22:11:11 2019 +0200

    Doc: OSPF graceful restart options

commit 1a2ad348f660b150265f6df759a07de8a2b6de2f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Jun 30 20:12:59 2019 +0200

    OSPF: Support for graceful restart
    
    Implement OSPFv2 (RFC 3623) and OSPFv3 (RFC 5187) graceful restart,
    for both restarting and helper sides. Graceful restart is initiated
    by 'graceful down' command.

commit 8a68316eb96be1fecf91ca395f3321aa99997ad2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Jun 18 16:27:21 2019 +0200

    Nest: Add command to request graceful restart
    
    When 'graceful down' command is entered, protocols are shut down
    with regard to graceful restart. Namely Kernel protocol does
    not remove routes and BGP protocol does not send notification,
    just closes the connection.

commit 63f49457dcc4216002742166dfecce751efa78d5
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Jun 28 11:08:48 2019 +0200

    Filter: renaming pointers for consistency
    
    The struct f_inst * is now always "what"
    and the union member pointer is always "whati".

commit 64bb1346c71cbd2764b1e0a00dc88290bec72a5a
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jun 27 15:55:48 2019 +0200

    Filter: A little cleanup of M4 interpreter generator

commit a8ab54d18d3af8e7dc9811ab8e3ba9a105131a25
Merge: 63e76204 2e077731
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Jun 25 22:40:05 2019 +0200

    Merge remote-tracking branch 'refs/remotes/origin/mq-filter-stack' into mq-filter-stack

commit 63e7620462b80c9c6bbbd4f128b6816e0748d6c6
Author: Maria Matejka <mq@jmq.cz>
Date:   Tue Jun 25 16:18:06 2019 +0200

    Conf/Filters: Moved argument count to conf scope

commit 2e0777317f373921487d80e88c376d23a842ba2c
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Jun 21 11:33:28 2019 +0200

    Filter instructions don't confuse now v1 and res.

commit a84b8b6ebb2b6825b7059e34cfaafe405ab0117e
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jun 19 14:09:57 2019 +0200

    Revert "Filter: Dropped the setter instructions in favor of direct result storage."
    
    This reverts commit bd91338246c1ba40358243f1bdf5a6dbd3a29f35.

commit 5c864e2cfaf5ff5e8e3db3ccd746162fbc7aac5b
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jun 13 14:27:58 2019 +0200

    String: bstrtoul macro expanded to bstrtoul10 and 16

commit 87c82334a77dfa3fea3057fa6d4bcf8558f203a4
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jun 13 14:24:48 2019 +0200

    Filter: removal of semantically insane consts in filter_commit

commit bdf2e55d98636eacaac8188ee0bd000cc10d217c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 12 18:02:01 2019 +0200

    Add mock-up function for unit tests
    
    They failed without it.

commit 9106a750cd76d4a76c7a60294ce3a43eede166c9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 12 16:13:21 2019 +0200

    Add CLI command to test reconfiguration status
    
    Based on patch from Kenth Eriksson <kenth.eriksson@infinera.com>.

commit 8a2cbb88d1657b4aee366605cb3d8ffcc5d3f90a
Author: Kenth Eriksson <kenth.eriksson@infinera.com>
Date:   Wed Jun 12 15:03:37 2019 +0200

    BIRD coding conventions
    
    Added Emacs config file describing BIRD coding conventions, as suggested
    by Kenth Eriksson based on existing practice.

commit d35fb9d732b05f20a556e9bda798939358459975
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jun 12 16:35:42 2019 +0200

    BGP: Fix bug introduced in one of last patches

commit bd91338246c1ba40358243f1bdf5a6dbd3a29f35
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri May 31 17:33:41 2019 +0200

    Filter: Dropped the setter instructions in favor of direct result storage.
    
    This should help filter performance a bit.

commit aa6c5f4d92f225452e432991671e7bdad185506a
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu May 30 14:42:54 2019 +0200

    Filter: Just a little comments in filter structure

commit 1757a6fce5bd23c44cc5b72a042644c4abb744c8
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed May 29 21:03:52 2019 +0200

    Filter: Stacks moved to thread-local storage if available.

commit 6479e403ef7398f48c0e1c0f1a71aa112938a357
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Thu May 23 11:27:24 2019 +0000

    Filters: If somebody doesn't like _Thread_local, don't fail for now, just be a little slower.
    
    When the parallel execution comes into place, we'll likely enforce this
    C11 feature. It's much simpler and also faster than pthread_[sg]etspecific().

commit 23e3b1e6652bac4a003a7eb1e074bdaf7ebb4900
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Wed May 22 15:16:32 2019 +0000

    Filter: Some people can't pronounce "postfixify" correctly. Let's try "linearize" instead.
    
    This is just a naming change.

commit 96d757c13fe4b2e21b265275af9ac7d1e2c3f075
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Tue May 21 16:33:37 2019 +0000

    Filter: Store variables and function arguments on stack

commit 20c6ea70ccb69f3c1d9ca46cc7941eb686f283c6
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon May 20 17:53:10 2019 +0000

    Filter: Making the filter state thread local.
    
    While having the filter code still reentrant if we really need,
    the compiler can now do constant propagation and address the
    thread local storage directly to save some computation time.

commit 9eef9c648cee7179e069ea1f978d4e86cef580d3
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri May 17 22:18:49 2019 +0200

    Lexer now returns known sym / unknown sym / keyword

commit dbbe4a783b3d4e7722bcb466673f8a1d2832fc7b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 30 16:16:50 2019 +0200

    Doc: Dynamic BGP

commit 7ff34ca2cb86f3947bf049f73e76e6ce5d57e4a8
Author: Alexander Azimov <a.e.azimov@gmail.com>
Date:   Tue Apr 30 13:55:43 2019 +0200

    BGP: Compliance with RFC8203bis

commit 0b1e1e1a007f860230855d0c9e8adc88969ee077
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 30 13:44:11 2019 +0200

    BGP: Output Local AS number in show protocol
    
    Useful for implementation of agents implementing the SNMP-BGP MIB, which
    requires the local AS of a session to be specified.
    
    Thanks to Jan-Philipp Litza for the patch.

commit e0835db4f137c1686c26165053ec9c0578b94009
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Apr 8 17:05:07 2019 +0200

    BGP: Dynamic BGP
    
    Support for dynamically spawning BGP protocols for incoming connections.
    Use 'neighbor range' to specify range of valid neighbor addresses, then
    incoming connections from these addresses spawn new BGP instances.

commit df092aa1def0419da74f15bd20582fab4ec09207
Author: Ondrej Filip <feela@network.cz>
Date:   Wed Apr 24 13:49:18 2019 +0200

    Small type in doc.

commit 6ff811976513132c831a352bd0aa0f3600252acb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Apr 12 14:11:23 2019 +0200

    OSPFv3: Fix some overlooked cases in IPv4 mode
    
    Prefixes with max length (/32) were not handled properly.
    
    Thanks to bauen1 for the bugreport.

commit 4a50c8bd0310053a3dcab45c8dde0362348c0503
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Apr 8 16:39:22 2019 +0200

    BGP: Handle corner cases in event ordering
    
    When BGP connection is opened, it may happen that rx hook (with remote
    OPEN) is called before tx hook (for local OPEN). Therefore, we need to do
    internal changes (like setting local_caps) synchronously with OPENSENT
    transition and we need to ensure that OPEN is sent before KEEPALIVE.

commit 23ee6b1cd6dc597876d91db9a015f7a633764808
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Apr 3 15:54:50 2019 +0200

    BGP: Promiscuous ASN mode
    
    Allow to specify just 'internal' or 'external' for remote neighbor
    instead of specific ASN. In the second case that means BGP peers with
    any non-local ASNs are accepted.

commit a22c3e59683d0ea6c379a37f990e74a6d281ccef
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Apr 2 17:22:31 2019 +0200

    BGP: Separate runtime and config usage of local/remote ip and as fields

commit fe503c7c0632b385222c92b85d04526fdf36a1a3
Author: Maria Matejka <mq@ucw.cz>
Date:   Sat Mar 23 13:32:14 2019 +0100

    Filter: fixed error-checking bug in !~ operator

commit 7078aa63ae498b55c729df4a075eb28019917e81
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Mar 22 21:40:35 2019 +0100

    Fixed one warning and one undefined value.

commit 2ab680c6972306db71d9a8d4ee4fabf265981d30
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 20 16:50:58 2019 +0100

    Fixed an undefined symbol bug in CLI introduced by filter refactoring

commit 3a22a6e858cd703d254ab331183ccd56fe195c6b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 19 19:38:32 2019 +0100

    Doc: Route attribute cleanups

commit 3c3605818fb304f8de6975c56096bfafa43a8b6b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Mar 19 17:44:50 2019 +0100

    BGP: Mandatory option for channels
    
    Allow to mark channel to be mandatory, and do not allow BGP sessions if
    no common AFI/SAFI is established.

commit 7e5f769d91319b4130f7d611dd14252806892ace
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Mar 15 20:54:01 2019 +0100

    BGP: Handle case where capabilites are not used
    
    If peer does not announce capabilities at all, or when we have
    capabilities disabled, handle that as implicit IPv4 unicast.

commit 8d65add626b34256879a3e83855af3c0fa8ce4e7
Merge: 2f02c25e 5d511948
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Mar 18 12:54:40 2019 +0100

    Merge branch 'master' into HEAD

commit 5d511948cddee415c2f0f1103bda0468a193f2d6
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Mar 15 15:07:00 2019 +0100

    Build: Automatic dependency tracking for generated files

commit 2f02c25e36f3946019c24dafe9b894a9e195350d
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Mar 7 18:02:05 2019 +0100

    Perf: fixed stupid allocation bug

commit d638c1794a48dec79fa0a6c118296356754a134d
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 6 21:45:28 2019 +0100

    Gitlab CI: Drop CentOS 6 test build as unsupported.
    
    If someone wants to maintain BIRD for CentOS 6,
    feel free to send patches.

commit 875cc073b067f295cccc668008e10218f8e98dd3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Mar 14 17:22:22 2019 +0100

    Nest: Update handling of temporary attributes
    
    The temporary atttributes are no longer removed by ea_do_prune(), but
    they are undefined by store_tmp_attrs() protocol hooks. This fixes
    several bugs where temporary attributes were removed when they should
    not or not removed when they should be. The flag EAF_TEMP is no longer
    needed and was removed.
    
    Update all protocol make_tmp_attrs() / store_tmp_attrs() hooks to use
    helper functions and to handle unset attributes properly.
    
    Also fix some related bugs like improper handling of empty eattr list.

commit 9aa77fccebc4d84b5e1496884cd124d09893041b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Mar 6 18:14:12 2019 +0100

    OSPF: Improved handling of tmpattrs
    
    Keep track of whether OSPF tmpattrs are actually defined for given route
    (using flags in rte->pflags). That makes them behave more like real
    eattrs so a protocol can define just a subset of them or they can be
    undefined by filters.
    
    Do not set ospf_metric2 for other than type 2 external OSPF routes and do
    not set ospf_tag for non-external OSPF routes. That also fixes a bug
    where internal/inter-area route propagated from one OSPF instance to
    another is initiated with infinity ospf_metric2.
    
    Thanks to Yaroslav Dronskii for the bugreport.

commit e1ac6f1e301416037725b631fd6529a805e65d51
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Mar 6 15:01:10 2019 +0100

    Faster filters: documentation on what is happening there

commit a68442e0563f5b756f9a7323cea44a25ce048738
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 27 14:40:05 2019 +0100

    Fixed link time optimizer check for FreeBSD

commit b9deced219cfda2afe8604b24351ae10ac56f98b
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 26 18:19:35 2019 +0100

    NEWS and version update

commit f249d0b84c840242a084966999a1d228c603b431
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 26 16:44:24 2019 +0100

    Filters: comparison of functions and filters caching

commit 0d12aa48363802e751d3b9a4afd6eb090592d7a3
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 26 16:11:40 2019 +0100

    Build: No link time optimization when debug is enabled

commit 2915e711f77d68dff756babd19af8da1677c4549
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 25 23:28:36 2019 +0100

    Custom number parser to speed up config parsing
    
    The glibc's generic parser is slow due to its versatility. Specialized
    parsers for base-10 and base-16 are much faster and we don't use other
    bases.

commit 99911873a196975f5221aad89ae5eac42e1330e0
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 25 17:19:47 2019 +0100

    Conf: Lexer parses quoted strings in a more descriptive way

commit 7c36eb3e8bd7d06f65dc7319d42b6abe782c5b89
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 22 12:41:51 2019 +0100

    Conf: Switch for faster (and slightly bigger) lexer

commit 412614c700085ac964b07ff9405403eaf02fa5b4
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 22 12:41:51 2019 +0100

    Conf: Switch for faster (and slightly bigger) lexer

commit 93af78d2d29ce11e20d46f60cfe1d3ef68052e5c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Feb 22 02:16:39 2019 +0100

    Nest: Do not compare rte.flags during rte_update()
    
    Route flags are mosty internal state of rtable, they are not significant
    to whether a route has changed. With the old code, all routes received as
    a part of enhanced route refresh are always re-announced to other peers
    due to change in REF_STALE.

commit ad702bae0ce95ee1913327dd13a877e6bf9b320d
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 20 22:14:28 2019 +0100

    Enabled link time optimization.

commit d1039926f5ee5a4e0442919474f16f3c93385cc9
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 19 12:34:16 2019 +0100

    Filter: Interpreter merged into the common m4 generator.
    
    The config-time partial evaluation of constant expressions in filters is nearby.

commit 32793ab685b047b553d6f7afc23b3245e8850e4a
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 18 14:57:15 2019 +0100

    Filter: Fixed bugs in FI_CALL and FI_SWITCH

commit d348a916f57cb0ac390718295624dd9a1cf2d32a
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 18 14:56:49 2019 +0100

    Test: Added -d flag to die directly after first error.

commit d4bf74816faf9955297f93f8bb6973c1f600dbe2
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 18 14:56:10 2019 +0100

    GDB: Added more pretty printers for filters

commit ea4f55e3dcd472bb6d18c030839597ffd9583462
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 15 23:59:44 2019 +0100

    Filter: More cleanup -- customized structures also in struct f_line_item

commit 0b39b1cbb70c6f37a30a3130e1c308ddd0ba36de
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 15 13:53:17 2019 +0100

    Conf: Symbol implementation converted from void pointers to union
    
    ... and consted some declarations.

commit 132529ce8908661fd2baa0758c335006fb039ef0
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 13 12:25:30 2019 +0100

    Filter: merged filter compare functions into common M4 file

commit dd4d409551ae22d0a9bf4e3a6edc6fb9656911b9
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 12 20:37:32 2019 +0100

    Filter: Merged postfixify routine

commit de12cd18fb213ee9cc872fec77b789f34cfd7cc4
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 12 14:16:28 2019 +0100

    Filter: Merged filter line item dumpers into common generated source

commit b256f241459c51224a4bf428f4bc5dfa44882920
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 12 11:35:41 2019 +0100

    Filter: auto-generating enum-to-string

commit 041608129ab15b5eab6fb607c45ddd2d748295b5
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 12 11:31:18 2019 +0100

    Filter generator: workaround for M4 claiming all the put-around code be on one line

commit 5289304519918f62d099463123bf6c69a0dd497e
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 11 17:12:48 2019 +0100

    Filter data manipulation functions separated to their file

commit 87bd7cd7b03f24c9d7c37a2a060ef553f26ead29
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 11 16:44:14 2019 +0100

    Filter: split the constructors to a separate file

commit 75206f266f8534367b88401be463953b7d5dc770
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Feb 11 15:27:47 2019 +0100

    Conf: Fixed makefiles

commit 4f082dfa892e95f86ca8137410992a248110b6ef
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 8 13:38:12 2019 +0100

    Filter: merged filter instruction constructors, counting line size on instruction construct

commit 0a793ebc6059f4354c62ccec62ef7c950988ca4a
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 8 11:19:04 2019 +0100

    Test: Fixed annoying warnings (and possible obscure bugs).

commit 8bdb05edb2b4e1d2989ed98d67992047ad69443c
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Feb 7 21:25:38 2019 +0100

    Filters: split the large filter.h file to smaller files.
    
    This should be revised, there are still ugly things in the filter API.

commit c1e97169cd96ce39337e75cfdf6882b180341f09
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 6 14:41:39 2019 +0100

    Filter: M4 convertors polished a bit.

commit c0e958e022aac79f69e6aca2652fdb6a529e68e2
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jan 30 14:03:47 2019 +0100

    Filter + Config: Fix bugs, tests and split symbols by type

commit 713658798dfafabcd0a74f510c1639f6e3c9c820
Author: Maria Matejka <mq@ucw.cz>
Date:   Wed Jan 23 17:08:27 2019 +0100

    GDB pretty printers: f_inst and f_val.

commit 9b46748d5b50d1e8c242a571e80fe1f9f33aeb73
Author: Maria Matejka <mq@ucw.cz>
Date:   Mon Jan 21 09:17:54 2019 +0100

    Filter: refactoring of instruction constructors

commit 4c553c5a5b40c21ba67bd82455e79678b204cd07
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 27 14:26:11 2018 +0100

    Filter refactoring: dropped the recursion from the interpreter
    
    This is a major change of how the filters are interpreted. If everything
    works how it should, it should not affect you unless you are hacking the
    filters themselves.
    
    Anyway, this change should make a huge improvement in the filter performance
    as previous benchmarks showed that our major problem lies in the
    recursion itself.
    
    There are also some changes in nest and protocols, related mostly to
    spreading const declarations throughout the whole BIRD and also to
    refactored dynamic attribute definitions. The need of these came up
    during the whole work and it is too difficult to split out these
    not-so-related changes.

commit 967b88d9388b3800efed45798542cd0b41f2b903
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 16:25:54 2018 +0100

    Filter refactoring: The instructions are converted to the switch body by M4

commit 8436040735b84bb185311125bfc91375f740fd86
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 16:07:59 2018 +0100

    Filter refactoring: Drop the roa check specific f_inst

commit ca2ee91a80aa87b7f18898c28e93ff22cebf73d7
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 15:25:04 2018 +0100

    Filter refactoring: The constant f_val is simply included inside the instruction
    
    With 32 bits, size of the args is 12 bytes, the f_val is 20 bytes.
    With 64 bits, size of the args is 24 bytes, the f_val the same.
    
    This is not so nice on 32 bits, anyway the f_inst itself is
    24 vs. 32 bytes and the overall size of filters must be 32k of
    instructions to get to one megabyte of RAM eaten by f_inst.
    
    Therefore it seems to be improbable for common user to get into
    problems with this change.

commit 7f0ac73724f7383a2bcc229910414d339dbd2434
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 14:55:40 2018 +0100

    Filter refactoring: Changed arguments from separate unions to an array

commit 224b77d4f786ea09bb2632476a89f0976baafd64
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 14:34:35 2018 +0100

    Filter refactoring: Converted condition to three-args instruction

commit 8e8b1fe48cfcb92d54e15df5198e8cef9bc3dd8e
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 14:29:47 2018 +0100

    Filter refactoring: Some instructions eat up excessively much space.

commit c577493908a9cda9008cc4043d0473b69fb2da66
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 20 14:05:32 2018 +0100

    Filter refactoring: Expanded the short instructions with common code.
    
    This will make the further changes more straightforward.

commit a8740d6c09547dd9fe445b3deb5238305c0a5959
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Dec 18 17:10:05 2018 +0100

    Filter refactoring: indentation fix

commit fc8df41ec6cd5e6e3d53036a97dc7219dbbade5e
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 15:00:01 2018 +0100

    Filter refactoring: The values are now saved on a custom stack.
    
    This shall help with performance.

commit 7afa1438866fa94454ba133608b6877171f71d37
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 13:51:11 2018 +0100

    Filter refactoring: Passing the resulting struct f_val as a pointer.
    
    This also drops the multiplexing of errors with the f_val itself
    together with the T_RETURN f_val type flag.

commit f62a369fb48be066560d6e8f0df82eef9c464ef0
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 13:08:08 2018 +0100

    Filter refactoring: Moved filter instruction definition to a separate file

commit 25566c68109381178e0305f3e7e1464dea15b90b
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 12:58:01 2018 +0100

    Filter refactoring: Moved the bitfield bit position formula to route.h

commit aca8263926df6156322e1a1157886f1cad2486b1
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 12:48:33 2018 +0100

    Filter refactoring: Moved the interpret macros inside the block

commit 02dcbf343d94dd548605c5efbf724f89d81d7258
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Mon Dec 17 12:45:21 2018 +0100

    Configure: Don't check for implicit fallthrough unless when debugging.

commit a946317fab9776754192f679f38cb7789050c52d
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Tue Feb 27 15:39:39 2018 +0100

    Filter: Converted static global variables to a filter_state struct.
    
    The static filter state was messy and blocked the planned parallel
    execution of filters. Anyway, this will be also slower as the state
    structure must be passed almost everywhere with us.

commit ae294cc2d02ec02cbea11c275b64e7637ba0ea68
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 19 18:30:28 2019 +0100

    HTML are no longer generated in srcdir

commit 900fda4411a5346f808a575101b1260b5f73fa93
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 19 18:20:07 2019 +0100

    Doc: Detect SP/OpenSP automatically

commit 3a8ca7abbcf6452fa56d0c1c6ddcf7d5bd6876ed
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 19 16:26:09 2019 +0100

    Nest: Prevent withdraws from propagation back to source protocol (for accepted mode)
    
    Update for one of previous patches, handles the the issue for
    first-accepted mode of route propagation.

commit bf8d7bba9ef3c6d95661f97dc71fa7a6b2cf0b87
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 17 01:54:01 2019 +0100

    OSPF: Reset LSAs during area type change
    
    When area is reconfigured to a different type, we need to flush LSAs as
    they may not be valid (e.g. NSSA-LSA for non-NSSA area). Also, when we
    have have just one OSPF area and that changes type, we could restart OSPF
    as there is no state to keep anyway. That solves issue with different
    handling of external routes exported to OSPF based of main area type.

commit 4a3f5b36173299d44e26dc18db4e5d103875f8c4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Feb 13 15:40:22 2019 +0100

    OSPF: Basic support for DN-bit handling (RFC 4576)
    
    External LSAs originated by OSPF routers with VPN-PE behavior enabled are
    marked by DN flag and they are ignored by other OSPF routers with VPN-PE
    enabled.

commit 1e958e52d3ef0c38e5fb5e673bcce95d1c28ac0e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Feb 9 16:15:01 2019 +0100

    OSPF: Do not originate Router-Information LSA
    
    As we do not have much usage for it yet.

commit cd16538fc91778e31f8241f62ee47056f099c051
Merge: 6e8fb668 f9b97f1c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Feb 9 15:53:16 2019 +0100

    Merge remote-tracking branch 'origin/mq-opt'

commit 6e8fb66859a17b295cd9246264221a75cdbe6c55
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 5 19:00:43 2019 +0100

    Nest: Improve export counter handling
    
    One of previous workarounds for phantom route avoidance breaks export
    counters by expanding sending of spurious withdraws, which are send when
    we are not sure whether we have advertised that routes in the past.
    If not, then export counter is decreased, but it was not increased
    before, so it overflows under zero.
    
    The patch fixes that by sendung spurious withdraws, but not counting them
    on export counter. That may lead to error in the other direction, but that
    happens only as a race condition (i.e., in normal operation filters
    return proper values about old route export state).

commit 52fdd1cb76be1e278799001fa57f56888062dd86
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Feb 5 15:59:26 2019 +0100

    Nest: Report preferred counters also when 'import keep filtered' is enabled
    
    Thanks to Michal Nowak for reporting the issue.

commit a9b97cbcb74d918f3f606eb87a506712dccd2832
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 3 20:22:40 2019 +0100

    OSPF: Send direct acknowledgements as unicast
    
    Direct acknowledgements should be send as unicast to a corresponding
    neighbor. Only delayed acks should be send as multicast to all/designated
    routers.

commit 16605f2fdad730b8bb570e17192dc5f45cf15d3f
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 3 17:31:27 2019 +0100

    OSPF: Reject duplicate DBDES packets after dead interval
    
    Master may free last DBDES packet immediately. Slave must wait dead
    interval before freeing last DBDES packet and then reject duplicate
    DBDES packets with SeqNumberMismatch.

commit 9c94583a3ded3b2792bd08d88beb10100a82d7b4
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 3 16:20:37 2019 +0100

    OSPF: DD seqnum should be initialized only for first attempts
    
    After SeqNumberMismatch/BadLSReq, we should continue with the old
    seqnum++. The old code tries to do that by n->adj, but it was set
    nowhere.

commit 267da8138d7f429941f2d829b44cf9bdd94a14d6
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Feb 3 15:45:43 2019 +0100

    OSPF: Reject DBDES packets with non-matching MTU
    
    As it is specified in RFC 2328. The old code just provided warning.

commit e1c275d87b26f35c29ec8bfab0a3265810463574
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Feb 2 13:28:16 2019 +0100

    Nest: Reestablish preferred counters

commit f9b97f1c6282be398d2c2bb896dbb453f638f720
Author: Maria Matejka <mq@ucw.cz>
Date:   Fri Feb 1 14:09:01 2019 +0100

    Perf: Added forgotten all-protocol options

commit a8d0f2516c1ee0372edfc607832ae78632e404ca
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jan 29 15:19:06 2019 +0100

    Nest: FIB rehash values tweaked for better performance

commit e85e37d91d0c5fca6cb7a3ea80fac582074c389d
Author: Maria Matejka <mq@ucw.cz>
Date:   Tue Jan 29 14:22:55 2019 +0100

    Perf: Prune the table after every loop to have clean state.

commit 7411b694c3ca9db4947f577f826b622ff23e570d
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jan 31 15:03:43 2019 +0100

    Perf: Write also BIRD version to have all the needed data in the logfile

commit c65a9a05f9005d8b7369d07a3f0e99b2f205955b
Author: Maria Matejka <mq@ucw.cz>
Date:   Thu Jan 31 15:02:15 2019 +0100

    Nest: Don't lookup net in table before filters are run.
    
    Using dummy net instead. This should help with performance on rejected
    routes.

commit e84c81b76ff6af88041b55c4ed25c208f78d4826
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 30 17:25:21 2019 +0100

    Nest: Prevent withdraws from propagation back to source protocol
    
    The earlier fix loosen conditions for not running filters on old
    route when deciding about route propagation to a protocol to avoid
    issues with ghost routes in some race conditions.
    
    Unfortunately, the fix also caused back-propagation of withdraws. For
    regular updates, back-propagation is prevented in import_control hooks,
    but these are not called on withdraws. For them, import_control hooks
    are called on old routes instead, changing (old, NULL) notification
    to (NULL, NULL), which is ignored. By not calling export processing
    in some cases, the withdraw is not ignored and is back-propagated.
    
    This patch fixes that by contract conditions so the earlier fix is not
    applied to back-propagated updates.

commit ee95f281f038684a4a2613a0c54af7389afe64da
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Jan 26 21:02:35 2019 +0100

    Doc: Add documentation for OSPF retransmit delay option
    
    Thanks to Igor Podlesny for notification.

commit 1c730ee761b3c9b7ff12a0ad11c5b1768d1e4ada
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Jan 26 20:44:37 2019 +0100

    Doc: Remove doc for already removed option

commit b8a3608aa59a67364f05dbd0d0332371a200f226
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Jan 26 19:48:16 2019 +0100

    BGP: Cleanup channels when going down
    
    When going up, uncleaned old channel state may trigger unexpected
    conditions crashing bird.

commit 5a50a98980a3554b66cedda6992ece4063a0e85a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 24 22:34:33 2019 +0100

    OSPF: Opaque LSAs and Router Information LSA
    
    Add support for OSPFv2 Opaque LSAs (RFC 5250) and for Router Information
    LSA (RFC 7770). The second part is here mainly for testing opaque LSAs.

commit 954888859969587a288501b6801ab0ddb1f94133
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Fri Dec 14 16:10:19 2018 +0100

    Nest: Don't make tmp_attr before preexport is called

commit 3e60932a289e55e212dec1cbaf3bca44b2bbaeb8
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Jan 5 00:38:37 2019 +0100

    NEWS and version update

commit d7e8f00e7e35daff9bcf96aa455ebc6f932d0882
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 4 23:49:26 2019 +0100

    Unix: Remove removed option from help
    
    Also includes minor cleanup of help.

commit a1ee5eb2aae1f5e78909b36c979fd689ba319bbd
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Jan 4 17:03:48 2019 +0100

    BSD: Fix TCP-MD5 code on current FreeBSD kernels
    
    Current FreeBSD kernels require SA records for both directions.
    
    Thanks to Joseph Mulloy and Andrey V. Elsukov for reporting and
    solving the issue.

commit 4d9049dc1a57ccbf0ff9fa2642282a30e875e9e1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Jan 3 17:11:56 2019 +0100

    Doc: README and INSTALL update
    
    Minor cleanups, updates and clarifications. Also removes (incomplete
    and well-known) build steps from README, as they are better described
    in INSTALL.

commit 470740f97bfa61c3c5c79d6f2d92f2014a119031
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 2 16:01:21 2019 +0100

    BGP: Better dispatch of incoming connections
    
    Since v2 we have multiple listening BGP sockets, and each BGP protocol
    has associated one of them. Use listening socket that accepted the
    incoming connection as a key in the dispatch process so only BGP
    protocols assocaited with that listening socket can be selected.
    This is necesary for proper dispatch when VRFs are used.

commit e16b0aef31adf7000c22430adc3ceb9fc969ae14
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Jan 2 15:57:14 2019 +0100

    BGP: Postpone setting link_addr
    
    It may happen that the LLv6 address for given iface is not defined during
    BGP start, so we postpone the check to the the session establishment.

commit 4659b2ae45672868646900c81c963da221363b40
Author: Arthur Gautier <baloo@gandi.net>
Date:   Fri Dec 28 19:38:18 2018 +0100

    KRT: Fix debug messages in netlink code

commit c2d29dd197cbff6c143a570576c81bee20fc06eb
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 18 19:16:23 2018 +0100

    IO: Workaround for broken FreeBSD behavior
    
    FreeBSD silently changes TTL to 1 when MSG_DONTROUTE is used, even when
    it is explicitly set to another value. That breaks TTL security sockets,
    including BFD which always uses TTL 255. Bad FreeBSD!

commit 82b742533bdbf977ec95997fc0011a47a672bcc8
Author: Maria Matějka <mq@jmq.cz>
Date:   Fri Oct 26 09:32:35 2018 +0200

    Perf: Protocol to measure BIRD performance internally
    
    This protocol is highly experimental and nobody should use it in
    production. Anyway it may help you getting some insight into what eats
    so much time in filter processing.

commit 78131eee64aeaf14cf418d6e5bf3f17ca602afb7
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Fri Dec 14 15:50:44 2018 +0100

    Debug: support for -gdwarf-4 is not available everywhere

commit bda5863425854cc1c705c6f428e952bafd01d2a1
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 18 14:41:12 2018 +0100

    Nest: Handle labels_orig correctly in attribute cache

commit cea2e25f417866129ce7e78f1c078e993743173c
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 17 17:01:08 2018 +0100

    OSPF: Fix wrong LSA collisions detection
    
    In some circumstances (old LSA flushed but not acknowledged and not
    removed) origination of a new LSA may wrongly triggers LSA collision
    code. The patch fixes that.
    
    Thanks to Asbjorn Mikkelsen for the bugreport and @mdelagueronniere
    for the original patch.

commit 1cab2b4a7cffb7ad604dcbd200267733ef079973
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Dec 16 23:44:24 2018 +0100

    BGP: Extend 'next hop keep' and 'next hop self' options
    
    Extend 'next hop keep' and 'next hop self' options to have boolean values
    (enabled / disabled) and also values 'ibgp'/ 'ebgp' to restrict it to
    routes received from IBGP / EBGP. This allows to have it enabled by
    default in some cases, matches features of other implementations, and
    allows to handle some strange cases like EBGP border router with 'next
    hop self' also doing IBGP route reflecting.
    
    Change default of 'next hop keep' to enabled for route servers, and
    'ibgp' for route reflectors.
    
    Update documentation for these options.

commit 337165959c5a556d6556fb2acbba5e7f2b1c35a5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Dec 16 23:39:53 2018 +0100

    Nest: Fix handling of ECMP next hop flags
    
    Flag field was not copied when next hop was cached.

commit cfa6ff95695bcaff0c1046c63eb4a839c7a90cb7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Dec 16 22:48:13 2018 +0100

    Nest: fix bug in previous patches related to channel reconfiguration
    
    The patch d506263d... blocked adding channel during reconfiguration,
    that broke protocols which use the same functiona also during init.
    This patch fixes that.

commit cb311b441a6bbc02e88cd4a92e19044e2e95aac2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sat Dec 15 14:01:57 2018 +0100

    BGP: Better handling of non-matching AFI in nexthops

commit 3a2a3c7325b34923c4ecc465700708dd13e6ad73
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Dec 14 02:03:42 2018 +0100

    Doc: Rename code documentation files back to Doc

commit 1e0fccd1af54fdd4dbd79f6e7c5715478f83dea3
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Dec 14 01:53:32 2018 +0100

    Doc: Move root of code documentation to doc dir
    
    It reduces clutter in root and also avoid collision with doc dir on
    case-insensitive filesystems when name back to Doc.

commit 532116e7e33d80a79e176f043defffbfc2b8d06e
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 12 17:36:54 2018 +0100

    BGP: Do not prepend ASN in export from non-RS EBGP to RS EBGP
    
    When route is exported to regular EBGP, local ASN should be prepended to
    AS_PATH. When route is propagated by route server (between RS-marked
    EBGP peers), it should not change AS_PATH. Question is what to do in
    other cases (from non-RS EBGP, IBGP, or locally originated to RS EBGP).
    
    In 1.6.x, we did not prepend ASN in non-RS EBGP or IBGP to RS EBGP, but
    we prepended in local to RS EBGP.
    
    In 2.0.x, we changed that so only RS-EBGP to RS-EBGP is not prepended.
    We received some negative responses (thanks to heisenbug and Alexander
    Zubkov), we decided to change it back. One reason is that it is simple
    to modify the AS_PATH by filters, but not possible to un-modify
    changes done by BGP itself. Also, as 1.6.x behavior was not really
    consistent, the final behavior is that ASN is never prepended when
    exported to RS EBGP, like to IBGP.
    
    Note that i do not express an opinion about whether such configurations
    are even reasonable.

commit 6b5ad2066a8002bb0fd1dde58e6c0f1e43613aee
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 12 16:54:23 2018 +0100

    Doc: Document log rotation feature

commit 0f40405fc94fa253b5020e6603dc9ec7a02e13e7
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 12 16:38:30 2018 +0100

    Update RFC references
    
    Progdoc comments do not allow SGML tags

commit 9e92f357becf405643fa8c536734cccf2ae26da2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Dec 12 16:04:15 2018 +0100

    Doc: Document BGP import table option

commit 67d8665af58a14bdc26963f8910e738886edb373
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 11 13:52:30 2018 +0100

    Nest: Update statistics and rx-limit for Adj-RIB-In

commit 682d3f7de0905ca2e853844734cce7ff65f7d77d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Thu Sep 27 22:57:55 2018 +0200

    BGP: implement Adj-RIB-In
    
    The patch implements optional internal import table to a channel and
    hooks it to BGP so it can be used as Adj-RIB-In. When enabled, all
    received (pre-filtered) routes are stored there and import filters can
    be re-evaluated without explicit route refresh. An import table can be
    examined using e.g. 'show route import table bgp1.ipv4'.

commit 01fd00f5ed9298ab5829403cd7a8a9ba22bcc96a
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 11 18:43:58 2018 +0100

    Doc: Fix typo in previous LinuxDoc change

commit d506263da713673f95bc17aaedceebaaad03580d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 11 17:57:14 2018 +0100

    Nest: Forbid adding channels during reconfiguration
    
    When a new channel is found during reconfiguration, do force restart
    of the protocol, like with any other un-reconfigurable change.
    
    The old behavior was that the new channel was added but remained in down
    state, even if the protocol was up, so a manual protocol restart was
    often necessary.
    
    In the future this should be improved such that a reconfigurable
    channel addition (e.g. direct) is accepted and channel is started,
    while an un-reconfigurable addition forces protocol restart.

commit baeacdcfd3ce30b3fa89ebdd4e53c60c38c26c31
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Dec 10 02:11:42 2018 +0100

    OSPF: Fix reconfiguration of vlinks
    
    Fix crash during reconfiguration of OSPF config with vlinks. When vlink
    is reconfigured, a generic iface-reconfiguration code is used, which in
    one place supposes that it is running on a regular iface.
    
    Thanks to Cybertinus for a bugreport.

commit 9a5ef043c11ad9fba00557dedcc0d7ae0d2794e9
Merge: 0e492063 265419a3
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Thu Dec 6 09:55:34 2018 +0100

    Merge branch 'mq-custom' into int-new

commit 265419a3695b9a5c0a01d9fffc60f66fea8bee13
Author: Maria Matejka <mq@jmq.cz>
Date:   Wed Nov 21 20:37:11 2018 +0100

    Custom route attributes
    
    For local route marking purposes, local custom route attributes may be
    defined. These attributes are seamlessly stripped after export filter to
    every real protocol like Kernel, BGP or OSPF, they however pass through
    pipes. We currently allow at most 256 custom attributes.
    
    This should be much faster than currently used bgp communities
    for marking routes.

commit 0e4920632aa30dab4fbfb0530bce5a959e7a7675
Author: Robert Scheck <robert@fedoraproject.org>
Date:   Tue Dec 4 18:14:04 2018 +0100

    Doc: Allow overriding $SGML_CATALOG_FILES using distribution specific paths

commit f26bf60fb58bc975d510a9fff3adb76817ddb624
Author: Robert Scheck <robert@fedoraproject.org>
Date:   Tue Dec 4 18:11:42 2018 +0100

    Doc: Add alternative path for SGML ISO entities 8879.1986 to $SGML_CATALOG_FILES
    
    The existing paths are valid for Debian, alternative paths are necessary
    for Fedora and RHEL/CentOS.

commit 3fda08e40532245ba69e14cdac0623a138b939f9
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Dec 4 16:55:25 2018 +0100

    Unix: Change debugging options
    
    The old behavior was that enabling debugging did many nontrivial changes
    in BIRD behavior. The patch changes it that these changes are generally
    independent. Compiling with --enable-debug now just enables compile-time
    debug macros, but do not automatically activate debug mode (-d) nor local
    mode (-l). Debug mode with output to file (-D) do not force foreground
    mode (-f), therefore there is no need for backgroud option (-b), which is
    removed. Also fixes a bug when the default log target in -D mode was
    stderr instead of given debug file.

commit 0642fb4d456fe12e1bbeb2ffc2149433f228c02e
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Tue Nov 27 08:49:31 2018 +0100

    Hash: mem_hash doesn't modify the memory, declared constant

commit d73c4ac869048e60276c5e568450c7342bc0bc8a
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Thu Nov 1 12:17:49 2018 +0100

    Route table max hash size raised to 2^24.
    
    This is still OK for everybody to fit into RAM and also probably enough
    to keep a little collision rate for full BGP table.

commit 84661bf6da683d70e6e5e0e490d95abaf91b470b
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Tue Oct 30 15:25:32 2018 +0100

    Changed IPv4 hash function to simple multiplication.

commit 14375237f6901a926d59cc54870cf44ed2a61d20
Author: Jan Maria Matejka <mq@ucw.cz>
Date:   Wed Feb 14 13:42:53 2018 +0100

    Terminology cleanup: The import_control hook is now called preexport.
    
    Once upon a time, far far away, there were the old Bird developers
    discussing what direction of route flow shall be called import and
    export. They decided to say "import to protocol" and "export to table"
    when speaking about a protocol. When speaking about a table, they
    spoke about "importing to table" and "exporting to protocol".
    
    The latter terminology was adopted in configuration, then also the
    bird CLI in commit ea2ae6dd0 started to use it (in year 2009). Now
    it's 2018 and the terminology is the latter. Import is from protocol to
    table, export is from table to protocol. Anyway, there was still an
    import_control hook which executed right before route export.
    
    One thing is funny. There are two commits in April 1999 with just two
    minutes between them. The older announces the final settlement
    on config terminology, the newer uses the other definition. Let's see
    their commit messages as the git-log tool shows them (the newer first):
    
        commit 9e0e485e50ea74c4f1c5cb65bdfe6ce819c2cee2
        Author: Martin Mares <mj@ucw.cz>
        Date:   Mon Apr 5 20:17:59 1999 +0000
    
            Added some new protocol hooks (look at the comments for better explanation):
    
                    make_tmp_attrs          Convert inline attributes to ea_list
                    store_tmp_attrs         Convert ea_list to inline attributes
                    import_control          Pre-import decisions
    
        commit 5056c559c4eb253a4eee10cf35b694faec5265eb
        Author: Martin Mares <mj@ucw.cz>
        Date:   Mon Apr 5 20:15:31 1999 +0000
    
            Changed syntax of attaching filters to protocols to hopefully the final
            version:
    
                    EXPORT <filter-spec>    for outbound routes (i.e., those announced
                                            by BIRD to the rest of the world).
                    IMPORT <filter-spec>    for inbound routes (i.e., those imported
                                            by BIRD from the rest of the world).
    
            where <filter-spec> is one of:
    
                    ALL                     pass all routes
                    NONE                    drop all routes
                    FILTER <name>           use named filter
                    FILTER { <filter> }     use explicitly defined filter
    
            For all protocols, the default is IMPORT ALL, EXPORT NONE. This includes
            the kernel protocol, so that you need to add EXPORT ALL to get the previous
            configuration of kernel syncer (as usually, see doc/bird.conf.example for
            a bird.conf example :)).
    
    Let's say RIP to this almost 19-years-old inconsistency. For now, if you
    import a route, it is always from protocol to table. If you export a
    route, it is always from table to protocol.
    
    And they lived happily ever after.

commit e2ae08694e45b2a127c9d741e41dee4b14c2964d
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 28 16:43:17 2018 +0100

    Nest: Do not hard-reset interface when preferred address is changed
    
    Modify protocols to use preferred address change notification instead on
    depending on hard-reset of interfaces in that case, and remove hard-reset
    in that case. This avoids issue when e.g. IPv6 protocol restarts
    interface when IPv4 preferred address changed (as hard-reset is
    unavoidable and common for whole iface).
    
    The patch also fixes a bug when removing last address does not send
    preferred address change notification.

commit 66934aceff0e5299719177782bcbf151f8030591
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 21 16:30:22 2018 +0100

    Autoconf: Minor cleanup

commit fc1b933304c325775169d5241ce1ac5ae3266680
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 21 16:00:22 2018 +0100

    MRT documentation

commit 863ecfc78538657e51f1ec67441aec32261aa405
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 20 17:38:19 2018 +0100

    The MRT protocol
    
    The new MRT protocol is responsible for periodic RIB table dumps in the
    MRT format (RFC 6396). Also the existing code for BGP4MP MRT dumps is
    refactored and splitted between BGP to MRT protocols, will be more
    integrated into MRT in the future.
    
    Example:
    
    protocol mrt {
            table "*";
            filename "%N_%F_%T.mrt";
            period 60;
    }
    
    It is partially based on the old MRT code from Pavel Tvrdik.

commit 6712e77271fb3cb4a3c48cd7b027b39c5cea00a2
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Wed Nov 14 17:16:05 2018 +0100

    Unix: Implement log file size limit / log rotation
    
    Allow to specify log file size limit and ensure that log file is rotated
    to secondary name to avoid exceeding of log size limit.
    
    The patch also fixes a bug related to keeping old fds open after
    reconfiguration and using old fds after 'configure undo'.

commit c68ba7d093e1fcf01fceb341438fc5dc95f93ac5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Tue Nov 13 18:13:11 2018 +0100

    Unix: Refactor tracked files
    
    We need access to resource in order to free it.

commit d0b4597842ba1f65e5280529fca243ce5b5043fa
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Sun Nov 18 01:22:09 2018 +0100

    Configure: Use standard --runstatedir option
    
    Newer Autoconf defines --runstatedir option for setting directory for
    run-time variable data. Use it instead our old --with-runtimedir.

commit f2d8e6801e88a84b1e57da72d078d7569598a5f5
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 5 22:03:21 2018 +0100

    Filter: Make ifname attribute modifiable
    
    Allow to change an interface associated with a route by setting
    ifname attribute. It will also change the route to a direct one.

commit 69b2f63d9a477ab5d083773e16ca15ed2e570144
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Mon Nov 5 13:56:59 2018 +0100

    Nest: Fix crash in rta_show() for RPKI and Babel routes
    
    Some new route source values did not have associated string
    in rta_show(), which might caused crash in some cases.

commit e19d08055a4614f03e51ee72617be10946ce7919
Author: Ondrej Zajicek (work) <santiago@crfreenet.org>
Date:   Fri Oct 26 19:11:33 2018 +0200

    BGP: Fix VRF for listening socket
    
    Listening socket should be bound to specified interface and VRF.
    
    Thanks to Alexander Zubkov for the bugreport.

commit 0ac9cb2c1f6592290e025f61ccd0fef0dc09de46
